<?php

 // THIS FILE IS PART OF WEBMATIC3 (Webmatic cube)
 // www.valarsoft.com

 defined('WM3_cEXEC') or die('Denied');

 class wm3Chatroom
  {

   function __construct() { }

   public static function getChatroomFieldsArray()
    {
     return array('chatroomID','name','topic','visibility','enabled','languageID','ts');
    }

   public static function getChatroomSentenceFieldsArray()
    {
     return array('sentenceID','chatroomID','userID','nickname','sentence','enabled','languageID','ts');
    }

   public static function executeHomeAction($w3,$pageID)
    {
     // Chat page content
     switch($w3->getAction())
      {
       case WM3_cACTION_SHOW_FAQ:
        {
         return wm3Faq::getFaqList($w3,0,false);
         break;
        }
       case WM3_cACTION_SHOW_SINGLE_FAQ:
        {
         return wm3Faq::renderFaq($w3);
         break;
        }
       case WM3_cACTION_ADD_FAQ:
        {
         return "TODO";
         break;
        }
       default:
        {
         return wm3Chatroom::renderChatroom($w3);
        }
      }
    }

   public static function renderChatroom($w3,$error = 0)
    {
     // Render chatroom page (home side)
     $_STYLE['head'] = "class=\"listOdd\"";
	 $_STYLE['body'] = "class=\"listEven\"";
	 $_STYLE['foot'] = "class=\"listOdd\"";
	 $_FIELD['nickname'] = wm3User::getUserLogin($w3->getAuthenticateAdminUserID());
	 if($_FIELD['nickname']) $disabled = "disabled"; else $disabled = "";
     require(WM3_cPATH_INCLUDE."home_chatroom_form.inc");
     return $admin_content;
    }

   public static function renderChatroomSentenceList($w3,$currentID = 0,$admin = false)
    {
     // Get chatrooms sentences list (home side)

     // Prepare variables to create the list
     //$allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_FORUMS); // Used to enable admin buttons in home stage
	 $chatroomID = $w3->getVariable('chatroomID','get');
	 $userID     = $w3->getAuthenticateAdminUserID();
	 $join_ts    = wm3Session::getChatroomSessionJoinTS($w3);
	 if(!$userID) $query_filter = " AND ".WM3_cCONFIG_DB_PREFIX."_chatrooms.visibility = '".WM3_cCHATROOM_VISIBILITY_PUBLIC."'";
	 else         $query_filter = "";
     $width_avatar = 0; $columns = 2; $buttons = 0;
     //$base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     //if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_MESSAGES;
     $id_link = "";

     // Do the query and take the total items number
	 $order_by = " ORDER BY ".WM3_cCONFIG_DB_PREFIX."_chatrooms_sentences.ts DESC";
     $query = "SELECT ".WM3_cCONFIG_DB_PREFIX."_chatrooms_sentences.*,
	                  ".WM3_cCONFIG_DB_PREFIX."_chatrooms.*
	           FROM ".WM3_cCONFIG_DB_PREFIX."_chatrooms_sentences,
			        ".WM3_cCONFIG_DB_PREFIX."_chatrooms
			   WHERE ".WM3_cCONFIG_DB_PREFIX."_chatrooms.chatroomID = ".WM3_cCONFIG_DB_PREFIX."_chatrooms_sentences.chatroomID
			     AND ".WM3_cCONFIG_DB_PREFIX."_chatrooms_sentences.chatroomID = '$chatroomID'
				 AND ".WM3_cCONFIG_DB_PREFIX."_chatrooms.enabled = '".WM3_cENABLED."'
				 AND ".WM3_cCONFIG_DB_PREFIX."_chatrooms_sentences.ts >= '$join_ts'
               $query_filter";
     $rs = wm3Sql::sqlQuery($query.$order_by); // Do the query
     $total_items = mysql_num_rows($rs);

     // Create list header
     $_CONTENTS = array();
 	 $chatroom_name  = wm3Chatroom::getChatroomName($chatroomID);
	 $chatroom_topic = wm3Chatroom::getChatroomTopic($chatroomID);
	 $visibility     = wm3Chatroom::getChatroomVisibility($chatroomID);
	 if($userID) $nickname = wm3User::getUserLogin($userID);
	 else        $nickname = $w3->getVariable('nickname','get');
	 $content = "\"$nickname\" ".$w3->getWord(1432).": $chatroom_name<br>Topic: <i>$chatroom_topic</i>";
	 array_push($_CONTENTS,$content);
     $str = wm3Section::makeHeaderList($w3,$_CONTENTS,$columns);

     // Create list caption

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0) return $str.wm3Section::makeEmptyItemsList($w3,$columns,-1);

     // Create list items
     $p = 0;
     while($row = mysql_fetch_object($rs))
      {
       $_CONTENTS = array(); $_WIDTHS = array();
       //$link = $base_link.$id_link.$extra_link."&chatroomID=$row->chatroomID";
	   $nickname = wm3User::getUserLogin($row->userID); if(!$nickname) $nickname = $row->nickname;
	   $avatar   = "<img src=\"".wm3User::getAvatar($row->userID)."\" width=\"36\" height=\"36\"><br>$nickname";
	   $sentence = wm3Util::renderContent($w3,$row->sentence,WM3_cRENDER_MODE_BB_CODE);
       //if($allowed) $allowed_link = $base_allowed_link."&chatroomID=$row->chatroomID";
       array_push($_CONTENTS,$avatar,$sentence); array_push($_WIDTHS,$width_avatar,100);
       if($admin)
        {
         $lang_flag = "<img src=\"".WM3_cPATH_DATA.wm3Language::getFlag($row->languageID)."\" width=\"19\" height=\"13\" align=\"middle\">";
		 $info = $lang_flag.$visibility;
         array_push($_CONTENTS,$info); array_push($_WIDTHS,20);
         // Buttons
         //array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_EDIT_CHATROOM,"action_edit.png",$w3->getWord(178)));
         //array_push($_CONTENTS,wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DELETE_CHATROOM,"action_delete.png",$w3->getWord(179),$w3->getWord(1452)));
        }
       else
        {
         //if($allowed) array_push($_CONTENTS,wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_CHATROOM,"action_edit.png",$w3->getWord(178)));
        }
       $str .= wm3Section::makeItemList($w3,$p,$_WIDTHS,$_CONTENTS,$row->chatroomID==$currentID);
       $p++;
      }

     // Create list bottom
     $str .= wm3Section::makeBottomList($w3,$columns,"");

     return $str;
    }

   public static function renderChatroomUserList($w3,$currentID = 0,$admin = false)
    {
     // Get chatrooms current users list (home side)

     // Prepare variables to create the list
     //$allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_FORUMS); // Used to enable admin buttons in home stage
	 $chatroomID = $w3->getVariable('chatroomID','get');
	 $userID     = $w3->getAuthenticateAdminUserID();	
  	 if(!$userID) $query_filter = " AND ".WM3_cCONFIG_DB_PREFIX."_chatrooms.visibility = '".WM3_cCHATROOM_VISIBILITY_PUBLIC."'";
	 else         $query_filter = "";
     $width_avatar = 0; $columns = 2; $buttons = 0;
     //$base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     //if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_MESSAGES;
     $id_link = "";

     // Do the query and take the total items number
	 $order_by = " ORDER BY ".WM3_cCONFIG_DB_PREFIX."_sessions_chatrooms.userID DESC";
     $query = "SELECT ".WM3_cCONFIG_DB_PREFIX."_sessions_chatrooms.*,
	                  ".WM3_cCONFIG_DB_PREFIX."_chatrooms.*
	           FROM ".WM3_cCONFIG_DB_PREFIX."_sessions_chatrooms,
			        ".WM3_cCONFIG_DB_PREFIX."_chatrooms
			   WHERE ".WM3_cCONFIG_DB_PREFIX."_chatrooms.chatroomID = ".WM3_cCONFIG_DB_PREFIX."_sessions_chatrooms.chatroomID
			     AND ".WM3_cCONFIG_DB_PREFIX."_sessions_chatrooms.chatroomID = '$chatroomID'
				 AND ".WM3_cCONFIG_DB_PREFIX."_chatrooms.enabled = '".WM3_cENABLED."'
               $query_filter";
     $rs = wm3Sql::sqlQuery($query.$order_by); // Do the query
     $total_items = mysql_num_rows($rs);

     // Create list header
     $_CONTENTS = array();
 	 $chatroom_name  = wm3Chatroom::getChatroomName($chatroomID);
	 $visibility     = wm3Chatroom::getChatroomVisibility($chatroomID);
	 $content        = $chatroom_name."<br><i>($total_items users)</i>";
	 array_push($_CONTENTS,$content);
     $str = wm3Section::makeHeaderList($w3,$_CONTENTS,$columns,"");

     // Create list caption

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0) return $str.wm3Section::makeEmptyItemsList($w3,$columns,-1);

     // Create list items
     $p = 0;
     while($row = mysql_fetch_object($rs))
      {
       $_CONTENTS = array(); $_WIDTHS = array();
       //$link = $base_link.$id_link.$extra_link."&chatroomID=$row->chatroomID";
	   if($row->userID) $nickname = wm3User::getUserLogin($row->userID);
	   else             $nickname = $row->nickname."<i>(".$row->ip.")</i>";
	   $avatar   = "<img src=\"".wm3User::getAvatar($row->userID)."\" width=\"16\" height=\"16\">";
       //if($allowed) $allowed_link = $base_allowed_link."&chatroomID=$row->chatroomID";
       array_push($_CONTENTS,$avatar,$nickname); array_push($_WIDTHS,$width_avatar,100);
       if($admin)
        {
         $lang_flag = "<img src=\"".WM3_cPATH_DATA.wm3Language::getFlag($row->languageID)."\" width=\"19\" height=\"13\" align=\"middle\">";
		 $info = $lang_flag.$visibility;
         array_push($_CONTENTS,$info); array_push($_WIDTHS,20);
         // Buttons
         //array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_EDIT_CHATROOM,"action_edit.png",$w3->getWord(178)));
         //array_push($_CONTENTS,wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DELETE_CHATROOM,"action_delete.png",$w3->getWord(179),$w3->getWord(1452)));
        }
       else
        {
         //if($allowed) array_push($_CONTENTS,wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_CHATROOM,"action_edit.png",$w3->getWord(178)));
        }
       $str .= wm3Section::makeItemList($w3,$p,$_WIDTHS,$_CONTENTS,$row->chatroomID==$currentID);
       $p++;
      }

     // Create list bottom
     $str .= wm3Section::makeBottomList($w3,$columns,"");

	 return $str;
    }

   public static function getChatroomList($w3,$currentID = 0,$admin = true)
    {
     // Get Chatrooms list (admin side)

     // Prepare variables to create the list
     $max_page_items = 12;
     $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_FORUMS); // Used to enable admin buttons in home stage
     $pg = $w3->getVariable('pg','both');
     $filter = $w3->getVariable('filter','both'); // Search field
     if($filter)
      {
       $search_link  = "&filter=$filter";
       $query_filter = "WHERE topic LIKE '%$filter%'";
      }
     else { $search_link = $query_filter = ""; }
     if($admin)
      {
       $width_name = 80;
	   $search_form_link  = WM3_cCONFIG_ADMIN_FILE."?action=".WM3_cACTION_SHOW_CHATROOM;
       $columns = 5; $buttons = 3;
      }
     else
      {
       $width_name = 100;
       if($query_filter) $query_filter .= " AND "; else $query_filter .= " WHERE ";
       $query_filter .= "enabled='".WM3_cENABLED."' AND languageID='".$w3->getHomeLanguage()."'";
       if($allowed) { $columns = 2; $buttons = 1; } else { $columns = 1; $buttons = 0; }
      }
     $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_MESSAGES;
     $id_link = "";

     // Do the query and take the total items number
	 $order_by = " ORDER BY ".WM3_cCONFIG_DB_PREFIX."_chatrooms.name DESC";
     $query = "SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_chatrooms
                        $query_filter";
     $rs = wm3Sql::sqlQuery($query.$order_by); // Do the query without "limit"
     $total_items = mysql_num_rows($rs);
     if($total_items % $max_page_items == 0 && $pg == (int)($total_items / $max_page_items)) $pg--;
	 if($currentID)
	  {
	   $position = wm3Sql::getRSPosition($rs,'chatroomID',$currentID);
	   $pg = (int)($position / $max_page_items);
      }
	 if($pg) $extra_link = "&pg=$pg"; else $extra_link = "";
     if($total_items != 0 && $admin) $rs = wm3Sql::sqlQuery($query.$order_by." LIMIT ".($pg*$max_page_items).",$max_page_items");

     // Create list header
     $_CONTENTS = array(); $search_form = "";
     if($admin)
      {
       require(WM3_cPATH_INCLUDE."admin_chatroom_search_form.inc");
       array_push($_CONTENTS,$w3->getWord(1444));
      }
     $str = wm3Section::makeHeaderList($w3,$_CONTENTS,$columns,$search_form);

     // Create list caption
     if($admin) $str .= wm3Section::makeCaptionList($w3,array($width_name,20,0),array(1439,1671),$buttons);

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0) return $str.wm3Section::makeEmptyItemsList($w3,$columns,593);

     // Create list items
     $p = 0;
     while($row = mysql_fetch_object($rs))
      {
       $_CONTENTS = array(); $_WIDTHS = array();
       $link = $base_link.$id_link.$extra_link."&chatroomID=$row->chatroomID";
       if($allowed) $allowed_link = $base_allowed_link."&chatroomID=$row->chatroomID";
	   $name = "<b>".$row->name."</b><br>".$row->topic;
       array_push($_CONTENTS,$name); array_push($_WIDTHS,$width_name);
       if($admin)
        {
         $lang_flag = "<img src=\"".WM3_cPATH_DATA.wm3Language::getFlag($row->languageID)."\" width=\"19\" height=\"13\" align=\"middle\">";
		 if($row->visibility==1) $visibility = " (".$w3->getWord(1441)." <img src=\"".WM3_cPATH_DATA."misc_lock_open.png\" width=\"13\" height=\"11\">)";
		 else                    $visibility = " (".$w3->getWord(1442)." <img src=\"".WM3_cPATH_DATA."misc_lock_close.png\" width=\"13\" height=\"11\">)";
		 $info = $lang_flag.$visibility;
         array_push($_CONTENTS,$info); array_push($_WIDTHS,20);
         // Buttons
         if($row->enabled) array_push($_CONTENTS,wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DISABLE_CHATROOM,"action_disable.png",$w3->getWord(180)));
         else              array_push($_CONTENTS,wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_ENABLE_CHATROOM,"action_enable.png",$w3->getWord(181)));
         array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_EDIT_CHATROOM,"action_edit.png",$w3->getWord(178)));
         array_push($_CONTENTS,wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DELETE_CHATROOM,"action_delete.png",$w3->getWord(179),$w3->getWord(1452)));
        }
       else
        {
         if($allowed) array_push($_CONTENTS,wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_CHATROOM,"action_edit.png",$w3->getWord(178)));
        }
       $str .= wm3Section::makeItemList($w3,$p,$_WIDTHS,$_CONTENTS,$row->chatroomID==$currentID);
       $p++;
      }

     // Create list bottom
     $bottom_content = "";
     if($total_items > $max_page_items)
      {
       if($admin) $bottom_content = wm3Util::makePagesNavigator($total_items,$max_page_items,$pg,$base_link."&action=".WM3_cACTION_SHOW_CHATROOM.$id_link.$search_link);
       else       $bottom_content = wm3Util::makePagesNavigator($total_items,$max_page_items,$pg,$base_link.$page_link."&action=".WM3_cACTION_SHOW_CHATROOM.$id_link.$search_link);
      }
     $str .= wm3Section::makeBottomList($w3,$columns,$bottom_content);

     return $str;
    }

   public static function checkChatroomError($w3)
    {
     // Check form invalid inputs
     $_FIELD = webmatic3::getPostValueArray(wm3Chatroom::getChatroomFieldsArray());
     if(!$_FIELD['name']) return 1;
     return 0;
    }

   public static function addChatroom($w3,$error = 0)
    {
     // Take variables value and set correct form style    
     $_STYLE = wm3Skin::getFormStyleArray(wm3Chatroom::getChatroomFieldsArray());
     $_FIELD = webmatic3::getPostValueArray(wm3Chatroom::getChatroomFieldsArray());
     // Fields for paging default value
     $pg = $filter = ""; 
     switch($error)
      {
       case 1: // Empty name 
        {
         $_STYLE['name']           = "class=\"adminFormError\"";
         $_STYLE['adminFormTitle'] = "class=\"adminFormTitleError\"";
         $form_title = $w3->getWord(1449);
         break;
        }
       default:
        {
         // Default values for the form
         $_FIELD['enabled']   = WM3_cENABLED;

         $_STYLE['adminFormTitle'] = "class=\"adminFormTitle\"";
         $form_title = $w3->getWord(1435);
       	}
      }
     $next_action       = WM3_cACTION_SAVE_CHATROOM;
     $next_action_label = $w3->getWord(191);
     require(WM3_cPATH_INCLUDE."admin_chatroom_form.inc");
     return $admin_content;
    }

   public static function editChatroom($w3,$error = 0)
    {
     // Take variables value from db and set correct form style
     if(!$error)
      {
       $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_chatrooms
                               WHERE chatroomID = '".$w3->getVariable('chatroomID','get')."'");
       $row = mysql_fetch_object($rs);
	   if(!$row) return wm3Section::makeNotFoundItem($w3);
       $_FIELD = webmatic3::getRowValueArray(wm3Chatroom::getChatroomFieldsArray(),$row);
       // Default value for fields not in $row object
      }
     else $_FIELD = webmatic3::getPostValueArray(wm3Chatroom::getChatroomFieldsArray());

     $_STYLE = wm3Skin::getFormStyleArray(wm3Chatroom::getChatroomFieldsArray());
     $pg     = $w3->getVariable('pg','both');
     $filter = $w3->getVariable('filter','both');
     switch($error)
      {
       case 1: // No name
        {
         $_STYLE['name']        = "class=\"adminFormError\"";
         $_STYLE['adminFormTitle'] = "class=\"adminFormTitleError\"";
         $form_title = "Error $error";//$w3->getWord(29);
         break;
        }
       default:
        {
         $_STYLE['adminFormTitle'] = "class=\"adminFormTitle\"";
         $form_title = $w3->getWord(1450);
       	}
      }
     $next_action       = WM3_cACTION_UPDATE_CHATROOM;
     $next_action_label = $w3->getWord(29);
     require(WM3_cPATH_INCLUDE."admin_chatroom_form.inc");
     return $admin_content;
    }

   public static function saveChatroom($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Chatroom::getChatroomFieldsArray(),WM3_cQUOTE_DB);
     $_FIELD['ts'] = time();
     wm3Sql::saveAllTableFields('_chatrooms',$_FIELD);
     return wm3Sql::getLastInsertID();
    }

   public static function updateChatroom($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Chatroom::getChatroomFieldsArray(),WM3_cQUOTE_DB);
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_chatrooms
                       SET   name       = '".$_FIELD['name']."',
					         topic      = '".$_FIELD['topic']."',
                             visibility = '".$_FIELD['visibility']."',
						     enabled    = '".$_FIELD['enabled']."',
                             languageID = '".$_FIELD['languageID']."'
                       WHERE chatroomID = '".$_FIELD['chatroomID']."'");
     return $_FIELD['chatroomID'];
    }

   public static function saveChatroomSentence($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Chatroom::getChatroomSentenceFieldsArray(),WM3_cQUOTE_DB);

	 $chatroomID = $w3->getVariable('chatroomID','get');
	 $userID     = $w3->getAuthenticateAdminUserID();
     if(!wm3Chatroom::isChatroomAllowed($w3)) return 0;

	 $sentence = $w3->getVariable('sentence','get'); // Take sentence from get
	 $nickname = "";//TODO for anonymous;
	 $_FIELD['chatroomID'] = $chatroomID;
	 $_FIELD['userID']     = $userID;
	 if($userID) $_FIELD['nickname'] = ""; else $_FIELD['nickname'] = $w3->getVariable('nickname','get');
	 $_FIELD['sentence']   = $sentence;
	 $_FIELD['enabled']    = WM3_cENABLED;
     $_FIELD['ts']         = time();
     wm3Sql::saveAllTableFields('_chatrooms_sentences',$_FIELD);
     return wm3Sql::getLastInsertID();
    }

   public static function joinChatroom($w3)
    {
	 // Try to join an user in the chatroomID
	 $chatroomID = $w3->getVariable('chatroomID','get');
	 $userID     = $w3->getAuthenticateAdminUserID();

	 if(!wm3Chatroom::isChatroomAllowed($w3)) // Private chatroom
	  {
       $_CONTENTS = array($w3->getWord(1438));
       $str = wm3Section::makeHeaderList($w3,$_CONTENTS,1);
       return $str.wm3Section::makeEmptyItemsList($w3,1,1443);
      }
     if(!wm3Session::chatroomSessionExists($w3))
	  {
	   wm3Session::chatroomSessionCreate($w3);
      }
	 else // Update chatroom session (when join a chatroom and the session already exists)
	  {
       wm3Session::chatroomSessionUpdate($w3,true);
	  }
     $_CONTENTS = array();
 	 $chatroom_name  = wm3Chatroom::getChatroomName($chatroomID);
	 $chatroom_topic = wm3Chatroom::getChatroomTopic($chatroomID);
	 $visibility     = wm3Chatroom::getChatroomVisibility($chatroomID);
	 if($userID) $nickname = wm3User::getUserLogin($userID);
	 else        $nickname = $w3->getVariable('nickname','get');
	 $content = "\"$nickname\" ".$w3->getWord(1432).": $chatroom_name<br>Topic: <i>$chatroom_topic</i>";
	 array_push($_CONTENTS,$content);
     $str = wm3Section::makeHeaderList($w3,$_CONTENTS,1);
	 return $str.wm3Section::makeEmptyItemsList($w3,1,-1);	   
    }

   public static function selectChatroom($w3,$name,$chatroomID,$id = '')
    {
     // Make chatrooms select
     $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_chatrooms");
     if($id) $str = "<select id=\"$id\" name=\"$name\">";
	 else    $str = "<select name=\"$name\">";
     while($row = mysql_fetch_object($rs))
      {
	   if($row->visibility == WM3_cCHATROOM_VISIBILITY_PRIVATE) $visibility = " (".$w3->getWord(1442).")";
	   else                                                     $visibility = " (".$w3->getWord(1441).")";
       if($row->chatroomID == $chatroomID) $str .= wm3Util::inputOption($row->name.$visibility,$row->chatroomID,"selected");
       else                                $str .= wm3Util::inputOption($row->name.$visibility,$row->chatroomID);
      }
     $str .= "</select>";
     return $str;
    }

   public static function selectChatroomVisibility($name,$value,$w3)
    {
     // Make chatroom visibility select
	 $_LABELS = array($w3->getWord(1437),$w3->getWord(1438));
	 $_VALUES = array(WM3_cCHATROOM_VISIBILITY_PUBLIC,WM3_cCHATROOM_VISIBILITY_PRIVATE);
     return wm3Util::selectArray($name,$_LABELS,$_VALUES,$value);
    }

   public static function selectChatroomSentenceMode($name,$value,$w3)
    {
     // Make chatroom sentence mode select
	 $_LABELS = array($w3->getWord(1427),$w3->getWord(1428),$w3->getWord(1429));
	 $_VALUES = array(1,2,3);//TODO costanti
     return wm3Util::selectArray($name,$_LABELS,$_VALUES,$value);
    }

   public static function disableChatroom($chatroomID)
    {
	 wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_chatrooms SET enabled = '".WM3_cDISABLED."' WHERE chatroomID = '$chatroomID'");
	}

   public static function enableChatroom($chatroomID) 
    {
	 wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_chatrooms SET enabled = '".WM3_cENABLED."' WHERE chatroomID = '$chatroomID'");
    }
   
   public static function deleteChatroom($chatroomID) 
    {
	 wm3Sql::sqlQuery("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_chatrooms WHERE chatroomID = '$chatroomID'");
	}

   public static function getChatroomName($chatroomID)
    {
     $rs = wm3Sql::sqlQuery("SELECT name FROM ".WM3_cCONFIG_DB_PREFIX."_chatrooms
                             WHERE chatroomID = '$chatroomID'");
     if(mysql_num_rows($rs) != 1) return "";
     $row = mysql_fetch_object($rs);
     return $row->name;
    }

   public static function getChatroomTopic($chatroomID)
    {
     $rs = wm3Sql::sqlQuery("SELECT topic FROM ".WM3_cCONFIG_DB_PREFIX."_chatrooms
                             WHERE chatroomID = '$chatroomID'");
     if(mysql_num_rows($rs) != 1) return "";
     $row = mysql_fetch_object($rs);
     return $row->topic;
    }

   public static function getChatroomVisibility($chatroomID)
    {
     $rs = wm3Sql::sqlQuery("SELECT visibility FROM ".WM3_cCONFIG_DB_PREFIX."_chatrooms
                             WHERE chatroomID = '$chatroomID'");
     if(mysql_num_rows($rs) != 1) return WM3_cCHATROOM_VISIBILITY_PRIVATE;
     $row = mysql_fetch_object($rs);
     return $row->visibility;
    }

   public static function isChatroomAllowed($w3)
    {
	 $chatroomID = $w3->getVariable('chatroomID','get');
	 $userID     = $w3->getAuthenticateAdminUserID();
	 $visibility = wm3Chatroom::getChatroomVisibility($chatroomID);
  	 if(!$userID && $visibility == WM3_cCHATROOM_VISIBILITY_PRIVATE) return false;
     else return true;
    }

   public static function deleteChatroomExpiredSentences($w3)
    {
	 // Delete expired chatroom sentences
	 $chatroomID = $w3->getVariable('chatroomID','get');
	 if($chatroomID)
	  {
	   wm3Sql::sqlQuery("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_chatrooms_sentences
	                     WHERE chatroomID = '$chatroomID'
		                   AND ts < (SELECT MIN(join_ts) FROM ".WM3_cCONFIG_DB_PREFIX."_sessions_chatrooms WHERE chatroomID = '$chatroomID')");
	  }
     else
	  {
	   wm3Sql::sqlQuery("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_chatrooms_sentences
	                     WHERE ts < (SELECT MIN(join_ts) FROM ".WM3_cCONFIG_DB_PREFIX."_sessions_chatrooms)");
	  }

    }

  }

?>
