<?php

 // THIS FILE IS PART OF WEBMATIC3 (Webmatic cube)
 // www.valarsoft.com

 defined('WM3_cEXEC') or die('Denied');

 class wm3Faq extends wm3Section
  {

   function __construct() { }

   public static function getSectionParameters()
    {
     // Set the right parameters for faq section
     return array(
                  'allowed_section'           => WM3_cSECTION_FAQ,
                  'category_form'             => 'admin_faq_category_form.inc',
                  'search_form'               => 'admin_faq_search_form.inc',
                  'table_categories'          => '_faqs_categories',
                  'table_subcategories'       => '_faqs',
                  'table_subcategories_count' => '_faqs',
                  'action_save_category'      => WM3_cACTION_SAVE_FAQ_CATEGORY,
                  'action_update_category'    => WM3_cACTION_UPDATE_FAQ_CATEGORY,
                  'action_show_subcategory'   => WM3_cACTION_SHOW_FAQ,
                  'action_add_subcategory'    => WM3_cACTION_ADD_FAQ,
                  'action_disable_category'   => WM3_cACTION_DISABLE_FAQ_CATEGORY,
                  'action_enable_category'    => WM3_cACTION_ENABLE_FAQ_CATEGORY,
                  'action_edit_category'      => WM3_cACTION_EDIT_FAQ_CATEGORY,
                  'action_delete_category'    => WM3_cACTION_DELETE_FAQ_CATEGORY,
                  'action_search'             => WM3_cACTION_SHOW_FAQ,
                  'label_category_list_title' => 1672,
                  'label_subcategory_add'     => 1657,
                  'label_subcategories_count' => 1668);
    }

   public static function getFaqFieldsArray()
    {
     return array('faqID','question','categoryID','render_mode','answer','enabled','languageID','ts');
    }

   public static function executeHomeAction($w3,$pageID)
    {
     // Faq page content
     switch($w3->getAction())
      {
       case WM3_cACTION_SHOW_FAQ:
        {
         return wm3Faq::getFaqList($w3,0,false);
         break;
        }
       case WM3_cACTION_SHOW_SINGLE_FAQ:
        {
         return wm3Faq::renderFaq($w3);
         break;
        }
       case WM3_cACTION_ADD_FAQ:
        {
         return "TODO";
         break;
        }
       default:
        {
         return wm3Faq::getFaqCategoryList($w3,0,false);
        }
      }
    }

   public static function executeAdminAction($w3)
    {
     switch($w3->getAction())
      {
       case WM3_cACTION_ADD_FAQ_CATEGORY:
        {
         return wm3Faq::addFaqCategory($w3);
         break;
        }
       case WM3_cACTION_SAVE_FAQ_CATEGORY:
        {
         $error = wm3Faq::checkFaqCategoryError($w3);
         if(!$error)
          {
           $lastID = wm3Faq::saveFaqCategory($w3);
           // $msg= message saved... //TODO
           return wm3Faq::getFaqCategoryList($w3,$lastID);
          }
         else return wm3Faq::addFaqCategory($w3,$error);
         break;
        }
       case WM3_cACTION_EDIT_FAQ_CATEGORY:
        {
         return wm3Faq::editFaqCategory($w3);
         break;
        }
       case WM3_cACTION_UPDATE_FAQ_CATEGORY:
        {
         $error = wm3Faq::checkFaqCategoryError($w3);
         if(!$error)
          {
           $lastID = wm3Faq::updateFaqCategory($w3);
           // $msg= message udated... //TODO
           return wm3Faq::getFaqCategoryList($w3,$lastID);
          }
         else return wm3Faq::editFaqCategory($w3,$error);
         break;
        }
       case WM3_cACTION_DISABLE_FAQ_CATEGORY:
        {
         wm3Faq::disableFaqCategory($w3->getVariable('categoryID','get'));
         return wm3Faq::getFaqCategoryList($w3,$w3->getVariable('categoryID','get'));
         break;
        }
       case WM3_cACTION_ENABLE_FAQ_CATEGORY:
        {
         wm3Faq::enableFaqCategory($w3->getVariable('categoryID','get'));
         return wm3Faq::getFaqCategoryList($w3,$w3->getVariable('categoryID','get'));
         break;
        }
       case WM3_cACTION_DELETE_FAQ_CATEGORY:
        {
         wm3Faq::deleteFaqCategory($w3,$w3->getVariable('categoryID','get'));
         return wm3Faq::getFaqCategoryList($w3);
         break;
        }
       case WM3_cACTION_ADD_FAQ:
        {
         return wm3Faq::addFaq($w3);
         break;
        }
       case WM3_cACTION_SAVE_FAQ:
        {
		 wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_faqs            WRITE,
		                               ".WM3_cCONFIG_DB_PREFIX."_faqs_categories WRITE");
         $error = wm3Faq::checkFaqError($w3);
         if(!$error) {
                      $lastID = wm3Faq::saveFaq($w3);
                      wm3Sql::sqlQuery("UNLOCK TABLES");
                      return wm3Faq::getFaqList($w3,$lastID);
                     }
         else        {
			          wm3Sql::sqlQuery("UNLOCK TABLES");
			          return wm3Faq::addFaq($w3,$error);
	                 }
         break;
        }
       case WM3_cACTION_EDIT_FAQ:
        {
         return wm3Faq::editFaq($w3);
         break;
        }
       case WM3_cACTION_UPDATE_FAQ:
        {
		 wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_faqs            WRITE,
		                               ".WM3_cCONFIG_DB_PREFIX."_faqs_categories WRITE");
         $error = wm3Faq::checkFaqError($w3);
         if(!$error) {
                      $lastID = wm3Faq::updateFaq($w3);
                      wm3Sql::sqlQuery("UNLOCK TABLES");
                      return wm3Faq::getFaqList($w3,$lastID);
                     }
         else        {
			          wm3Sql::sqlQuery("UNLOCK TABLES");
			          return wm3Faq::editFaq($w3,$error);
				     }
         break;
        }
       case WM3_cACTION_DISABLE_FAQ:
        {
         wm3Faq::disableFaq($w3->getVariable('faqID','get'));
         return wm3Faq::getFaqList($w3,$w3->getVariable('faqID','get'));
         break;
        }
       case WM3_cACTION_ENABLE_FAQ:
        {
         wm3Faq::enableFaq($w3->getVariable('faqID','get'));
         return wm3Faq::getFaqList($w3,$w3->getVariable('faqID','get'));
         break;
        }
       case WM3_cACTION_DELETE_FAQ:
        {
         wm3Faq::deleteFaq($w3->getVariable('faqID','get'));
         return wm3Faq::getFaqList($w3);
         break;
        }
       case WM3_cACTION_SHOW_FAQ:
        {
         return wm3Faq::getFaqList($w3);
         break;
        }
       default:
        {
         return wm3Faq::getFaqCategoryList($w3);
        }
      }
    }

   public static function getFaqCategoryList($w3,$currentID = 0,$admin = true)
    {
	 return $w3->getSectionObj()->getCategoryList($w3,$currentID,$admin);
	}

   public static function checkFaqCategoryError($w3)
    {
     return $w3->getSectionObj()->checkCategoryError($w3);
    }

   public static function addFaqCategory($w3,$error = 0)
    {
     return $w3->getSectionObj()->addCategory($w3,$error);
    }

   public static function editFaqCategory($w3,$error = 0)
    {
     return $w3->getSectionObj()->editCategory($w3,$error);
    }

   public static function saveFaqCategory($w3)
    {
     return $w3->getSectionObj()->saveCategory($w3);
    }

   public static function updateFaqCategory($w3)
    {
     return $w3->getSectionObj()->updateCategory($w3);
    }

   public static function disableFaqCategory($categoryID)
    {
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_faqs_categories SET enabled = '".WM3_cDISABLED."' WHERE categoryID = '$categoryID'");
    }

   public static function enableFaqCategory($categoryID)
    {
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_faqs_categories SET enabled = '".WM3_cENABLED."' WHERE categoryID = '$categoryID'");
    }
   
   public static function deleteFaqCategory($w3,$categoryID)
    {
     $w3->getSectionObj()->deleteCategory($categoryID);
    }

   public static function selectFaqCategory($w3,$name,$categoryID,$all = false,$admin = true)
    {
     return $w3->getSectionObj()->selectCategory($w3,$name,$categoryID,$all,$admin);
    }

   public static function getFaqCategoryName($w3,$categoryID)
    {
     return $w3->getSectionObj()->getCategoryName($categoryID);
    }

   public static function getFaqList($w3,$currentID = 0,$admin = true)
    {
     // Get faq list (admin and home side)

     // Prepare variables to create the list
     $max_page_items = 12;
     $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_FAQ); // Used to enable admin buttons in home stage
     $categoryID = $w3->getVariable('categoryID','both');
     if($categoryID) $query_filter = " AND ".WM3_cCONFIG_DB_PREFIX."_faqs.categoryID = '$categoryID'"; else $query_filter = "";
     $filter = $w3->getVariable('filter','both'); // Search field
     $pg     = $w3->getVariable('pg','both');
     if($filter) {
     	          $search_link   = "&filter=$filter";
     	          $query_filter .= " AND (".WM3_cCONFIG_DB_PREFIX."_faqs.question LIKE '%$filter%' OR ".WM3_cCONFIG_DB_PREFIX."_faqs.answer LIKE '%$filter%')";
     	         }
     else        { if(!$categoryID) $query_filter =" AND 1=0"; $search_link = ""; }
     if($admin) {
                 $width_question = 70;
                 $search_form_link = WM3_cCONFIG_ADMIN_FILE."?action=".WM3_cACTION_SHOW_FAQ;
                 $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     	         $columns = 5; $buttons = 3;
     	        }
     else       {
                 $pageID = $w3->getVariable('pageID','get');
                 $page_link        = "&pageID=$pageID";
                 $search_form_link = WM3_cCONFIG_HOME_FILE."?action=".WM3_cACTION_SHOW_FAQ."$page_link";
                 $base_link        = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
                 $width_question = 100;
                 $query_filter .= " AND ".WM3_cCONFIG_DB_PREFIX."_faqs.enabled*".WM3_cCONFIG_DB_PREFIX."_faqs_categories.enabled='".WM3_cENABLED."' AND ".WM3_cCONFIG_DB_PREFIX."_faqs.languageID='".$w3->getHomeLanguage()."'";
     	         if($allowed) { $columns = 2; $buttons = 1; } else { $columns = 1; $buttons = 0; }
     	        }
     if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_FAQ;
     $id_link = "&categoryID=$categoryID";

     // Do the query and take the total items number
	 $order_by = " ORDER BY ".WM3_cCONFIG_DB_PREFIX."_faqs.question DESC";
     $query = "SELECT ".WM3_cCONFIG_DB_PREFIX."_faqs_categories.enabled,".WM3_cCONFIG_DB_PREFIX."_faqs.*
               FROM   ".WM3_cCONFIG_DB_PREFIX."_faqs_categories,".WM3_cCONFIG_DB_PREFIX."_faqs
               WHERE  ".WM3_cCONFIG_DB_PREFIX."_faqs_categories.categoryID=".WM3_cCONFIG_DB_PREFIX."_faqs.categoryID
               $query_filter";
     $rs = wm3Sql::sqlQuery($query.$order_by); // Do the query without "limit"
     $total_items = mysql_num_rows($rs);
     if($total_items % $max_page_items == 0 && $pg == (int)($total_items / $max_page_items)) $pg--;
	 if($currentID)
	  {
	   $position = wm3Sql::getRSPosition($rs,'faqID',$currentID);
	   $pg = (int)($position / $max_page_items);
      }
	 if($pg) $extra_link = "&pg=$pg"; else $extra_link = "";
     if($total_items != 0) $rs = wm3Sql::sqlQuery($query.$order_by." LIMIT ".($pg*$max_page_items).",$max_page_items");

     // Create list header
     $_CONTENTS = array();
     require(WM3_cPATH_INCLUDE."admin_faq_search_form.inc");
     if($admin) array_push($_CONTENTS,"<a href=\"$base_link\">".$w3->getWord(1672)."</a>");
     else       array_push($_CONTENTS,"<a href=\"$base_link$page_link\">".$w3->getWord(1672)."</a>");
     if($categoryID)
      {
       $_SEP  = $w3->getSkinObj()->getSeparator();
	   $_PSEP = $w3->getSkinObj()->getPathSeparator();
       if($admin) array_push($_CONTENTS," $_PSEP <a href=\"".$base_link.$id_link."&action=".WM3_cACTION_SHOW_FAQ."\">".wm3Faq::getFaqCategoryName($w3,$categoryID)." ($total_items)</a>");
       else       array_push($_CONTENTS," $_PSEP <a href=\"".$base_link.$id_link.$page_link."&action=".WM3_cACTION_SHOW_FAQ."\">".wm3Faq::getFaqCategoryName($w3,$categoryID)." ($total_items)</a>");
       if($admin) array_push($_CONTENTS," $_SEP ".wm3Util::actionButton($base_link.$id_link."&action=".WM3_cACTION_ADD_FAQ,"action_add.png","","",$w3->getWord(1657),0,16,16));
	   //else       array_push($_CONTENTS," $_SEP ".wm3Util::actionButton($base_link.$page_link."&action=".WM3_cACTION_ADD_FAQ,"action_add.png","","",$w3->getWord(110),0,16,16));//Ask a faq (TODO)
      }
     $str = wm3Section::makeHeaderList($w3,$_CONTENTS,$columns,$search_form);

     // Create list caption
     if($admin) $str .= wm3Section::makeCaptionList($w3,array($width_question,30,0),array(839,1671),$buttons);

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0) return $str.wm3Section::makeEmptyItemsList($w3,$columns,593);

     // Create list items
     $p = 0;
     while($row = mysql_fetch_object($rs))
      {
       $_CONTENTS = array(); $_WIDTHS = array();
       $link = $base_link.$id_link.$extra_link."&faqID=$row->faqID";
       if($allowed) $allowed_link = $base_allowed_link."&faqID=$row->faqID";
       if($categoryID) {
                        if($admin) array_push($_CONTENTS,$row->question);
                        else       array_push($_CONTENTS,"<a href=$link$page_link&action=".WM3_cACTION_SHOW_SINGLE_FAQ.">$row->question</a>");
                       }
       else            {
       	                // For the search in all categories
                        if($admin) array_push($_CONTENTS,$row->question."<br>(".$w3->getWord(659)." <a href=\"$base_link$search_link&categoryID=$row->categoryID&action=".WM3_cACTION_SHOW_FAQ."\">".wm3Faq::getFaqCategoryName($w3,$row->categoryID)."</a>)");
                        else       array_push($_CONTENTS,"<a href=\"$base_link$page_link&faqID=$row->faqID&categoryID=$row->categoryID&action=".WM3_cACTION_SHOW_SINGLE_FAQ."\">$row->question</a><br>(".$w3->getWord(659)." <a href=\"$base_link$search_link$page_link&categoryID=$row->categoryID&action=".WM3_cACTION_SHOW_FAQ."\">".wm3Faq::getFaqCategoryName($w3,$row->categoryID)."</a>)");
                       }
       array_push($_WIDTHS,$width_question);
       if($admin)
        {
         $lang_flag = "<img src=\"".WM3_cPATH_DATA.wm3Language::getFlag($row->languageID)."\" width=\"19\" height=\"13\" align=\"middle\">";
         array_push($_CONTENTS,$lang_flag); array_push($_WIDTHS,30);
         // Buttons
         if($row->enabled) array_push($_CONTENTS,wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DISABLE_FAQ,"action_disable.png",$w3->getWord(180)));
         else              array_push($_CONTENTS,wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_ENABLE_FAQ,"action_enable.png",$w3->getWord(181)));
         array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_EDIT_FAQ,"action_edit.png",$w3->getWord(178)));
         array_push($_CONTENTS,wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DELETE_FAQ,"action_delete.png",$w3->getWord(179),$w3->getWord(699)));
        }
       else
        {
         if($allowed) array_push($_CONTENTS,wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_FAQ,"action_edit.png",$w3->getWord(178)));
        }
       $str .= wm3Section::makeItemList($w3,$p,$_WIDTHS,$_CONTENTS,$row->faqID==$currentID);
       $p++;
      }

     // Create list bottom
     $bottom_content = "";
     if($total_items > $max_page_items)
      {
       if($admin) $bottom_content = wm3Util::makePagesNavigator($total_items,$max_page_items,$pg,$base_link."&action=".WM3_cACTION_SHOW_FAQ.$id_link.$search_link);
       else       $bottom_content = wm3Util::makePagesNavigator($total_items,$max_page_items,$pg,$base_link.$page_link."&action=".WM3_cACTION_SHOW_FAQ.$id_link.$search_link);
      }
     $str .= wm3Section::makeBottomList($w3,$columns,$bottom_content);

     return $str;
    }

   public static function checkFaqError($w3)
    {
     // Check form invalid inputs
     $_FIELD = webmatic3::getPostValueArray(wm3Faq::getFaqFieldsArray());
     if(!$_FIELD['question']) return 1;
     if(!$_FIELD['answer'])   return 2;
	 if(!$w3->getSectionObj()->existsCategory($_FIELD['categoryID'])) return 3;	 
     return 0;
    }

   public static function addFaq($w3,$error = 0)
    {
     // Take variables value and set correct form style    
     $_STYLE = wm3Skin::getFormStyleArray(wm3Faq::getFaqFieldsArray());
     $_FIELD = webmatic3::getPostValueArray(wm3Faq::getFaqFieldsArray());
     // Fields for paging default value
     $pg = $filter = ""; 
     switch($error)
      {
       case 1: // No question
        {
         $_STYLE['question']       = "class=\"adminFormError\"";
         $_STYLE['adminFormTitle'] = "class=\"adminFormTitleError\"";
         $form_title = $w3->getWord(367);
         break;
        }
       case 2: // No answare
        {
         $_STYLE['answer']         = "class=\"adminFormError\"";
         $_STYLE['adminFormTitle'] = "class=\"adminFormTitleError\"";
         $form_title = $w3->getWord(860);
         break;
        }
       case 3: // Invalid category
        {
         $_STYLE['categoryID']     = "class=\"adminFormError\"";
         $_STYLE['adminFormTitle'] = "class=\"adminFormTitleError\"";
         $form_title = "Error $error nvalid categry";//$w3->getWord(29);
         break;
        }
       default:
        {
         // Default values for the form
         $_FIELD['categoryID']     = $w3->getVariable('categoryID','get'); // Take categoryID from get
         $_FIELD['enabled']        = WM3_cENABLED;
         $_STYLE['adminFormTitle'] = "class=\"adminFormTitle\"";
         $form_title = $w3->getWord(1673);
       	}
      }
     $next_action       = WM3_cACTION_SAVE_FAQ;
     $next_action_label = $w3->getWord(191);
     require(WM3_cPATH_INCLUDE."admin_faq_form.inc");
     return $admin_content;
    }

   public static function editFaq($w3,$error = 0)
    {
     // Take variables value from db and set correct form style
     if(!$error)
      {
       $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_faqs
                               WHERE faqID = '".$w3->getVariable('faqID','get')."'");
       $row = mysql_fetch_object($rs);
	   if(!$row) return wm3Section::makeNotFoundItem($w3);
       $_FIELD = webmatic3::getRowValueArray(wm3Faq::getFaqFieldsArray(),$row);
       // Default value for fields not in $row object
      }
     else $_FIELD = webmatic3::getPostValueArray(wm3Faq::getFaqFieldsArray());

     $_STYLE = wm3Skin::getFormStyleArray(wm3Faq::getFaqFieldsArray());
     $pg     = $w3->getVariable('pg','both');
     $filter = $w3->getVariable('filter','both');
     switch($error)
      {
       case 1: // No question
        {
         $_STYLE['question']       = "class=\"adminFormError\"";
         $_STYLE['adminFormTitle'] = "class=\"adminFormTitleError\"";
         $form_title = $w3->getWord(367);
         break;
        }
       case 2: // No answare
        {
         $_STYLE['answer']         = "class=\"adminFormError\"";
         $_STYLE['adminFormTitle'] = "class=\"adminFormTitleError\"";
         $form_title = $w3->getWord(860);
         break;
        }
       case 3: // Invalid category
        {
         $_STYLE['categoryID']     = "class=\"adminFormError\"";
         $_STYLE['adminFormTitle'] = "class=\"adminFormTitleError\"";
         $form_title = "Error $error nvalid categry";//$w3->getWord(29);
         break;
        }
       default:
        {
         $_STYLE['adminFormTitle'] = "class=\"adminFormTitle\"";
         $form_title = $w3->getWord(1674);
       	}
      }
     $next_action       = WM3_cACTION_UPDATE_FAQ;
     $next_action_label = $w3->getWord(29);
     require(WM3_cPATH_INCLUDE."admin_faq_form.inc");
     return $admin_content;
    }

   public static function saveFaq($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Faq::getFaqFieldsArray(),WM3_cQUOTE_DB);
     $_FIELD['ts'] = time();
     wm3Sql::saveAllTableFields('_faqs',$_FIELD);
     return wm3Sql::getLastInsertID();
    }

   public static function updateFaq($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Faq::getFaqFieldsArray(),WM3_cQUOTE_DB);
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_faqs
                       SET   question    = '".$_FIELD['question']."',
                             categoryID  = '".$_FIELD['categoryID']."',
                             answer      = '".$_FIELD['answer']."',
							 render_mode = '".$_FIELD['render_mode']."',
                             enabled     = '".$_FIELD['enabled']."',
                             languageID  = '".$_FIELD['languageID']."'
                       WHERE faqID       = '".$_FIELD['faqID']."'");
     return $_FIELD['faqID'];
    }

   public static function duplicateFaq($w3)
    {
     // Take fields from database and duplicate data creating a new row
     $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_faqs
                             WHERE faqID = '".$w3->getVariable('faqID','get')."'");
     $row = mysql_fetch_object($rs);
     if($row) // Duplicate only if ID exist
      {
       $_FIELD = webmatic3::getRowValueArray(wm3Faq::getFaqFieldsArray(),$row);
       $_FIELD['title'] = $w3->getWord(1417).$_FIELD['title'];
       $_FIELD['enabled'] = WM3_cDISABLED;
       $_FIELD['ts'] = time();
       wm3Sql::saveAllTableFields('_faqs',$_FIELD);
       return wm3Sql::getLastInsertID();
      }
    }

   public static function disableFaq($faqID) { wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_faqs SET enabled = '".WM3_cDISABLED."' WHERE faqID = '$faqID'"); }

   public static function enableFaq($faqID)  { wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_faqs SET enabled = '".WM3_cENABLED."' WHERE faqID = '$faqID'"); }
   
   public static function deleteFaq($faqID)  { wm3Sql::sqlQuery("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_faqs WHERE faqID = '$faqID'"); }

   public static function renderFaq($w3,$admin = false)
    {
     // Get faq (home side)

     // Prepare variables
     $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_MEDIA_ALBUMS); // Used to enable admin buttons in home stage
     $categoryID = $w3->getVariable('categoryID','both');
     $faqID      = $w3->getVariable('faqID','both');
	 if($categoryID) $query_filter = " AND ".WM3_cCONFIG_DB_PREFIX."_faqs.categoryID = '$categoryID'"; else $query_filter = "";
     $filter = $w3->getVariable('filter','both'); // Search field
     $pg     = $w3->getVariable('pg','both');
     if($filter) $search_link = "&filter=$filter"; else $search_link = "";
     if($pg) $extra_link = "&pg=$pg"; else $extra_link = "";
     $pageID = $w3->getVariable('pageID','both');
     $page_link        = "&pageID=$pageID";
     $search_form_link = WM3_cCONFIG_HOME_FILE."?action=".WM3_cACTION_SHOW_FAQ."$page_link";
     $base_link        = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     $query_filter .= " AND ".WM3_cCONFIG_DB_PREFIX."_faqs.enabled*".WM3_cCONFIG_DB_PREFIX."_faqs_categories.enabled='".WM3_cENABLED."' AND ".WM3_cCONFIG_DB_PREFIX."_faqs.languageID='".$w3->getHomeLanguage()."'";
     $columns = 1; $buttons = 0; 
     if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_FAQ;
     $id_link = "&categoryID=$categoryID";

     // Do the query and take the total items number
     $query = "SELECT ".WM3_cCONFIG_DB_PREFIX."_faqs_categories.enabled,
                      ".WM3_cCONFIG_DB_PREFIX."_faqs.*
               FROM   ".WM3_cCONFIG_DB_PREFIX."_faqs_categories,
                      ".WM3_cCONFIG_DB_PREFIX."_faqs
               WHERE  ".WM3_cCONFIG_DB_PREFIX."_faqs_categories.categoryID=".WM3_cCONFIG_DB_PREFIX."_faqs.categoryID
               $query_filter";
     $rs = wm3Sql::sqlQuery($query." ORDER BY ".WM3_cCONFIG_DB_PREFIX."_faqs.question DESC"); // Do the query without "limit"
	 $rs_aux = $rs;
     $total_items = mysql_num_rows($rs);
     if($total_items != 0) $rs = wm3Sql::sqlQuery($query." AND ".WM3_cCONFIG_DB_PREFIX."_faqs.faqID = '$faqID'");

     // Create list header
     $_CONTENTS = array();
     require(WM3_cPATH_INCLUDE."admin_faq_search_form.inc");
     array_push($_CONTENTS,"<a href=\"$base_link$page_link\">".$w3->getWord(1672)."</a>");	 
     if($categoryID)
      {
	   $_PSEP = $w3->getSkinObj()->getPathSeparator();
       array_push($_CONTENTS," $_PSEP <a href=\"".$base_link.$id_link.$page_link."&action=".WM3_cACTION_SHOW_FAQ."\">".wm3Faq::getFaqCategoryName($w3,$categoryID)." ($total_items)</a>");
      }
     $str = wm3Section::makeHeaderList($w3,$_CONTENTS,$columns,$search_form);

     // Create list caption

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0) return $str.wm3Section::makeEmptyItemsList($w3,$columns,593);

     // Create item
     $row = mysql_fetch_object($rs);
	 if(!$row) return $str.wm3Section::makeNotFoundItem($w3,$columns,false);
     $link = $base_link.$id_link.$search_link.$extra_link;
     if($allowed)
	  {
	   $allowed_link = $base_allowed_link."&faqID=$row->faqID";
	   $button = wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_FAQ,"action_edit.png",$w3->getWord(178));
      }
     else $button = "";
     $question = "$button<b>$row->question</b>";	 
     $answer   = "<i>".wm3Util::renderContent($w3,$row->answer,$row->render_mode)."</i>";
     $str .= wm3Section::makeItemList($w3,0,array(100),array($question),false);
	 $str .= wm3Section::makeItemList($w3,0,array(100),array($answer),false);

     // Create list bottom
     if($total_items > 1) $bottom_content = wm3Util::makePagesNavigator(0,0,0,$base_link.$id_link.$search_link.$extra_link.$page_link."&action=".WM3_cACTION_SHOW_SINGLE_FAQ,$rs_aux,"faqID",$row->faqID);
	 else $bottom_content = "";
     $str .= wm3Section::makeBottomList($w3,$columns,$bottom_content);

     return $str;
    }

  }

?>
