<?php

 // THIS FILE IS PART OF WEBMATIC3 (Webmatic cube)
 // www.valarsoft.com

 defined('WM3_cEXEC') or die('Denied');

 class wm3Market extends wm3Section
  {

   function __construct() { }   

   public static function getSectionParameters()
    {
     // Set the right parameters for market section
     return array(
                  'allowed_section'               => WM3_cSECTION_MARKET,
                  'allow_category_description'    => false,
                  'allow_subcategory_description' => false,
                  'category_form'                 => 'admin_market_category_form.inc',
                  'search_form'                   => 'admin_market_search_form.inc',
                  'subcategory_form'              => 'admin_market_subcategory_form.inc',
                  'table_categories'              => '_market_categories',
                  'table_subcategories'           => '_market_subcategories',
                  'table_subcategories_count'     => '_market_subcategories',
                  'table_items_count'             => '_market_announcements',
                  'action_save_category'          => WM3_cACTION_SAVE_MARKET_CATEGORY,
                  'action_update_category'        => WM3_cACTION_UPDATE_MARKET_CATEGORY,
                  'action_show_subcategory'       => WM3_cACTION_SHOW_MARKET_SUBCATEGORY,
                  'action_add_subcategory'        => WM3_cACTION_ADD_MARKET_SUBCATEGORY,
                  'action_disable_category'       => WM3_cACTION_DISABLE_MARKET_CATEGORY,
                  'action_enable_category'        => WM3_cACTION_ENABLE_MARKET_CATEGORY,
                  'action_edit_category'          => WM3_cACTION_EDIT_MARKET_CATEGORY,
                  'action_delete_category'        => WM3_cACTION_DELETE_MARKET_CATEGORY,
                  'action_update_subcategory'     => WM3_cACTION_UPDATE_MARKET_SUBCATEGORY,
                  'action_save_subcategory'       => WM3_cACTION_SAVE_MARKET_SUBCATEGORY,
                  'action_show_items'             => WM3_cACTION_SHOW_MARKET_ANNOUNCEMENT,
                  'action_add_item'               => WM3_cACTION_ADD_MARKET_ANNOUNCEMENT,
                  'action_disable_subcategory'    => WM3_cACTION_DISABLE_MARKET_SUBCATEGORY,
                  'action_enable_subcategory'     => WM3_cACTION_ENABLE_MARKET_SUBCATEGORY,
                  'action_edit_subcategory'       => WM3_cACTION_EDIT_MARKET_SUBCATEGORY,
                  'action_delete_subcategory'     => WM3_cACTION_DELETE_MARKET_SUBCATEGORY,
                  'action_search'                 => WM3_cACTION_SHOW_MARKET_ANNOUNCEMENT,
                  'label_category_list_title'     => 1702,
                  'label_subcategory_add'         => 1663,
                  'label_subcategories_count'     => 1051,
                  'label_items_count'             => 1681,
                  'label_item_add'                => 1687);
    }

   public static function getMarketAnnouncementFieldsArray()
    { // TODO update_ts ???
     return array('announcementID','subcategoryID','userID','title','announcement_type','render_mode','announcement','always_valid','languageID','enabled','ts','categoryID');
    }

   public static function executeHomeAction($w3,$pageID)
    {
     // Market page content
     switch($w3->getAction())
      {
       case WM3_cACTION_SHOW_MARKET_ANNOUNCEMENT:
        {
         return wm3Market::getMarketAnnouncementList($w3,0,false);
         break;
        }
       case WM3_cACTION_SHOW_SINGLE_ANNOUNCEMENT:
        {
         return wm3Market::renderMarketAnnouncement($w3);
         break;
        }
       /*case WM3_cACTION_ADD_MARKET_ANNOUNCEMENT:
        {
         return wm3Market::addMarketAnnouncement($w3);//TODO ...
         break;
        }*/
       /*case WM3_cACTION_SAVE_MARKET_ANNOUNCEMENT:
        {
         $error = wm3Market::checkMarketAnnouncementError($w3);
         if(!$error)
          {
           $lastID = wm3Market::saveMarketAnnouncement($w3);
           // $msg= news saved... //TODO
           return wm3Market::getMarketAnnouncementList($w3,$lastID);
          }
         else return wm3Market::addMarketAnnouncement($w3,$error);
         break;
        }*/
       case WM3_cACTION_SHOW_MARKET_SUBCATEGORY:
        {
         return wm3Market::getMarketSubcategoryList($w3,0,false);
         break;
        }        
       default:
        {
         return wm3Market::getMarketCategoryList($w3,0,false);
        }
      }
    }

   public static function executeUserAction($w3)
    {
     switch($w3->getAction())
      {
       case WM3_cACTION_ADD_MARKET_ANNOUNCEMENT:
        {
         return wm3Market::addMarketAnnouncement($w3,0,true);
         break;
        }
       case WM3_cACTION_SAVE_MARKET_ANNOUNCEMENT:
        {
		 wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_market_announcements WRITE,
		                               ".WM3_cCONFIG_DB_PREFIX."_market_subcategories WRITE,
									   ".WM3_cCONFIG_DB_PREFIX."_market_categories    WRITE");
         $error = wm3Market::checkMarketAnnouncementError($w3);
         if(!$error) {
                      $lastID = wm3Market::saveMarketAnnouncement($w3,true);
                      wm3Sql::sqlQuery("UNLOCK TABLES");
                      return wm3Market::getMarketAnnouncementList($w3,$lastID,true,true);
                     }
         else        {
			          wm3Sql::sqlQuery("UNLOCK TABLES");
			          return wm3Market::addMarketAnnouncement($w3,$error,true);
				     }
         break;
        }
       case WM3_cACTION_EDIT_MARKET_ANNOUNCEMENT:
        {
         return wm3Market::editMarketAnnouncement($w3,0,true);
         break;
        }
       case WM3_cACTION_UPDATE_MARKET_ANNOUNCEMENT:
        {
		 wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_market_announcements WRITE,
		                               ".WM3_cCONFIG_DB_PREFIX."_market_subcategories WRITE,
									   ".WM3_cCONFIG_DB_PREFIX."_market_categories    WRITE");
         $error = wm3Market::checkMarketAnnouncementError($w3);
         if(!$error) {
                      $lastID = wm3Market::updateMarketAnnouncement($w3,true);
                      wm3Sql::sqlQuery("UNLOCK TABLES");
                      return wm3Market::getMarketAnnouncementList($w3,$lastID,true);
                     }
         else        {
			          wm3Sql::sqlQuery("UNLOCK TABLES");
			          return wm3Market::editMarketAnnouncement($w3,$error,true);
				     }
         break;
        }
       case WM3_cACTION_DISABLE_MARKET_ANNOUNCEMENT:
        {
         wm3Market::disableMarketAnnouncement($w3,$w3->getVariable('announcementID','get'),true);
         return wm3Market::getMarketAnnouncementList($w3,$w3->getVariable('announcementID','get'),true,true);
         break;
        }
       case WM3_cACTION_ENABLE_MARKET_ANNOUNCEMENT:
        {
         wm3Market::enableMarketAnnouncement($w3,$w3->getVariable('announcementID','get'),true);
         return wm3Market::getMarketAnnouncementList($w3,$w3->getVariable('announcementID','get'),true,true);
         break;
        }
       case WM3_cACTION_DELETE_MARKET_ANNOUNCEMENT:
        {
         wm3Market::deleteMarketAnnouncement($w3,$w3->getVariable('announcementID','get'),true);
         return wm3Market::getMarketAnnouncementList($w3,0,true,true);
         break;
        }
       default:
        {
         return wm3Market::getMarketAnnouncementList($w3,0,true,true);
        }
      }     
    }

   public static function executeAdminAction($w3)
    {
     switch($w3->getAction())
      {
       case WM3_cACTION_ADD_MARKET_CATEGORY:
        {
         return wm3Market::addMarketCategory($w3);
         break;
        }
       case WM3_cACTION_SAVE_MARKET_CATEGORY:
        {
         $error = wm3Market::checkMarketCategoryError($w3);
         if(!$error)
          {
           $lastID = wm3Market::saveMarketCategory($w3);
           // $msg= message saved... //TODO
           return wm3Market::getMarketCategoryList($w3,$lastID);
          }
         else return wm3Market::addMarketCategory($w3,$error);
         break;
        }
       case WM3_cACTION_EDIT_MARKET_CATEGORY:
        {
         return wm3Market::editMarketCategory($w3);
         break;
        }
       case WM3_cACTION_UPDATE_MARKET_CATEGORY:
        {
         $error = wm3Market::checkMarketCategoryError($w3);
         if(!$error)
          {
           $lastID = wm3Market::updateMarketCategory($w3);
           // $msg= message udated... //TODO
           return wm3Market::getMarketCategoryList($w3,$lastID);
          }
         else return wm3Market::editMarketCategory($w3,$error);
         break;
        }
       case WM3_cACTION_DISABLE_MARKET_CATEGORY:
        {
         wm3Market::disableMarketCategory($w3->getVariable('categoryID','get'));
         return wm3Market::getMarketCategoryList($w3,$w3->getVariable('categoryID','get'));
         break;
        }
       case WM3_cACTION_ENABLE_MARKET_CATEGORY:
        {
         wm3Market::enableMarketCategory($w3->getVariable('categoryID','get'));
         return wm3Market::getMarketCategoryList($w3,$w3->getVariable('categoryID','get'));
         break;
        }
       case WM3_cACTION_DELETE_MARKET_CATEGORY:
        {
         wm3Market::deleteMarketCategory($w3,$w3->getVariable('categoryID','get'));
         return wm3Market::getMarketCategoryList($w3);
         break;
        }
       case WM3_cACTION_ADD_MARKET_SUBCATEGORY:
        {
         return wm3Market::addMarketSubcategory($w3);
         break;
        }
       case WM3_cACTION_SAVE_MARKET_SUBCATEGORY:
        {
		 wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_market_subcategories WRITE,
									   ".WM3_cCONFIG_DB_PREFIX."_market_categories    WRITE");
         $error = wm3Market::checkMarketSubcategoryError($w3);
         if(!$error) {
                      $lastID = wm3Market::saveMarketSubcategory($w3);
                      wm3Sql::sqlQuery("UNLOCK TABLES");
                      return wm3Market::getMarketSubcategoryList($w3,$lastID);
                     }
         else        {
			          wm3Sql::sqlQuery("UNLOCK TABLES");
			          return wm3Market::addMarketSubcategory($w3,$error);
					 }
         break;
        }
       case WM3_cACTION_DISABLE_MARKET_SUBCATEGORY:
        {
         wm3Market::disableMarketSubcategory($w3->getVariable('subcategoryID','get'));
         return wm3Market::getMarketSubcategoryList($w3,$w3->getVariable('subcategoryID','get'));
         break;
        }
       case WM3_cACTION_ENABLE_MARKET_SUBCATEGORY:
        {
         wm3Market::enableMarketSubcategory($w3->getVariable('subcategoryID','get'));
         return wm3Market::getMarketSubcategoryList($w3,$w3->getVariable('subcategoryID','get'));
         break;
        }
       case WM3_cACTION_DELETE_MARKET_SUBCATEGORY:
        {
         wm3Market::deleteMarketSubcategory($w3,$w3->getVariable('subcategoryID','get'));
         return wm3Market::getMarketSubcategoryList($w3);
         break;
        }
       case WM3_cACTION_EDIT_MARKET_SUBCATEGORY:
        {
         return wm3Market::editMarketSubcategory($w3);
         break;
        }
       case WM3_cACTION_UPDATE_MARKET_SUBCATEGORY:
        {
		 wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_market_subcategories WRITE,
									   ".WM3_cCONFIG_DB_PREFIX."_market_categories    WRITE");
         $error = wm3Market::checkMarketSubcategoryError($w3);
         if(!$error) {
                      $lastID = wm3Market::updateMarketSubcategory($w3);
                      wm3Sql::sqlQuery("UNLOCK TABLES");
                      return wm3Market::getMarketSubcategoryList($w3,$lastID);
                     }
         else        {
			          wm3Sql::sqlQuery("UNLOCK TABLES");
			          return wm3Market::editMarketSubcategory($w3,$error);
				     }
         break;
        }
       case WM3_cACTION_ADD_MARKET_ANNOUNCEMENT:
        {
         return wm3Market::addMarketAnnouncement($w3);
         break;
        }
       case WM3_cACTION_SAVE_MARKET_ANNOUNCEMENT:
        {
		 wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_market_announcements WRITE,
		                               ".WM3_cCONFIG_DB_PREFIX."_market_subcategories WRITE,
									   ".WM3_cCONFIG_DB_PREFIX."_market_categories    WRITE");
         $error = wm3Market::checkMarketAnnouncementError($w3);
         if(!$error) {
                      $lastID = wm3Market::saveMarketAnnouncement($w3);
                      wm3Sql::sqlQuery("UNLOCK TABLES");
                      return wm3Market::getMarketAnnouncementList($w3,$lastID);
                     }
         else        {
                      wm3Sql::sqlQuery("UNLOCK TABLES");
	   		          return wm3Market::addMarketAnnouncement($w3,$error);
		             }
         break;
        }
       case WM3_cACTION_EDIT_MARKET_ANNOUNCEMENT:
        {
         return wm3Market::editMarketAnnouncement($w3);
         break;
        }
       case WM3_cACTION_UPDATE_MARKET_ANNOUNCEMENT:
        {
		 wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_market_announcements WRITE,
		                               ".WM3_cCONFIG_DB_PREFIX."_market_subcategories WRITE,
									   ".WM3_cCONFIG_DB_PREFIX."_market_categories    WRITE");
         $error = wm3Market::checkMarketAnnouncementError($w3);
         if(!$error) {
                      $lastID = wm3Market::updateMarketAnnouncement($w3);
                      wm3Sql::sqlQuery("UNLOCK TABLES");
                      return wm3Market::getMarketAnnouncementList($w3,$lastID);
                     }
         else        {
			          wm3Sql::sqlQuery("UNLOCK TABLES");
			          return wm3Market::editMarketAnnouncement($w3,$error);
				     }
         break;
        }
       case WM3_cACTION_DISABLE_MARKET_ANNOUNCEMENT:
        {
         wm3Market::disableMarketAnnouncement($w3,$w3->getVariable('announcementID','get'));
         return wm3Market::getMarketAnnouncementList($w3,$w3->getVariable('announcementID','get'));
         break;
        }
       case WM3_cACTION_ENABLE_MARKET_ANNOUNCEMENT:
        {
         wm3Market::enableMarketAnnouncement($w3,$w3->getVariable('announcementID','get'));
         return wm3Market::getMarketAnnouncementList($w3,$w3->getVariable('announcementID','get'));
         break;
        }
       case WM3_cACTION_DELETE_MARKET_ANNOUNCEMENT:
        {
         wm3Market::deleteMarketAnnouncement($w3,$w3->getVariable('announcementID','get'));
         return wm3Market::getMarketAnnouncementList($w3);
         break;
        }
       case WM3_cACTION_SHOW_MARKET_ANNOUNCEMENT:
        {
         return wm3Market::getMarketAnnouncementList($w3);
         break;
        }
       case WM3_cACTION_SHOW_MARKET_SUBCATEGORY:
        {
         return wm3Market::getMarketSubcategoryList($w3);
         break;
        }
       default:
        {
         return wm3Market::getMarketCategoryList($w3);
        }
      }     
    }

   public static function getMarketCategoryList($w3,$currentID = 0,$admin = true)
    {
	 return $w3->getSectionObj()->getCategoryList($w3,$currentID,$admin);
	}

   public static function checkMarketCategoryError($w3)
    {
	 return $w3->getSectionObj()->checkCategoryError($w3);
	}

   public static function addMarketCategory($w3,$error = 0)
    {
	 return $w3->getSectionObj()->addCategory($w3,$error);
	}

   public static function editMarketCategory($w3,$error = 0)
    {
	 return $w3->getSectionObj()->editCategory($w3,$error);
	}

   public static function saveMarketCategory($w3)
    {
	 return $w3->getSectionObj()->saveCategory($w3);
	}

   public static function updateMarketCategory($w3)
    {
	 return $w3->getSectionObj()->updateCategory($w3);
	}

   public static function disableMarketCategory($categoryID)
    {
	 wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_market_categories SET enabled = '".WM3_cDISABLED."' WHERE categoryID = '$categoryID'");
	}

   public static function enableMarketCategory($categoryID)
    {
	 wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_market_categories SET enabled = '".WM3_cENABLED."' WHERE categoryID = '$categoryID'");
	}
   
   public static function deleteMarketCategory($w3,$categoryID)
    {
	 $w3->getSectionObj()->deleteCategory($categoryID);
	}

   public static function selectMarketCategory($w3,$name,$categoryID,$all = false,$admin = true)
    {
	 return $w3->getSectionObj()->selectCategory($w3,$name,$categoryID,$all,$admin);
	}

   public static function getMarketCategoryName($w3,$categoryID)
    {
	 return $w3->getSectionObj()->getCategoryName($categoryID);
	}

   public static function getMarketSubcategoryList($w3,$currentID = 0,$admin = true)
    {
	 return $w3->getSectionObj()->getSubcategoryList($w3,$currentID,$admin);
	}

   public static function checkMarketSubcategoryError($w3)
    {
	 return $w3->getSectionObj()->checkSubcategoryError($w3);
	}

   public static function addMarketSubcategory($w3,$error = 0)
    {
	 return $w3->getSectionObj()->addSubcategory($w3,$error);
	}

   public static function editMarketSubcategory($w3,$error = 0)
    {
	 return $w3->getSectionObj()->editSubcategory($w3,$error);
	}

   public static function saveMarketSubcategory($w3)
    {
	 return $w3->getSectionObj()->saveSubcategory($w3);
	}

   public static function updateMarketSubcategory($w3)
    {
	 return $w3->getSectionObj()->updateSubcategory($w3);
	}

   public static function disableMarketSubcategory($subcategoryID)
    {
	 wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_market_subcategories SET enabled = '".WM3_cDISABLED."' WHERE subcategoryID = '$subcategoryID'");
	}

   public static function enableMarketSubcategory($subcategoryID)
    {
	 wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_market_subcategories SET enabled = '".WM3_cENABLED."' WHERE subcategoryID = '$subcategoryID'");
	}
   
   public static function deleteMarketSubcategory($w3,$subcategoryID)
    {
	 $w3->getSectionObj()->deleteSubcategory($subcategoryID);
	}

   public static function getMarketSubcategoryName($w3,$subcategoryID)
    {
	 return $w3->getSectionObj()->getSubcategoryName($subcategoryID);
	}

   public static function selectMarketSubcategory($w3,$name,$subcategoryID,$all = false,$admin = true)
    {
	 return $w3->getSectionObj()->selectSubcategory($w3,$name,$subcategoryID,$all,$admin);
	}

   public static function getMarketCategoryID($w3,$subcategoryID)
    {
     return $w3->getSectionObj()->getCategoryID($subcategoryID);
    }

   public static function duplicateMarketCategories($w3)
    {
     // Take fields from database and duplicate data creating a new row
     wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_market_announcements WRITE,
	                               ".WM3_cCONFIG_DB_PREFIX."_market_subcategories WRITE,
								   ".WM3_cCONFIG_DB_PREFIX."_market_categories    WRITE");
     $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_news
                             WHERE newsID = '".$w3->getVariable('newsID','get')."'");
     $row = mysql_fetch_object($rs);
     if($row) // Duplicate only if ID exist
      {
       $_FIELD = webmatic3::getRowValueArray(wm3Market::getMarketAnnouncementFieldsArray(),$row);
       $_FIELD['title'] = $w3->getWord(1417).$_FIELD['title'];
       $_FIELD['enabled'] = WM3_cDISABLED;
       $_FIELD['ts'] = time();
       wm3Sql::saveAllTableFields('_news',$_FIELD);
	   wm3Sql::sqlQuery("UNLOCK TABLES");
       return wm3Sql::getLastInsertID();
      }
	 wm3Sql::sqlQuery("UNLOCK TABLES");
    }

   public static function getMarketAnnouncementList($w3,$currentID = 0,$admin = true,$user = false)
    {
	 // Get announcements list (admin and home side)

     // Prepare variables to create the list
     $max_page_items = 12;
     $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_MARKET); // Used to enable admin buttons in home stage
     $categoryID    = $w3->getVariable('categoryID','both');
     $subcategoryID = $w3->getVariable('subcategoryID','both');
     if($subcategoryID && !$categoryID) // When make a search take only subcategoryID (but need also categoryID)
      $categoryID = wm3Market::getMarketCategoryID($w3,$subcategoryID);
     if($subcategoryID) $query_filter = " AND ".WM3_cCONFIG_DB_PREFIX."_market_announcements.subcategoryID = '$subcategoryID'"; else $query_filter = "";
     $filter = $w3->getVariable('filter','both'); // Search field
     $pg     = $w3->getVariable('pg','both');
     if($filter) {
     	          $search_link   = "&filter=$filter";
     	          $query_filter .= " AND ".WM3_cCONFIG_DB_PREFIX."_market_announcements.announcement LIKE '%$filter%'";
     	         }
     else        { if(!$subcategoryID) $query_filter =" AND 1=0"; $search_link = ""; }
     if($admin) {
                 $width_title = 70;
 	             if(!$user) $search_form_link = WM3_cCONFIG_ADMIN_FILE."?action=".WM3_cACTION_SHOW_MARKET_ANNOUNCEMENT;
	             else       $search_form_link = WM3_cCONFIG_USER_FILE;
                 $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     	         $columns = 5; $buttons = 3;
     	        }
     else       {
                 $pageID = $w3->getVariable('pageID','get');
                 $page_link         = "&pageID=$pageID";
                 $search_form_link  = WM3_cCONFIG_HOME_FILE."?action=".WM3_cACTION_SHOW_MARKET_ANNOUNCEMENT."$page_link";
                 $base_link         = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
                 $width_title       = 100;
                 $query_filter .= " AND ".WM3_cCONFIG_DB_PREFIX."_market_announcements.enabled*".WM3_cCONFIG_DB_PREFIX."_market_categories.enabled*".WM3_cCONFIG_DB_PREFIX."_market_subcategories.enabled='".WM3_cENABLED."' AND ".WM3_cCONFIG_DB_PREFIX."_market_announcements.languageID='".$w3->getHomeLanguage()."'";
     	         if($allowed) { $columns = 2; $buttons = 1; } else { $columns = 1; $buttons = 0; }
     	        }
     if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_MARKET;
     $id_link = "&categoryID=$categoryID&subcategoryID=$subcategoryID";

     // Do the query and take the total items number
	 $order_by = " ORDER BY ".WM3_cCONFIG_DB_PREFIX."_market_announcements.ts DESC";
	 if(!$user)
      {
       $query = "SELECT ".WM3_cCONFIG_DB_PREFIX."_market_categories.enabled,
                        ".WM3_cCONFIG_DB_PREFIX."_market_subcategories.enabled,
                        ".WM3_cCONFIG_DB_PREFIX."_market_announcements.*
                 FROM   ".WM3_cCONFIG_DB_PREFIX."_market_categories,
                        ".WM3_cCONFIG_DB_PREFIX."_market_subcategories,
                        ".WM3_cCONFIG_DB_PREFIX."_market_announcements
                 WHERE  ".WM3_cCONFIG_DB_PREFIX."_market_categories.categoryID=".WM3_cCONFIG_DB_PREFIX."_market_subcategories.categoryID AND
                        ".WM3_cCONFIG_DB_PREFIX."_market_subcategories.subcategoryID=".WM3_cCONFIG_DB_PREFIX."_market_announcements.subcategoryID
                 $query_filter";
	  }
	 else
	  {
       $query = "SELECT *
                 FROM   ".WM3_cCONFIG_DB_PREFIX."_market_announcements
                 WHERE  userID = '".$w3->getAuthenticateUserID()."'";
	  }
     $rs = wm3Sql::sqlQuery($query.$order_by); // Do the query without "limit"
     $total_items = mysql_num_rows($rs);
     if($total_items % $max_page_items == 0 && $pg == (int)($total_items / $max_page_items)) $pg--;
	 if($currentID)
	  {
	   $position = wm3Sql::getRSPosition($rs,'announcementID',$currentID);
	   $pg = (int)($position / $max_page_items);
      }
	 if($pg) $extra_link = "&pg=$pg"; else $extra_link = "";
     if($total_items != 0) $rs = wm3Sql::sqlQuery($query.$order_by." LIMIT ".($pg*$max_page_items).",$max_page_items");

     // Create list header
     $_CONTENTS = array();
	 $_SEP = $w3->getSkinObj()->getSeparator();
     require(WM3_cPATH_INCLUDE."admin_market_search_form.inc");
     if($admin)
	  {
	   if(!$user) array_push($_CONTENTS,"<a href=\"$base_link\">".$w3->getWord(1702)."</a>");
	   else       array_push($_CONTENTS,$w3->getWord(1545));
      }
     else       array_push($_CONTENTS,"<a href=\"$base_link$page_link\">".$w3->getWord(1702)."</a>");
     if($subcategoryID && !$user)
      {
	   $_PSEP = $w3->getSkinObj()->getPathSeparator();
       if($admin) array_push($_CONTENTS," $_PSEP <a href=\"".$base_link."&categoryID=$categoryID&action=".WM3_cACTION_SHOW_MARKET_SUBCATEGORY."\">".wm3Market::getMarketCategoryName($w3,$categoryID)."</a>");
       else       array_push($_CONTENTS," $_PSEP <a href=\"".$base_link.$page_link."&categoryID=$categoryID&action=".WM3_cACTION_SHOW_MARKET_SUBCATEGORY."\">".wm3Market::getMarketCategoryName($w3,$categoryID)."</a>");
       if($admin) array_push($_CONTENTS," $_PSEP <a href=\"".$base_link.$id_link."&action=".WM3_cACTION_SHOW_MARKET_ANNOUNCEMENT."\">".wm3Market::getMarketSubcategoryName($w3,$subcategoryID)." ($total_items)</a>");
       else       array_push($_CONTENTS," $_PSEP <a href=\"".$base_link.$id_link.$page_link."&action=".WM3_cACTION_SHOW_MARKET_ANNOUNCEMENT."\">".wm3Market::getMarketSubcategoryName($w3,$subcategoryID)." ($total_items)</a>");
       if($admin) array_push($_CONTENTS," $_SEP ".wm3Util::actionButton($base_link.$id_link."&action=".WM3_cACTION_ADD_MARKET_ANNOUNCEMENT,"action_add.png","","",$w3->getWord(1687),0,16,16));
      }
	 if(!$admin) array_push($_CONTENTS," $_SEP ".wm3Util::actionButton(WM3_cCONFIG_HOME_FILE."?stage=".WM3_cSTAGE_USER."&section=".WM3_cSECTION_MARKET."&categoryID=$categoryID&action=".WM3_cACTION_ADD_MARKET_ANNOUNCEMENT,"action_add.png","","",$w3->getWord(1687),0,16,16));
     $str = wm3Section::makeHeaderList($w3,$_CONTENTS,$columns,$search_form);

     // Create list caption
     if($admin) $str .= wm3Section::makeCaptionList($w3,array(70,30,0),array(194,1407),$buttons);

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0) return $str.wm3Section::makeEmptyItemsList($w3,$columns,593);

     // Create list items
     $p = 0;
     while($row = mysql_fetch_object($rs))
      {
       $_CONTENTS = array(); $_WIDTHS = array();
       $link = $base_link.$id_link.$extra_link."&announcementID=$row->announcementID";
       if($allowed) $allowed_link = $base_allowed_link."&announcementID=$row->announcementID";
       if($subcategoryID) {
                           if($admin) array_push($_CONTENTS,"$row->title");
				           else       array_push($_CONTENTS,"<a href=$link$page_link&action=".WM3_cACTION_SHOW_SINGLE_ANNOUNCEMENT.">$row->title</a>");
                          }
       else               {
       	                   // For the search in all categories -> subcategories
						   $_PSEP = $w3->getSkinObj()->getPathSeparator();
                           if($admin) {
							           if(!$user) {
										           array_push($_CONTENTS,"$row->title<br>(".$w3->getWord(659)."
                           	                                  <a href=\"".$base_link."&categoryID=".$w3->getSectionObj()->getCategoryID($row->subcategoryID)."&action=".WM3_cACTION_SHOW_MARKET_SUBCATEGORY."\">".wm3Market::getMarketCategoryName($w3,$w3->getSectionObj()->getCategoryID($row->subcategoryID))."</a>
                           	                                  $_PSEP <a href=\"$base_link$search_link&subcategoryID=$row->subcategoryID&action=".WM3_cACTION_SHOW_MARKET_ANNOUNCEMENT."\">".wm3Market::getMarketSubcategoryName($w3,$row->subcategoryID)."</a>)");
												  }
									   else       {
                                                   array_push($_CONTENTS,"$row->title<br>(".$w3->getWord(659)."
                           	                                        ".wm3Market::getMarketCategoryName($w3,$w3->getSectionObj()->getCategoryID($row->subcategoryID))."
                           	                                  $_PSEP ".wm3Market::getMarketSubcategoryName($w3,$row->subcategoryID).")");
												  }
									  }
                           else       {
							           array_push($_CONTENTS,"<a href=\"$base_link$page_link&categoryID=".$w3->getSectionObj()->getCategoryID($row->subcategoryID)."&subcategoryID=$row->subcategoryID&announcementID=$row->announcementID&action=".WM3_cACTION_SHOW_SINGLE_ANNOUNCEMENT."\">$row->title</a><br>(".$w3->getWord(659)."
                           	                      <a href=\"$base_link$page_link&categoryID=".$w3->getSectionObj()->getCategoryID($row->subcategoryID)."&action=".WM3_cACTION_SHOW_MARKET_SUBCATEGORY."\">".wm3Market::getMarketCategoryName($w3,$w3->getSectionObj()->getCategoryID($row->subcategoryID))."</a>
                           	                      $_PSEP <a href=\"$base_link$search_link$page_link&subcategoryID=$row->subcategoryID&action=".WM3_cACTION_SHOW_MARKET_ANNOUNCEMENT."\">".wm3Market::getMarketSubcategoryName($w3,$row->subcategoryID)."</a>)");
									  }
                          }
       array_push($_WIDTHS,$width_title);
       if($admin)
        {
         $lang_flag = "<img src=\"".WM3_cPATH_DATA.wm3Language::getFlag($row->languageID)."\" width=\"19\" height=\"13\" align=\"middle\">";
		 $author = wm3User::getUserLogin($row->userID);
         array_push($_CONTENTS,"$lang_flag $author<br>".wm3Util::renderDate($w3,$row->ts,$w3->getHomeLanguage())); array_push($_WIDTHS,$width_title,30);
         // Buttons
         if($row->enabled) array_push($_CONTENTS,wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DISABLE_MARKET_ANNOUNCEMENT,"action_disable.png",$w3->getWord(180)));
         else              array_push($_CONTENTS,wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_ENABLE_MARKET_ANNOUNCEMENT,"action_enable.png",$w3->getWord(181)));
         array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_EDIT_MARKET_ANNOUNCEMENT,"action_edit.png",$w3->getWord(178)));
         array_push($_CONTENTS,wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DELETE_MARKET_ANNOUNCEMENT,"action_delete.png",$w3->getWord(179),$w3->getWord(772)));
        }
       else
        {
         if($allowed) array_push($_CONTENTS,wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_MARKET_ANNOUNCEMENT,"action_edit.png",$w3->getWord(178)));
        }
	   $str .= wm3Section::makeItemList($w3,$p,$_WIDTHS,$_CONTENTS,$row->announcementID==$currentID);
	   $p++;
      }

     // Create list bottom
     $bottom_content = "";
     if($total_items > $max_page_items)
      {
       $bottom_content = wm3Util::makePagesNavigator($total_items,$max_page_items,$pg,$base_link."&action=".WM3_cACTION_SHOW_MARKET_ANNOUNCEMENT.$id_link.$search_link);
      }
     $str .= wm3Section::makeBottomList($w3,$columns,$bottom_content);

     return $str;
    }

   public static function checkMarketAnnouncementError($w3)
    {
     // Check form invalid inputs
     $_FIELD = webmatic3::getPostValueArray(wm3Market::getMarketAnnouncementFieldsArray());
	 if(!$w3->getSectionObj()->existsSubcategory($_FIELD['subcategoryID'])) return 1;
     if(!$_FIELD['title']) return 2;
     if(!$_FIELD['announcement']) return 3;
     return 0;
    }

   public static function addMarketAnnouncement($w3,$error = 0,$user = false)
    {
     // Take variables value and set correct form style    
     $_STYLE = wm3Skin::getFormStyleArray(wm3Market::getMarketAnnouncementFieldsArray());
     $_FIELD = webmatic3::getPostValueArray(wm3Market::getMarketAnnouncementFieldsArray());
     // Fields for paging default value
     $pg = $filter = ""; 
     switch($error)
      {
       case 1: // Subcategory do not exists
        {
         $_STYLE['subcategoryID']  = "class=\"adminFormError\"";
         $_STYLE['adminFormTitle'] = "class=\"adminFormTitleError\"";
         $form_title = "Error $error invalid subcategory";//$w3->getWord(29);
         break;
        }
       case 2: // No title
        {
         $_STYLE['title']          = "class=\"adminFormError\"";
         $_STYLE['adminFormTitle'] = "class=\"adminFormTitleError\"";
         $form_title = "Error $error";//$w3->getWord(29);
         break;
        }
       case 3: // Empty announcement
        {
         $_STYLE['announcement']   = "class=\"adminFormError\"";
         $_STYLE['adminFormTitle'] = "class=\"adminFormTitleError\"";
         $form_title = "Error $error";//$w3->getWord(29);
         break;
        }
       default:
        {
         // Default values for the form
         $_FIELD['categoryID']    = $w3->getVariable('categoryID','get'); // Take categoryID from get
         $_FIELD['subcategoryID'] = $w3->getVariable('subcategoryID','get'); // Take subcategoryID from get
         $_FIELD['enabled']       = WM3_cENABLED;

         $_STYLE['adminFormTitle'] = "class=\"adminFormTitle\"";
         $form_title = $w3->getWord(351);
       	}
      }
     $next_action       = WM3_cACTION_SAVE_MARKET_ANNOUNCEMENT;
     $next_action_label = $w3->getWord(191);
     if($user) require(WM3_cPATH_INCLUDE."user_market_announcement_form.inc");
	 else      require(WM3_cPATH_INCLUDE."admin_market_announcement_form.inc");
     return $admin_content;
    }

   public static function editMarketAnnouncement($w3,$error = 0,$user = false)
    {
     // Take variables value from db and set correct form style
     if(!$error)
      {
       $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_market_announcements
                               WHERE announcementID = '".$w3->getVariable('announcementID','get')."'");
       $row = mysql_fetch_object($rs);
	   if(!$row) return wm3Section::makeNotFoundItem($w3);
       $_FIELD = webmatic3::getRowValueArray(wm3Market::getMarketAnnouncementFieldsArray(),$row);
       // Default value for fields not in $row object
	   $_FIELD['categoryID'] = $w3->getVariable('categoryID','get'); // Take categoryID from get
      }
     else $_FIELD = webmatic3::getPostValueArray(wm3Market::getMarketAnnouncementFieldsArray());

     $_STYLE = wm3Skin::getFormStyleArray(wm3Market::getMarketAnnouncementFieldsArray());
     $pg     = $w3->getVariable('pg','both');
     $filter = $w3->getVariable('filter','both');
     switch($error)
      {
       case 1: // Subcategory do not exists
        {
         $_STYLE['subcategoryID']  = "class=\"adminFormError\"";
         $_STYLE['adminFormTitle'] = "class=\"adminFormTitleError\"";
         $form_title = "Error $error invalid subcategory";//$w3->getWord(29);
         break;
        }
       case 2: // No title
        {
         $_STYLE['title']          = "class=\"adminFormError\"";
         $_STYLE['adminFormTitle'] = "class=\"adminFormTitleError\"";
         $form_title = "Error $error";//$w3->getWord(29);
         break;
        }
       case 3: // Empty announcement
        {
         $_STYLE['announcement']   = "class=\"adminFormError\"";
         $_STYLE['adminFormTitle'] = "class=\"adminFormTitleError\"";
         $form_title = "Error $error";//$w3->getWord(29);
         break;
        }
       default:
        {
         $_STYLE['adminFormTitle'] = "class=\"adminFormTitle\"";
         $form_title = "Edit news ...."; //$w3->getWord(29);
       	}
      }
     $next_action       = WM3_cACTION_UPDATE_MARKET_ANNOUNCEMENT;
     $next_action_label = $w3->getWord(29);
     if($user) require(WM3_cPATH_INCLUDE."user_market_announcement_form.inc");
	 else      require(WM3_cPATH_INCLUDE."admin_market_announcement_form.inc");
     return $admin_content;
    }

   public static function saveMarketAnnouncement($w3,$user = true)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Market::getMarketAnnouncementFieldsArray(),WM3_cQUOTE_DB);
     $_FIELD['ts'] = time();
	 if($user) {
		        $_FIELD['userID'] = $w3->getAuthenticateUserID();
				if($_FIELD['render_mode'] == WM3_cRENDER_MODE_HTML ||
				   $_FIELD['render_mode'] == WM3_cRENDER_MODE_HTML_BB_CODE)
				$_FIELD['render_mode'] = WM3_cRENDER_MODE_PLAIN_TEXT;				 
			   }	 
     wm3Sql::saveAllTableFields('_market_announcements',$_FIELD,array('categoryID'));
     return wm3Sql::getLastInsertID();
    }

   public static function updateMarketAnnouncement($w3,$user = false)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Market::getMarketAnnouncementFieldsArray(),WM3_cQUOTE_DB);
	 if($user) {
		        $userID = $w3->getAuthenticateUserID();
				if($_FIELD['render_mode'] == WM3_cRENDER_MODE_HTML ||
				   $_FIELD['render_mode'] == WM3_cRENDER_MODE_HTML_BB_CODE)
				 $_FIELD['render_mode'] = WM3_cRENDER_MODE_PLAIN_TEXT;
		       }
	 else      $userID = $_FIELD['userID'];
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_market_announcements
                       SET   title             = '".$_FIELD['title']."',
                             subcategoryID     = '".$_FIELD['subcategoryID']."',
                             userID            = '$userID',
                             announcement      = '".$_FIELD['announcement']."',
							 render_mode       = '".$_FIELD['render_mode']."',
							 announcement_type = '".$_FIELD['announcement_type']."',
							 always_valid      = '".$_FIELD['always_valid']."',
                             enabled           = '".$_FIELD['enabled']."',
                             languageID        = '".$_FIELD['languageID']."'
                       WHERE announcementID    = '".$_FIELD['announcementID']."'");
     return $_FIELD['announcementID'];
    }

   public static function disableMarketAnnouncement($w3,$announcementID,$user = false)
    {
	 if($user) wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_market_announcements SET enabled = '".WM3_cDISABLED."' WHERE announcementID = '$announcementID' AND userID='".$w3->getAuthenticateUserID()."'");
	 else      wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_market_announcements SET enabled = '".WM3_cDISABLED."' WHERE announcementID = '$announcementID'");
	}

   public static function enableMarketAnnouncement($w3,$announcementID,$user = false)
    {
	 if($user) wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_market_announcements SET enabled = '".WM3_cENABLED."' WHERE announcementID = '$announcementID' AND userID='".$w3->getAuthenticateUserID()."'");
	 else      wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_market_announcements SET enabled = '".WM3_cENABLED."' WHERE announcementID = '$announcementID'");
	}
   
   public static function deleteMarketAnnouncement($w3,$announcementID,$user = false)
    {
	 if($user) wm3Sql::sqlQuery("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_market_announcements WHERE announcementID = '$announcementID' AND userID='".$w3->getAuthenticateUserID()."'");
	 else      wm3Sql::sqlQuery("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_market_announcements WHERE announcementID = '$announcementID'");
	}

   public static function selectMarketAnnouncementType($w3,$name,$announcement_type)
    {
     // Make announcement type select
	 return wm3Util::selectArray($name,
                        array($w3->getWord(545),$w3->getWord(546)),
                        array(WM3_cMARKET_ANNOUNCEMENT_TYPE_SELL,WM3_cMARKET_ANNOUNCEMENT_TYPE_BUY),
                        $announcement_type);
    }

   public static function renderMarketAnnouncement($w3,$admin = false)
    {
	 // Get announcements list (admin and home side)

     // Prepare variables to create the list
     $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_MARKET); // Used to enable admin buttons in home stage
     $categoryID     = $w3->getVariable('categoryID','both');
     $subcategoryID  = $w3->getVariable('subcategoryID','both');
	 $announcementID = $w3->getVariable('announcementID','both');
	 $pageID         = $w3->getVariable('pageID','get');
     if($subcategoryID) $query_filter = " AND ".WM3_cCONFIG_DB_PREFIX."_market_announcements.subcategoryID = '$subcategoryID'"; else $query_filter = "";
     $filter = $w3->getVariable('filter','both'); // Search field
     $pg     = $w3->getVariable('pg','both');
     if($filter) $search_link   = "&filter=$filter"; else $search_link = "";
     if($pg) $extra_link = "&pg=$pg"; else $extra_link = "";
     $page_link         = "&pageID=$pageID";
     $search_form_link  = WM3_cCONFIG_HOME_FILE."?action=".WM3_cACTION_SHOW_MARKET_ANNOUNCEMENT."$page_link";
     $base_link         = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     $query_filter .= " AND ".WM3_cCONFIG_DB_PREFIX."_market_announcements.enabled*".WM3_cCONFIG_DB_PREFIX."_market_categories.enabled*".WM3_cCONFIG_DB_PREFIX."_market_subcategories.enabled='".WM3_cENABLED."' AND ".WM3_cCONFIG_DB_PREFIX."_market_announcements.languageID='".$w3->getHomeLanguage()."'";
     $columns = 1; $buttons = 0;
     if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_MARKET;
     $id_link = "&categoryID=$categoryID&subcategoryID=$subcategoryID";

     // Do the query and take the total items number
     $query = "SELECT ".WM3_cCONFIG_DB_PREFIX."_market_categories.enabled,
                      ".WM3_cCONFIG_DB_PREFIX."_market_subcategories.enabled,
                      ".WM3_cCONFIG_DB_PREFIX."_market_announcements.*
               FROM   ".WM3_cCONFIG_DB_PREFIX."_market_categories,
                      ".WM3_cCONFIG_DB_PREFIX."_market_subcategories,
                      ".WM3_cCONFIG_DB_PREFIX."_market_announcements
               WHERE  ".WM3_cCONFIG_DB_PREFIX."_market_categories.categoryID=".WM3_cCONFIG_DB_PREFIX."_market_subcategories.categoryID AND
                      ".WM3_cCONFIG_DB_PREFIX."_market_subcategories.subcategoryID=".WM3_cCONFIG_DB_PREFIX."_market_announcements.subcategoryID
               $query_filter";
     $rs = wm3Sql::sqlQuery($query."ORDER BY ".WM3_cCONFIG_DB_PREFIX."_market_announcements.ts DESC"); // Do the query without "limit"
	 $rs_aux = $rs;
     $total_items = mysql_num_rows($rs);
     if($total_items != 0) $rs = wm3Sql::sqlQuery($query." AND ".WM3_cCONFIG_DB_PREFIX."_market_announcements.announcementID = '$announcementID'");

     // Create list header
     $_CONTENTS = array();
	 $_SEP = $w3->getSkinObj()->getSeparator();
     require(WM3_cPATH_INCLUDE."admin_market_search_form.inc");
     if($admin) array_push($_CONTENTS,"<a href=\"$base_link\">".$w3->getWord(1702)."</a>");
     else       array_push($_CONTENTS,"<a href=\"$base_link$page_link\">".$w3->getWord(1702)."</a>");
     if($subcategoryID)
      {
	   $_PSEP = $w3->getSkinObj()->getPathSeparator();
       if($admin) array_push($_CONTENTS," $_PSEP <a href=\"".$base_link."&categoryID=$categoryID&action=".WM3_cACTION_SHOW_MARKET_SUBCATEGORY."\">".wm3Market::getMarketCategoryName($w3,$categoryID)."</a>");
       else       array_push($_CONTENTS," $_PSEP <a href=\"".$base_link.$page_link."&categoryID=$categoryID&action=".WM3_cACTION_SHOW_MARKET_SUBCATEGORY."\">".wm3Market::getMarketCategoryName($w3,$categoryID)."</a>");
       if($admin) array_push($_CONTENTS," $_PSEP <a href=\"".$base_link.$id_link."&action=".WM3_cACTION_SHOW_MARKET_ANNOUNCEMENT."\">".wm3Market::getMarketSubcategoryName($w3,$subcategoryID)." ($total_items)</a>");
       else       array_push($_CONTENTS," $_PSEP <a href=\"".$base_link.$id_link.$page_link."&action=".WM3_cACTION_SHOW_MARKET_ANNOUNCEMENT."\">".wm3Market::getMarketSubcategoryName($w3,$subcategoryID)." ($total_items)</a>");
       if($admin) array_push($_CONTENTS," $_SEP ".wm3Util::actionButton($base_link.$id_link."&action=".WM3_cACTION_ADD_MARKET_ANNOUNCEMENT,"action_add.png","","",$w3->getWord(1687),0,16,16));
      }
	 if(!$admin) array_push($_CONTENTS," $_SEP ".wm3Util::actionButton(WM3_cCONFIG_HOME_FILE."?stage=".WM3_cSTAGE_USER."&section=".WM3_cSECTION_MARKET."&categoryID=$categoryID&action=".WM3_cACTION_ADD_MARKET_ANNOUNCEMENT,"action_add.png","","",$w3->getWord(1687),0,16,16));
     $str = wm3Section::makeHeaderList($w3,$_CONTENTS,$columns,$search_form);

     // Create list caption

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0) return $str.wm3Section::makeEmptyItemsList($w3,$columns,593);

     // Create list items
     $row = mysql_fetch_object($rs);
	 if(!$row) return $str.wm3Section::makeNotFoundItem($w3,$columns,false);
     $link = $base_link.$id_link.$search_link.$extra_link."&announcementID=$row->announcementID";
     if($allowed)
	  {
	   $allowed_link = $base_allowed_link."&announcementID=$row->announcementID";
       $button = wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_MARKET_ANNOUNCEMENT,"action_edit.png",$w3->getWord(178));
      }
	 else $button = "";
	 $date         = wm3Util::renderDate($w3,$row->ts,$w3->getHomeLanguage());
     $author       = wm3User::getUserLogin($row->userID);
	 $title        = "$button<b>$row->title</b> (<a href=\"xx\">$author</a>)";
	 $announcement = "$date<br><br><i>".wm3Util::renderContent($w3,$row->announcement,$row->render_mode)."</i>";
     $str .= wm3Section::makeItemList($w3,0,array(100),array($title),false);
	 $str .= wm3Section::makeItemList($w3,0,array(100),array($announcement),false);

     // Create list bottom
     if($total_items > 1) $bottom_content = wm3Util::makePagesNavigator(0,0,0,$base_link.$id_link.$search_link.$extra_link.$page_link."&action=".WM3_cACTION_SHOW_SINGLE_ANNOUNCEMENT,$rs_aux,"announcementID",$row->announcementID);
	 else $bottom_content = "";
     $str .= wm3Section::makeBottomList($w3,$columns,$bottom_content);

     return $str;
    }

   public static function getMarketAnnouncementName($announcementID)
    {
     $rs = wm3Sql::sqlQuery("SELECT name FROM ".WM3_cCONFIG_DB_PREFIX."_market_announcements
                             WHERE announcementID = '$announcementID'");
     $row = mysql_fetch_object($rs);
     return $row->name;
    }

  }

?>
