<?php

 // THIS FILE IS PART OF WEBMATIC3 (Webmatic cube)
 // www.valarsoft.com

 defined('WM3_cEXEC') or die('Denied');

 class wm3Section
  {
   // Variables
   private $allowed_section,$allow_category_description,$allow_subcategory_description;
   private $table_categories,$table_subcategories,$table_subcategories_count,$table_items_count,$field_items_count;
   private $category_form,$subcategory_form,$search_form;
   private $action_save_category,$action_update_category;
   private $action_show_subcategory,$action_add_subcategory;
   private $action_save_subcategory,$action_update_subcategory;
   private $action_show_items,$action_add_item,$action_search;
   private $action_disable_category,$action_enable_category,$action_edit_category,$action_delete_category;
   private $action_disable_subcategory,$action_enable_subcategory,$action_edit_subcategory,$action_delete_subcategory;   
   private $label_category_list_title,$label_subcategory_add,$label_item_add,$label_subcategories_count,$label_items_count;
   private $label_category_icon,$label_category_name,$label_category_info;
   private $label_subcategory_icon,$label_subcategory_name,$label_subcategory_info;
   private $label_add_category_title,$label_edit_category_title,$label_add_subcategory_title,$label_edit_subcategory_title;
   private $extra_buttons;

   function __construct() { }

   public function setParameters($_P)
    {
     // Parameters with default values
     if(isset($_P['allowed_section'])) $this->allowed_section = $_P['allowed_section'];
     else                              $this->allowed_section = 0;

     if(isset($_P['allow_category_description']))    $this->allow_category_description    = $_P['allow_category_description'];
     else                                            $this->allow_category_description    = false;
     if(isset($_P['allow_subcategory_description'])) $this->allow_subcategory_description = $_P['allow_subcategory_description'];
     else                                            $this->allow_subcategory_description = false;

     if(isset($_P['table_items_count'])) $this->table_items_count = $_P['table_items_count'];
     else                                $this->table_items_count = '';
     if(isset($_P['field_items_count'])) $this->field_items_count = $_P['field_items_count'];
     else                                $this->field_items_count = 'subcategoryID';

     if(isset($_P['subcategory_form'])) $this->subcategory_form = $_P['subcategory_form'];
     else                               $this->subcategory_form = '';
     if(isset($_P['search_form']))      $this->search_form = $_P['search_form'];
     else                               $this->search_form = '';

     if(isset($_P['action_save_subcategory']))    $this->action_save_subcategory    = $_P['action_save_subcategory'];
     else                                         $this->action_save_subcategory    = '';
     if(isset($_P['action_update_subcategory']))  $this->action_update_subcategory  = $_P['action_update_subcategory'];
     else                                         $this->action_update_subcategory  = '';
     if(isset($_P['action_show_items']))          $this->action_show_items          = $_P['action_show_items'];
     else                                         $this->action_show_items          = '';
     if(isset($_P['action_add_item']))            $this->action_add_item            = $_P['action_add_item'];
     else                                         $this->action_add_item            = '';
     if(isset($_P['action_disable_subcategory'])) $this->action_disable_subcategory = $_P['action_disable_subcategory'];
     else                                         $this->action_disable_subcategory = '';
     if(isset($_P['action_enable_subcategory']))  $this->action_enable_subcategory  = $_P['action_enable_subcategory'];
     else                                         $this->action_enable_subcategory  = '';
     if(isset($_P['action_edit_subcategory']))    $this->action_edit_subcategory    = $_P['action_edit_subcategory'];
     else                                         $this->action_edit_subcategory    = '';
     if(isset($_P['action_delete_subcategory']))  $this->action_delete_subcategory  = $_P['action_delete_subcategory'];
     else                                         $this->action_delete_subcategory  = '';

     if(isset($_P['label_category_icon']))          $this->label_category_icon          = $_P['label_category_icon'];
     else                                           $this->label_category_icon          = 1670;
     if(isset($_P['label_category_name']))          $this->label_category_name          = $_P['label_category_name'];
     else                                           $this->label_category_name          = 1045;
     if(isset($_P['label_category_info']))          $this->label_category_info          = $_P['label_category_info'];
     else                                           $this->label_category_info          = 1671;
     if(isset($_P['label_subcategory_icon']))       $this->label_subcategory_icon       = $_P['label_subcategory_icon'];
     else                                           $this->label_subcategory_icon       = 1670;
     if(isset($_P['label_subcategory_name']))       $this->label_subcategory_name       = $_P['label_subcategory_name'];
     else                                           $this->label_subcategory_name       = 1045;
     if(isset($_P['label_subcategory_info']))       $this->label_subcategory_info       = $_P['label_subcategory_info'];
     else                                           $this->label_subcategory_info       = 1671;
     if(isset($_P['label_items_count']))            $this->label_items_count            = $_P['label_items_count'];
     else                                           $this->label_items_count            = 0;
     if(isset($_P['label_item_add']))               $this->label_item_add               = $_P['label_item_add'];
     else                                           $this->label_item_add               = 0;
     if(isset($_P['label_add_category_title']))     $this->label_add_category_title     = $_P['label_add_category_title'];
     else                                           $this->label_add_category_title     = 649;
     if(isset($_P['label_edit_category_title']))    $this->label_edit_category_title    = $_P['label_edit_category_title'];
     else                                           $this->label_edit_category_title    = 653;
     if(isset($_P['label_add_subcategory_title']))  $this->label_add_subcategory_title  = $_P['label_add_subcategory_title'];
     else                                           $this->label_add_subcategory_title  = 1666;
     if(isset($_P['label_edit_subcategory_title'])) $this->label_edit_subcategory_title = $_P['label_edit_subcategory_title'];
     else                                           $this->label_edit_subcategory_title = 663;
     if(isset($_P['extra_button_action']))          $this->extra_button_action          = $_P['extra_button_action'];
     else                                           $this->extra_button_action          = 0;
     if(isset($_P['extra_button_icon']))            $this->extra_button_icon            = $_P['extra_button_icon'];
     else                                           $this->extra_button_icon            = '';
     if(isset($_P['extra_button_label']))           $this->extra_button_label           = $_P['extra_button_label'];
     else                                           $this->extra_button_label           = 0;

     // Parameters without a default value
     $this->table_categories          = $_P['table_categories'];
     $this->table_subcategories       = $_P['table_subcategories'];
     $this->table_subcategories_count = $_P['table_subcategories_count'];

     $this->category_form             = $_P['category_form'];
     
     $this->action_save_category      = $_P['action_save_category'];
     $this->action_update_category    = $_P['action_update_category'];
     $this->action_show_subcategory   = $_P['action_show_subcategory'];
     $this->action_add_subcategory    = $_P['action_add_subcategory'];
     $this->action_disable_category   = $_P['action_disable_category'];
     $this->action_enable_category    = $_P['action_enable_category'];
     $this->action_edit_category      = $_P['action_edit_category'];
     $this->action_delete_category    = $_P['action_delete_category'];
     $this->action_search             = $_P['action_search'];     

     $this->label_category_list_title = $_P['label_category_list_title'];
     $this->label_subcategory_add     = $_P['label_subcategory_add'];
     $this->label_subcategories_count = $_P['label_subcategories_count'];
    }

   protected function getCategoryFieldsArray()
    {
     if($this->allow_category_description) return array('categoryID','name','description','icon','enabled','languageID','ts');
     else                                  return array('categoryID','name','icon','enabled','languageID','ts');
    }

   protected function getSubcategoryFieldsArray()
    {
     if($this->allow_subcategory_description) return array('subcategoryID','categoryID','name','description','icon','enabled','languageID','ts');
     else                                     return array('subcategoryID','categoryID','name','icon','enabled','languageID','ts');
    }

   protected function getCategoryList($w3,$currentID,$admin,$no_icon = false,$no_allowed = false,$base_link = "",$no_page_link = false,$show_subcategories = false,$folder_style = false,$no_header = false,$simple_counter = false,$alternate_search_form = "",$all_language = false)
    {
     // Get generic category list (admin and home side)
     
     // Prepare variables to create the list
     if($no_allowed) $allowed = false;
     else            $allowed = wm3User::checkAdminPermission($w3,$this->allowed_section); // Used to enable admin buttons in home stage
     if($all_language) $language_filter = "AND (languageID = '".$w3->getHomeLanguage()."' OR languageID = '".WM3_cLANGUAGE_ALL."')";
	 else              $language_filter = "AND languageID = '".$w3->getHomeLanguage()."'";
     $page_link  = "";
     if($admin) {
                 if(!$base_link)
                  $base_link  = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     	         $width_name = 60;
     	         $columns = 7; $buttons = 4;
     	        }
     else       {
                 if(!$base_link)
     	          $base_link  = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection(); 
     	         if(!$no_page_link) $page_link  = "&pageID=".$w3->getVariable('pageID','get');
     	         $width_name = 100;
     	         if($allowed) { $columns = 3; $buttons = 1; } else { $columns = 2; $buttons = 0; }
     	        }
     if($no_icon) $columns -= 1;
     if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=$this->allowed_section";
     if($this->search_form) {
     	                     $filter = $w3->getVariable('filter','both'); // Search field
     	                     $categoryID = $w3->getVariable('categoryID','both');
     	                     $subcategoryID = 0; // If a search form with category->subcategory select its used
     	                     if($admin) $search_form_link = WM3_cCONFIG_ADMIN_FILE."?action=$this->action_search";
     	                     else       $search_form_link = WM3_cCONFIG_HOME_FILE."?action=$this->action_search$page_link";
     	                    }

     // Do the query
     if($admin) $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX.$this->table_categories."
                                        ORDER BY name");
     else       $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX.$this->table_categories."
                                        WHERE enabled = '".WM3_cENABLED."' $language_filter
                                        ORDER BY name");
     $total_items = mysql_num_rows($rs);

     // Create list header
     $_CONTENTS = array();
     if($no_header) $str = wm3Section::makeHeaderList($w3,$_CONTENTS,$columns);
     else
      {
       if($this->search_form) require(WM3_cPATH_INCLUDE.$this->search_form); else $search_form = "";
       array_push($_CONTENTS,$w3->getWord($this->label_category_list_title));
	   if(!$admin) if($this->extra_button_action) array_push($_CONTENTS," ".$w3->getSkinObj()->getSeparator()." ".wm3Util::actionButton($base_link.$page_link."&action=".$this->extra_button_action,$this->extra_button_icon,"","",$w3->getWord($this->extra_button_label),0,16,16));
       $str = wm3Section::makeHeaderList($w3,$_CONTENTS,$columns,$search_form);
      }

     // Create list caption
     if($admin) $str .= wm3Section::makeCaptionList($w3,array(0,$width_name,40,0),array($this->label_category_icon,$this->label_category_name,$this->label_category_info,0),$buttons);

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0) return $str.wm3Section::makeEmptyItemsList($w3,$columns,593);

     // Create list items
     $p = 0;
     while($row = mysql_fetch_object($rs))
      {
       $_CONTENTS = array(); $_WIDTHS = array();
       $link = $base_link.$page_link."&categoryID=$row->categoryID";
	   if($allowed) $allowed_link = $base_allowed_link."&categoryID=$row->categoryID";
       if(!$no_icon) { array_push($_CONTENTS,"<a href=\"$link&action=$this->action_show_subcategory\"><img src=\"".WM3_cPATH_ICONS."$row->icon\" width=\"36\" height=\"36\" border=\"0\"></a>"); array_push($_WIDTHS,0); }
       if(!$this->table_items_count) {
                                      if($admin) $counter = wm3Section::makeCounterCategorySub($w3,$this->table_subcategories_count,$this->label_subcategories_count,$row->categoryID,"",$simple_counter);
                                      else       $counter = wm3Section::makeCounterCategorySub($w3,$this->table_subcategories_count,$this->label_subcategories_count,$row->categoryID," AND enabled = '".WM3_cENABLED."' $language_filter",$simple_counter);
                                     }
       else                          {
                                      if($admin) $counter = wm3Section::makeCounterCategorySubItem($w3,$this->table_subcategories_count,$this->table_items_count,$this->label_subcategories_count,$this->label_items_count,$row->categoryID,$this->field_items_count,"",$simple_counter);
                                      else       $counter = wm3Section::makeCounterCategorySubItem($w3,$this->table_subcategories_count,$this->table_items_count,$this->label_subcategories_count,$this->label_items_count,$row->categoryID,$this->field_items_count," AND enabled = '".WM3_cENABLED."' $language_filter",$simple_counter);
                                     }
       if($simple_counter) $name = "<a href=\"$link&action=$this->action_show_subcategory\">$row->name $counter</a>";
       else                $name = "<a href=\"$link&action=$this->action_show_subcategory\">$row->name</a><br>$counter";       
       if($this->allow_category_description) $name .= "<p class=\"iTxt\">$row->description</p>";
       array_push($_CONTENTS,$name); array_push($_WIDTHS,$width_name);
       if($admin)
        {
         $lang_flag = "<img src=\"".WM3_cPATH_DATA.wm3Language::getFlag($row->languageID)."\" width=\"19\" height=\"13\" align=\"middle\">";
         array_push($_CONTENTS,$lang_flag); array_push($_WIDTHS,40);
         // Buttons
         array_push($_CONTENTS,wm3Util::actionButton("$link&action=$this->action_add_subcategory","action_add_from.png",$w3->getWord($this->label_subcategory_add)));
         if($row->enabled) array_push($_CONTENTS,wm3Util::actionButton("$link&action=$this->action_disable_category","action_disable.png",$w3->getWord(180)));
         else              array_push($_CONTENTS,wm3Util::actionButton("$link&action=$this->action_enable_category","action_enable.png",$w3->getWord(181)));
         array_push($_CONTENTS,wm3Util::actionButton("$link&action=$this->action_edit_category","action_edit.png",$w3->getWord(178)));
         array_push($_CONTENTS,wm3Util::actionButton("$link&action=$this->action_delete_category","action_delete.png",$w3->getWord(179),$w3->getWord(702)));
        }
       else
        {
         if($allowed) array_push($_CONTENTS,wm3Util::actionButton("$allowed_link&action=$this->action_edit_category","action_edit.png",$w3->getWord(178)));
        }
       $str .= wm3Section::makeItemList($w3,$p,$_WIDTHS,$_CONTENTS,$row->categoryID==$currentID);
       // Show also subcategories when select a category (if requested)
       if($show_subcategories)
        if($row->categoryID == $currentID)
         $str .= wm3Section::makeItemList($w3,0,array(100),array(wm3Section::getSubcategoryList($w3,$w3->getVariable('subcategoryID','both'),$admin,$no_icon,$no_allowed,$base_link,$no_page_link,$folder_style,$no_header,$simple_counter,$all_language)),false);
       $p++;
      }

     // Create the list bottom
     $str .= wm3Section::makeBottomList($w3,$columns,$alternate_search_form);

     return $str;
    }

   protected function getSubcategoryList($w3,$currentID,$admin,$no_icon = false,$no_allowed = false,$base_link = "",$no_page_link = false,$folder_style = false,$no_header = false,$simple_counter = false,$all_language = false)
    {
     // Get generic subcategory list (admin and home side)   

     // Prepare variables to create the list
     if($folder_style) $no_icon = false;// todo verificare
     if($no_allowed) $allowed = false;
     else            $allowed = wm3User::checkAdminPermission($w3,$this->allowed_section); // Used to enable admin buttons in home stage
     if($all_language)
	  {
	   $language_filter = "AND (".WM3_cCONFIG_DB_PREFIX."$this->table_subcategories.languageID='".$w3->getHomeLanguage()."' OR ".WM3_cCONFIG_DB_PREFIX."$this->table_subcategories.languageID='".WM3_cLANGUAGE_ALL."')";
       $language_filter_count = "AND (languageID = '".$w3->getHomeLanguage()."' OR languageID = '".WM3_cLANGUAGE_ALL."')";
      }
	 else
	  {
	   $language_filter = "AND ".WM3_cCONFIG_DB_PREFIX."$this->table_subcategories.languageID='".$w3->getHomeLanguage()."'";
	   $language_filter_count = "AND languageID = '".$w3->getHomeLanguage()."'";
      }
     $page_link  = "";
     $categoryID = $w3->getVariable('categoryID','both');
     if($categoryID) $query_filter = " AND ".WM3_cCONFIG_DB_PREFIX."$this->table_subcategories.categoryID = '$categoryID'"; else $query_filter = "";
     if($admin) {
     	         if(!$base_link)
     	          $base_link  = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     	         $id_link    = "&categoryID=$categoryID";
     	         $width_name = 60;
     	         $columns = 7; $buttons = 4;
     	        }
     else       {
                 if(!$base_link)
      	          $base_link  = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     	         $id_link    = "&categoryID=$categoryID";
     	         if(!$no_page_link) $page_link  = "&pageID=".$w3->getVariable('pageID','get');
     	         $width_name = 100;
                 $query_filter .= " AND ".WM3_cCONFIG_DB_PREFIX."$this->table_subcategories.enabled*".WM3_cCONFIG_DB_PREFIX."$this->table_categories.enabled='".WM3_cENABLED."' $language_filter";
     	         if($allowed) { $columns = 3; $buttons = 1; } else { $columns = 2; $buttons = 0; }
     	        }
     if($no_icon) $columns -= 1;
     if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=$this->allowed_section";
     if($this->search_form) {
     	                     $filter = $w3->getVariable('filter','both'); // Search field
     	                     $subcategoryID = $w3->getVariable('subcategoryID','both');
     	                     if($admin) $search_form_link = WM3_cCONFIG_ADMIN_FILE."?action=$this->action_search";
     	                     else       $search_form_link = WM3_cCONFIG_HOME_FILE."?action=$this->action_search$id_link$page_link";
     	                    }
     // Do the query
     $rs = wm3Sql::sqlQuery("SELECT   ".WM3_cCONFIG_DB_PREFIX."$this->table_categories.enabled,".WM3_cCONFIG_DB_PREFIX."$this->table_subcategories.*
                             FROM     ".WM3_cCONFIG_DB_PREFIX."$this->table_categories,".WM3_cCONFIG_DB_PREFIX."$this->table_subcategories
                             WHERE    ".WM3_cCONFIG_DB_PREFIX."$this->table_categories.categoryID=".WM3_cCONFIG_DB_PREFIX."$this->table_subcategories.categoryID
                             $query_filter
                             ORDER BY ".WM3_cCONFIG_DB_PREFIX."$this->table_subcategories.name DESC");
     $total_items = mysql_num_rows($rs);

     // Create list header
     $_CONTENTS = array();
     if($no_header) $str = wm3Section::makeHeaderList($w3,$_CONTENTS,$columns);
     else
      {
       $_PSEP = $w3->getSkinObj()->getPathSeparator();
       if($this->search_form) require(WM3_cPATH_INCLUDE.$this->search_form); else $search_form = "";
       array_push($_CONTENTS,"<a href=\"$base_link$page_link\">".$w3->getWord($this->label_category_list_title)."</a>");
       if($admin) array_push($_CONTENTS," $_PSEP <a href=\"".$base_link.$id_link."&action=".$this->action_show_subcategory."\">".wm3Section::getCategoryName($categoryID,$this->table_categories)."</a>");
       else       array_push($_CONTENTS," $_PSEP <a href=\"".$base_link.$id_link.$page_link."&action=".$this->action_show_subcategory."\">".wm3Section::getCategoryName($categoryID,$this->table_categories)."</a>");
       if($admin) array_push($_CONTENTS," ".$w3->getSkinObj()->getSeparator()." ".wm3Util::actionButton($base_link.$id_link."&action=$this->action_add_subcategory","action_add.png","","",$w3->getWord($this->label_subcategory_add),0,16,16));
       $str = wm3Section::makeHeaderList($w3,$_CONTENTS,$columns,$search_form);
      }

     // Create list caption
     if($admin) $str .= wm3Section::makeCaptionList($w3,array(0,$width_name,40,0),array($this->label_subcategory_icon,$this->label_subcategory_name,$this->label_subcategory_info,0),$buttons);

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0) return $str.wm3Section::makeEmptyItemsList($w3,$columns,593);

     // Create list items
     $p = 0;
     while($row = mysql_fetch_object($rs))
      {
       $_CONTENTS = array(); $_WIDTHS = array();
       $link = $base_link.$id_link.$page_link."&subcategoryID=$row->subcategoryID";
	   if($allowed) $allowed_link = $base_allowed_link.$id_link."&subcategoryID=$row->subcategoryID";
       if(!$no_icon) {
                      if($folder_style) array_push($_CONTENTS,"<a href=\"$link&action=$this->action_show_items\"><img src=\"".WM3_cPATH_DATA."misc_folder.png\" width=\"36\" height=\"36\" border=\"0\"></a>");
                      else              array_push($_CONTENTS,"<a href=\"$link&action=$this->action_show_items\"><img src=\"".WM3_cPATH_ICONS."$row->icon\"    width=\"36\" height=\"36\" border=\"0\"></a>");
                      array_push($_WIDTHS,0);
                     }
       if($admin) $counter = wm3Section::makeCounterSubcategoryItem($w3,$this->table_items_count,$this->label_items_count,$row->subcategoryID,"",$simple_counter);
       else       $counter = wm3Section::makeCounterSubcategoryItem($w3,$this->table_items_count,$this->label_items_count,$row->subcategoryID," AND enabled = '".WM3_cENABLED."' $language_filter_count",$simple_counter);
       if($simple_counter) {
		                    $_PSEP = $w3->getSkinObj()->getPathSeparator();
	                        $name = "<a href=\"$link&action=$this->action_show_items\">$_PSEP $row->name $counter</a>";
						   }
       else                {
		                    $name = "<a href=\"$link&action=$this->action_show_items\">$row->name</a><br>$counter";
						   }
       if($this->allow_subcategory_description) $name .= "<p class=\"iTxt\">$row->description</p>";
       array_push($_CONTENTS,$name); array_push($_WIDTHS,$width_name);

       if($admin)
        {
         $lang_flag = "<img src=\"".WM3_cPATH_DATA.wm3Language::getFlag($row->languageID)."\" width=\"19\" height=\"13\" align=\"middle\">";
         array_push($_CONTENTS,$lang_flag); array_push($_WIDTHS,40);
         // Buttons
         array_push($_CONTENTS,wm3Util::actionButton("$link&action=$this->action_add_item","action_add_from.png",$w3->getWord($this->label_item_add)));
         if($row->enabled) array_push($_CONTENTS,wm3Util::actionButton("$link&action=$this->action_disable_subcategory","action_disable.png",$w3->getWord(180)));
         else              array_push($_CONTENTS,wm3Util::actionButton("$link&action=$this->action_enable_subcategory","action_enable.png",$w3->getWord(181)));
         array_push($_CONTENTS,wm3Util::actionButton("$link&action=$this->action_edit_subcategory","action_edit.png",$w3->getWord(178)));
         array_push($_CONTENTS,wm3Util::actionButton("$link&action=$this->action_delete_subcategory","action_delete.png",$w3->getWord(179),$w3->getWord(702)));
        }
       else
        {
         if($allowed) array_push($_CONTENTS,wm3Util::actionButton("$allowed_link&action=$this->action_edit_subcategory","action_edit.png",$w3->getWord(178)));
        }
       $str .= wm3Section::makeItemList($w3,$p,$_WIDTHS,$_CONTENTS,$row->subcategoryID==$currentID);
       $p++;
      }

     // Create the list bottom     
     $str .= wm3Section::makeBottomList($w3,$columns);

     return $str;
    }

   protected function checkCategoryError($w3)
    {
     // Check form invalid inputs
     $_FIELD = webmatic3::getPostValueArray($this->getCategoryFieldsArray());
     if(!$_FIELD['name']) return 1;
     return 0;
    }

   protected function checkSubcategoryError($w3)
    {
     // Check form invalid inputs
     $_FIELD = webmatic3::getPostValueArray($this->getSubcategoryFieldsArray());
     if(!$_FIELD['name']) return 1;
	 if(!$this->existsCategory($_FIELD['categoryID'])) return 2;
     return 0;
    }

   protected function addCategory($w3,$error)
    {
     // Make a generic category form to add a new category
     
     // Take variables value from db and set correct fields and form style
     $_FIELD = webmatic3::getPostValueArray($this->getCategoryFieldsArray());
     $_STYLE = wm3Skin::getFormStyleArray($this->getCategoryFieldsArray());
     // Fields for paging default value
     $pg = $filter = "";
     switch($error)
      {
       case 1: // Empty category name 
        {
         $_STYLE['name']           = "class=\"adminFormError\"";
         $_STYLE['adminFormTitle'] = "class=\"adminFormTitleError\"";
         $form_title = $w3->getWord(8);
         break;
        }
       default:
        {
         // Default values for the form
         $_FIELD['enabled'] = WM3_cENABLED;
         $_STYLE['adminFormTitle'] = "class=\"adminFormTitle\"";
         $form_title = $w3->getWord($this->label_add_category_title);
       	}
      }
     $preview_image      = $_FIELD['icon']; if(!$preview_image) $preview_image = wm3Util::getFirstFile(WM3_cPATH_ICONS); // Set due preview image
     $next_action       = $this->action_save_category;
     $next_action_label = $w3->getWord(191);
     require(WM3_cPATH_INCLUDE.$this->category_form);
     return $admin_content;
    }

   protected function addSubcategory($w3,$error)
    {
     // Make a generic subcategory form to add a new subcategory

     // Take variables value and set correct form style    
     $_STYLE = wm3Skin::getFormStyleArray($this->getSubcategoryFieldsArray());
     $_FIELD = webmatic3::getPostValueArray($this->getSubcategoryFieldsArray());
     // Fields for paging default value
     $pg = $filter = "";
     switch($error)
      {
       case 1: // Empty subcategory name 
        {
         $_STYLE['name']           = "class=\"adminFormError\"";
         $_STYLE['adminFormTitle'] = "class=\"adminFormTitleError\"";
         $form_title = $w3->getWord(8);
         break;
        }
       case 2: // Category do not exists
        {
         $_STYLE['categoryID']     = "class=\"adminFormError\"";
         $_STYLE['adminFormTitle'] = "class=\"adminFormTitleError\"";
         $form_title = $w3->getWord(-1)."catgory not found...TODO";
         break;
        }
       default:
        {
         // Default values for the form
         $_FIELD['categoryID']     = $w3->getVariable('categoryID','get'); // Take categoryID from get
         $_FIELD['enabled']        = WM3_cENABLED;
         $_STYLE['adminFormTitle'] = "class=\"adminFormTitle\"";
         $form_title = $w3->getWord($this->label_add_subcategory_title);
       	}
      }
     $preview_image      = $_FIELD['icon']; if(!$preview_image) $preview_image = wm3Util::getFirstFile(WM3_cPATH_ICONS); // Set due preview image
     $next_action       = $this->action_save_subcategory;
     $next_action_label = $w3->getWord(191);
     require(WM3_cPATH_INCLUDE.$this->subcategory_form);
     return $admin_content;
    }

   protected function editCategory($w3,$error)
    {
     // Make generic category form to edit a category

     // Take variables value from db and set correct fields and form style
     if(!$error)
      {
       $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX.$this->table_categories."
                               WHERE categoryID = '".$w3->getVariable('categoryID','get')."'");
       $row = mysql_fetch_object($rs);
	   if(!$row) return wm3Section::makeNotFoundItem($w3);
       $_FIELD = webmatic3::getRowValueArray($this->getCategoryFieldsArray(),$row);
      }
     else $_FIELD = webmatic3::getPostValueArray($this->getCategoryFieldsArray());

     $_STYLE = wm3Skin::getFormStyleArray($this->getCategoryFieldsArray());
     switch($error)
      {
       case 1: // Empty category name
        {
         $_STYLE['name']           = "class=\"adminFormError\"";
         $_STYLE['adminFormTitle'] = "class=\"adminFormTitleError\"";
         $form_title = $w3->getWord(8);
         break;
        }
       default:
        {
         $_STYLE['adminFormTitle'] = "class=\"adminFormTitle\"";
         $form_title = $w3->getWord($this->label_edit_category_title);
       	}
      }
     $preview_image      = $_FIELD['icon'];
     $next_action       = $this->action_update_category;
     $next_action_label = $w3->getWord(29);
     require(WM3_cPATH_INCLUDE.$this->category_form);
     return $admin_content;
    }

   protected function editSubcategory($w3,$error)
    {
     // Make generic subcategory form to edit a subcategory
     
     // Take variables value from db and set correct form style
     if(!$error)
      {
       $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX.$this->table_subcategories."
                               WHERE subcategoryID = '".$w3->getVariable('subcategoryID','get')."'");
       $row = mysql_fetch_object($rs);
	   if(!$row) return wm3Section::makeNotFoundItem($w3);
       $_FIELD = webmatic3::getRowValueArray($this->getSubcategoryFieldsArray(),$row);
      }
     else $_FIELD = webmatic3::getPostValueArray($this->getSubcategoryFieldsArray());

     $_STYLE = wm3Skin::getFormStyleArray($this->getSubcategoryFieldsArray());
     switch($error)
      {
       case 1: // Empty subcategory name
        {
         $_STYLE['name']           = "class=\"adminFormError\"";
         $_STYLE['adminFormTitle'] = "class=\"adminFormTitleError\"";
         $form_title = $w3->getWord(8);
         break;
        }
       case 2: // Category do not exists
        {
         $_STYLE['categoryID']     = "class=\"adminFormError\"";
         $_STYLE['adminFormTitle'] = "class=\"adminFormTitleError\"";
         $form_title = $w3->getWord(-1)."catgory not found...TODO";
         break;
        }
       default:
        {
         $_STYLE['adminFormTitle'] = "class=\"adminFormTitle\"";
         $form_title = $w3->getWord($this->label_edit_subcategory_title);
       	}
      }
     $preview_image      = $_FIELD['icon'];
     $next_action       = $this->action_update_subcategory;
     $next_action_label = $w3->getWord(29);
     require(WM3_cPATH_INCLUDE.$this->subcategory_form);
     return $admin_content;
    }

   protected function saveCategory($w3)
    {
     $_FIELD = webmatic3::getPostValueArray($this->getCategoryFieldsArray(),WM3_cQUOTE_DB);
     $_FIELD['ts'] = time();
     wm3Sql::saveAllTableFields($this->table_categories,$_FIELD);
     return wm3Sql::getLastInsertID();
    }

   protected function saveSubcategory($w3)
    {
     $_FIELD = webmatic3::getPostValueArray($this->getSubcategoryFieldsArray(),WM3_cQUOTE_DB);
     $_FIELD['ts'] = time();
     wm3Sql::saveAllTableFields($this->table_subcategories,$_FIELD);
     return wm3Sql::getLastInsertID();
    }

   protected function updateCategory($w3)
    {
     $_FIELD = webmatic3::getPostValueArray($this->getCategoryFieldsArray(),WM3_cQUOTE_DB);
     if($this->allow_category_description) $extra_query = "description = '".$_FIELD['description']."',";
     else                                  $extra_query = "";
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX.$this->table_categories."
                       SET   name       = '".$_FIELD['name']."',
                             $extra_query
                             icon       = '".$_FIELD['icon']."',
                             enabled    = '".$_FIELD['enabled']."',
                             languageID = '".$_FIELD['languageID']."'
                       WHERE categoryID = '".$_FIELD['categoryID']."'");
     return $_FIELD['categoryID'];
    }

   protected function updateSubcategory($w3)
    {
     $_FIELD = webmatic3::getPostValueArray($this->getSubcategoryFieldsArray(),WM3_cQUOTE_DB);
     if($this->allow_subcategory_description) $extra_query = "description = '".$_FIELD['description']."',";
     else                                     $extra_query = "";     
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX.$this->table_subcategories."
                       SET   categoryID    = '".$_FIELD['categoryID']."',
                             name          = '".$_FIELD['name']."',
                             $extra_query
                             icon          = '".$_FIELD['icon']."',
                             enabled       = '".$_FIELD['enabled']."',
                             languageID    = '".$_FIELD['languageID']."'
                       WHERE subcategoryID = '".$_FIELD['subcategoryID']."'");
     return $_FIELD['subcategoryID'];
    }

   protected function deleteCategory($categoryID,$sub_id_field = 'subcategoryID')
    {
	 if(!$this->table_items_count) // Without subcategories
	  {
	   wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX.$this->table_categories." WRITE,
	                                 ".WM3_cCONFIG_DB_PREFIX.$this->table_subcategories." WRITE");
	   wm3Sql::sqlQuery("DELETE FROM ".WM3_cCONFIG_DB_PREFIX.$this->table_subcategories." WHERE categoryID = '$categoryID'");
       wm3Sql::sqlQuery("DELETE FROM ".WM3_cCONFIG_DB_PREFIX.$this->table_categories." WHERE categoryID = '$categoryID'");
	   wm3Sql::sqlQuery("UNLOCK TABLES");
      }
     else // With subcategories
	  {
	   wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX.$this->table_categories." WRITE,
	                                 ".WM3_cCONFIG_DB_PREFIX.$this->table_subcategories." WRITE,
									 ".WM3_cCONFIG_DB_PREFIX.$this->table_items_count." WRITE");
	   $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX.$this->table_subcategories." WHERE categoryID = '$categoryID'");
	   while($row = mysql_fetch_object($rs))
	    {
	     wm3Sql::sqlQuery("DELETE FROM ".WM3_cCONFIG_DB_PREFIX.$this->table_items_count." WHERE $sub_id_field = '".$row->$sub_id_field."'");
	    }
	   wm3Sql::sqlQuery("DELETE FROM ".WM3_cCONFIG_DB_PREFIX.$this->table_subcategories." WHERE categoryID = '$categoryID'");
	   wm3Sql::sqlQuery("DELETE FROM ".WM3_cCONFIG_DB_PREFIX.$this->table_categories." WHERE categoryID = '$categoryID'");
	   wm3Sql::sqlQuery("UNLOCK TABLES");
      }

    }

   protected function deleteSubcategory($subcategoryID,$sub_id_field = 'subcategoryID')
    {
	 wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX.$this->table_categories." WRITE, ".WM3_cCONFIG_DB_PREFIX.$this->table_subcategories." WRITE, ".WM3_cCONFIG_DB_PREFIX.$this->table_items_count." WRITE");
	 wm3Sql::sqlQuery("DELETE FROM ".WM3_cCONFIG_DB_PREFIX.$this->table_items_count." WHERE $sub_id_field = '$subcategoryID'");
     wm3Sql::sqlQuery("DELETE FROM ".WM3_cCONFIG_DB_PREFIX.$this->table_subcategories." WHERE $sub_id_field = '$subcategoryID'");
	 wm3Sql::sqlQuery("UNLOCK TABLES");
    }

   protected function selectCategory($w3,$name,$categoryID,$all,$admin)
    {
     // Make category select
     if($admin) $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX.$this->table_categories);
     else       $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX.$this->table_categories."
                                        WHERE enabled='".WM3_cENABLED."' AND languageID='".$w3->getHomeLanguage()."'");
     $str = "<select name=\"$name\">";
     if($all) $str .= wm3Util::inputOption("All the categories",0); // TODO
     while($row = mysql_fetch_object($rs))
      {
       if($row->categoryID == $categoryID) $str .= wm3Util::inputOption($row->name,$row->categoryID,"selected");
       else                                $str .= wm3Util::inputOption($row->name,$row->categoryID);
      }
     $str .= "</select>";
     return $str;
    }

   protected function selectSubcategory($w3,$name,$subcategoryID,$all,$admin,$field = "name",$fieldID = "subcategoryID")
    {
     // Make a category->subcategory select
     //if($admin) TODO
     $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX.$this->table_categories."
                             ORDER BY name");
     $str = "<select name=\"$name\">";
     if($all) $str .= wm3Util::inputOption("All the categories",0); // TODO
     while($row = mysql_fetch_object($rs))
      {
       $sub_rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX.$this->table_subcategories."
                                   WHERE categoryID = '".$row->categoryID."'
                                   ORDER BY $field");
       while($sub_row = mysql_fetch_object($sub_rs))
        {
         if($sub_row->$fieldID == $subcategoryID) $str .= wm3Util::inputOption($row->name."->".$sub_row->$field,$sub_row->$fieldID,"selected");
         else                                     $str .= wm3Util::inputOption($row->name."->".$sub_row->$field,$sub_row->$fieldID);
        }
      }
     $str .= "</select>";
     return $str;
    }

   protected function getCategoryName($categoryID)
    {
     // Get category name from generic category
     $rs = wm3Sql::sqlQuery("SELECT name FROM ".WM3_cCONFIG_DB_PREFIX.$this->table_categories."
                             WHERE categoryID = '$categoryID'");
     if(mysql_num_rows($rs) != 1) return "";
     $row = mysql_fetch_object($rs);
     return $row->name;
    }

   protected function getSubcategoryName($subcategoryID, $field = "name", $fieldID = "subcategoryID")
    {
     // Get subcategory name from generic subcategory
     $rs = wm3Sql::sqlQuery("SELECT $field FROM ".WM3_cCONFIG_DB_PREFIX.$this->table_subcategories."
                             WHERE  $fieldID = '$subcategoryID'");
     if(mysql_num_rows($rs) != 1) return "";
     $row = mysql_fetch_object($rs);
     return $row->$field;
    }

   protected function getCategoryID($subcategoryID,$fieldID = 'subcategoryID')
    {
     // Get categoryID from generic subcategoryID
     $rs = wm3Sql::sqlQuery("SELECT categoryID FROM ".WM3_cCONFIG_DB_PREFIX.$this->table_subcategories."
                             WHERE  $fieldID = '$subcategoryID'");
     if(mysql_num_rows($rs) != 1) return 0;
     $row = mysql_fetch_object($rs);
     return $row->categoryID;
    }

   protected function getCategoryIcon($categoryID)
    {
     // Get category name from generic category
     $rs = wm3Sql::sqlQuery("SELECT icon FROM ".WM3_cCONFIG_DB_PREFIX.$this->table_categories."
                             WHERE categoryID = '$categoryID'");
     if(mysql_num_rows($rs) == 0) return "";
     $row = mysql_fetch_object($rs);
     return $row->icon;
    }

   protected function existsCategory($categoryID)
    {
     // Return true if the category with categoryID exists else return false
     $rs = wm3Sql::sqlQuery("SELECT categoryID FROM ".WM3_cCONFIG_DB_PREFIX.$this->table_categories."
                             WHERE  categoryID = '$categoryID'");
     if(mysql_num_rows($rs) == 1) return true;
	 else                         return false;
    }

   protected function existsSubcategory($subcategoryID,$sub_id_field = 'subcategoryID')
    {
     // Return true if the subcategory with subcategoryID exists else return false
     $rs = wm3Sql::sqlQuery("SELECT $sub_id_field FROM ".WM3_cCONFIG_DB_PREFIX.$this->table_subcategories."
                             WHERE  $sub_id_field = '$subcategoryID'");
     if(mysql_num_rows($rs) == 1) return true;
	 else                         return false;
    }

   public static function makeHeaderList($w3,$_CONTENTS,$columns,$search_form = '',$render_table = true)
    {
     // Create a generic header for a list

     $str = "";
     $n = sizeof($_CONTENTS);
 
     if($n == 0)
	  {
	   if($render_table) return "<table width=\"100%\" cellspacing=\"0\" cellpadding=\"0\" align=\"center\">";
	   else              return "";
      }
     if($render_table) $str .= "<table class=\"list\" width=\"100%\" cellspacing=\"0\" cellpadding=\"0\" align=\"center\">";
     $str .= "<tr class=\"listSearch\">
               <td class=\"listSearchTitle\" width=\"100%\" colspan=\"$columns\">";
     for($i = 0; $i < $n; $i++) $str .= $_CONTENTS[$i];
     $str .= "</td></tr>";
     if($search_form) $str .= "<tr class=\"listSearch\"><td class=\"listSearch\" colspan=\"$columns\">$search_form</td></tr>";
     return $str;
    }

   public static function makeCaptionList($w3,$_WIDTHS,$_LABELS,$buttons,$no_button = false)
    {
     // Create a generic caption for a list

     $n = sizeof($_WIDTHS)-1;
 
     $str =  "<tr class=\"listTitle\">";
     for($i = 0; $i <= $n; $i++)
      {
       if(!$no_button)
        {
         if($i != $n) $str .= "<td class=\"listTitle\" width=\"$_WIDTHS[$i]%\">".$w3->getWord($_LABELS[$i])."</td>";
         else         $str .= "<td class=\"listTitle\" width=\"$_WIDTHS[$i]%\" colspan=\"$buttons\">&nbsp;</td>";
        }
       else $str .= "<td class=\"listTitle\" width=\"$_WIDTHS[$i]%\">".$w3->getWord($_LABELS[$i])."</td>";
      }
     $str .= "</tr>";
     return $str;
    }

   public static function makeEmptyItemsList($w3,$columns,$label,$no_table = false)
    {
     // Create a generic item for an empty list
     $str = "<tr class=\"listEven\"><td class=\"listEven\" colspan=\"$columns\">".$w3->getWord($label)."</td></tr>";
     if($no_table) return $str;
     $str .= "</table>";
     return $str;
    }

   public function makeNotFoundItem($w3,$columns = 0,$only_label = true,$no_table = false,$label = 1217)
    {
	 // Create a generic not found item
	 if($only_label) return $w3->getWord($label);
	 $str = "<tr class=\"listEven\"><td class=\"listEven\" colspan=\"$columns\">".$w3->getWord($label)."</td></tr>";
	 if($no_table) return $str;
     $str .= "</table>";
     return $str;
    }

   public static function makeItemList($w3,$p,$_WIDTHS,$_CONTENTS,$highlighted,$override_css = '',$_COLSPAN = array())
    {
     // Create a generic item line for a list

     $nc = sizeof($_CONTENTS);
     $nw = sizeof($_WIDTHS);
     if($highlighted) $css_class = "listCurrent";
     else if($p%2 == 0) $css_class = "listEven"; else $css_class="listOdd";
     if($override_css) $css_class = $override_css;
     $str = "<tr class=\"$css_class\">";
     for($i = 0; $i < $nc; $i++)
      {
       $colspan = "";
       if(isset($_COLSPAN[$i]))
        if($_COLSPAN[$i] > 1) $colspan = "colspan=\"$_COLSPAN[$i]\"";
       if($i < $nw) $str .= "<td class=\"$css_class\" $colspan width=\"$_WIDTHS[$i]%\">$_CONTENTS[$i]</td>";
       else         $str .= "<td class=\"$css_class\" $colspan>$_CONTENTS[$i]</td>";
      }
     $str .= "</tr>";
     return $str;
    }

   public static function makeBottomList($w3,$columns,$content="")
    {
     // Create a generic bottom for a list
     
     if(!$content) return "</table>";
     $str = "<tr class=\"listBottom\"><td class=\"listBottom\" colspan=\"$columns\">$content</td></tr>";
     $str .= "</table>";
     return $str;
    }

   private static function makeCounterCategorySub($w3,$table,$label,$categoryID,$filter = "",$simple_counter = false)
    {
     // Get the number of subcategory in a category and return a formatted string for output
     $total = wm3Sql::countTable(WM3_cCONFIG_DB_PREFIX.$table,"WHERE categoryID = '$categoryID'$filter");
     if($total == 1) $label = $w3->getWord($label);
     else            $label = $w3->getWord($label+1);
     if($simple_counter) return "($total)"; return "($total $label)";
    }

   private static function makeCounterCategorySubItem($w3,$table,$sub_table,$label,$sub_label,$categoryID,$field_items_count,$filter = "",$simple_counter = false)
    {
     // Get the number of subcategory and item in a category and return a formatted string for output
     $total     = wm3Sql::countTable(WM3_cCONFIG_DB_PREFIX.$table,"WHERE categoryID = '$categoryID'$filter");
     if($total != 1) $label = $w3->getWord($label); else $label = $w3->getWord($label+1);
     
     // TODO aggiustare la query del counter di secondo livello (sub_total)
     $sub_total = wm3Sql::countTable(WM3_cCONFIG_DB_PREFIX.$sub_table,"WHERE $field_items_count = '$categoryID'");
     if($sub_total != 1) $sub_label = $w3->getWord($sub_label); else $sub_label = $w3->getWord($sub_label+1);
     
     if($simple_counter) return "($sub_total)"; return "($total $label, $sub_total $sub_label)";
    }

   private static function makeCounterSubcategoryItem($w3,$table,$label,$subcategoryID,$filter = "",$simple_counter = false)
    {
     // Get the number of item in a subcategory and return a formatted string for output
     $total = wm3Sql::countTable(WM3_cCONFIG_DB_PREFIX.$table,"WHERE subcategoryID = '$subcategoryID'$filter");
     $label = $w3->getWord($label);
     if($simple_counter) return "($total)"; else return "($total $label)";
    }

   public static function isActionPrintable($w3)
    {
	 // Return true if a printable action is performed
	 if($w3->getStage()   == WM3_cSTAGE_HOME                    &&
	    $w3->getSection() == WM3_cSECTION_NEWS                  &&
	    $w3->getAction()  == WM3_cACTION_PRINTABLE_SINGLE_NEWS) return true;
	 if($w3->getStage()   == WM3_cSTAGE_HOME                                 &&
	    $w3->getSection() == WM3_cSECTION_HOME                               &&
	    $w3->getAction()  == WM3_cACTION_PRINTABLE_SINGLE_ECOMMERCE_PRODUCT) return true;
	 if($w3->getStage()   == WM3_cSTAGE_ADMIN                       &&
	    $w3->getSection() == WM3_cSECTION_ECOMMERCE                 &&
	    $w3->getAction()  == WM3_cACTION_PRINTABLE_ECOMMERCE_ORDER) return true;
	 return false;
	}

  }

?>
