<?php

 // THIS FILE IS PART OF WEBMATIC3 (Webmatic cube)
 // www.valarsoft.com

 defined('WM3_cEXEC') or die('Denied');

 class wm3Survey
  {

   function __construct() { }

   public static function getSurveyFieldsArray()
    {
     return array('surveyID','title','render_mode','question','target_type','result_type','layout_type','enabled','languageID','ts');
    }

   public static function getSurveyItemFieldsArray()
    {
     return array('survey_itemID','surveyID','render_mode','answer','enabled','languageID','ts');
    }

   public static function executeAction($w3)
    {
     switch($w3->getAction())
      {
       case WM3_cACTION_ADD_SURVEY:
        {
         return wm3Survey::addSurvey($w3);
         break;
        }
       case WM3_cACTION_SAVE_SURVEY:
        {
         $error = wm3Survey::checkSurveyError($w3);
         if(!$error)
          {
           $lastID = wm3Survey::saveSurvey($w3);
           // $msg= message saved... //TODO
           return wm3Survey::getSurveyList($w3,$lastID);
          }
         else return wm3Survey::addSurvey($w3,$error);
         break;
        }
       case WM3_cACTION_EDIT_SURVEY:
        {
         return wm3Survey::editSurvey($w3);
         break;
        }
       case WM3_cACTION_UPDATE_SURVEY:
        {
         $error = wm3Survey::checkSurveyError($w3);
         if(!$error)
          {
           $lastID = wm3Survey::updateSurvey($w3);
           // $msg= message udated... //TODO
           return wm3Survey::getSurveyList($w3,$lastID);
          }
         else return wm3Survey::editSurvey($w3,$error);
         break;
        }
       case WM3_cACTION_DISABLE_SURVEY:
        {
         wm3Survey::disableSurvey($w3->getVariable('surveyID','get'));
         return wm3Survey::getSurveyList($w3,$w3->getVariable('surveyID','get'));
         break;
        }
       case WM3_cACTION_ENABLE_SURVEY:
        {
         wm3Survey::enableSurvey($w3->getVariable('surveyID','get'));
         return wm3Survey::getSurveyList($w3,$w3->getVariable('surveyID','get'));
         break;
        }
       case WM3_cACTION_DELETE_SURVEY:
        {
         wm3Survey::deleteSurvey($w3->getVariable('surveyID','get'));
         return wm3survey::getSurveyList($w3);
         break;
        }
	   case WM3_cACTION_RESET_SURVEY:
	    {
         wm3Survey::resetSurvey($w3->getVariable('surveyID','get'));
		 return wm3Survey::getSurveyList($w3,$w3->getVariable('surveyID','get'));
         break;
		}
       case WM3_cACTION_ADD_SURVEY_ITEM:
        {
         return wm3Survey::addSurveyItem($w3);
         break;
        }
       case WM3_cACTION_SAVE_SURVEY_ITEM:
        {
		 wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_surveys_items WRITE,
		                               ".WM3_cCONFIG_DB_PREFIX."_surveys       WRITE");
         $error = wm3Survey::checkSurveyItemError($w3);
         if(!$error) {
                      $lastID = wm3Survey::saveSurveyItem($w3);
                      wm3Sql::sqlQuery("UNLOCK TABLES");
                      return wm3Survey::getSurveyItemList($w3,$lastID);
                     }
         else        {
			          wm3Sql::sqlQuery("UNLOCK TABLES");
			          return wm3Survey::addSurveyItem($w3,$error);
				     }
         break;
        }
       case WM3_cACTION_EDIT_SURVEY_ITEM:
        {
         return wm3Survey::editSurveyItem($w3);
         break;
        }
       case WM3_cACTION_UPDATE_SURVEY_ITEM:
        {
		 wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_surveys_items   WRITE,
		                               ".WM3_cCONFIG_DB_PREFIX."_surveys         WRITE,
									   ".WM3_cCONFIG_DB_PREFIX."_sessions_surveys WRITE");
         $error = wm3Survey::checkSurveyItemError($w3);
         if(!$error) {
                      $lastID = wm3Survey::updateSurveyItem($w3);
                      wm3Sql::sqlQuery("UNLOCK TABLES");
                      return wm3Survey::getSurveyItemList($w3,$lastID);
                     }
         else        {
			          wm3Sql::sqlQuery("UNLOCK TABLES");
			          return wm3Survey::editSurveyItem($w3,$error);
				     }
         break;
        }
       case WM3_cACTION_DISABLE_SURVEY_ITEM:
        {
         wm3Survey::disableSurveyItem($w3->getVariable('survey_itemID','get'));
         return wm3Survey::getSurveyItemList($w3,$w3->getVariable('survey_itemID','get'));
         break;
        }
       case WM3_cACTION_ENABLE_SURVEY_ITEM:
        {
         wm3Survey::enableSurveyItem($w3->getVariable('survey_itemID','get'));
         return wm3Survey::getSurveyItemList($w3,$w3->getVariable('survey_itemID','get'));
         break;
        }
       case WM3_cACTION_DELETE_SURVEY_ITEM:
        {
         wm3Survey::deleteSurveyItem($w3->getVariable('survey_itemID','get'));
         return wm3Survey::getSurveyItemList($w3);
         break;
        }
       case WM3_cACTION_SHOW_SURVEY_ITEM:
        {
         return wm3Survey::getSurveyItemList($w3);
         break;
        }
       default:
        {
         return wm3Survey::getSurveyList($w3);
        }
      }
    }

   public static function getSurveyList($w3,$currentID = 0,$admin = true)
    {
     // Get surveys list
     $max_page_items = 12; $columns = 7; $buttons = 5;
     $pg = $w3->getVariable('pg','both');
     $filter = $w3->getVariable('filter','both'); // Search field
     if($filter) { $search_link = "&filter=$filter";
                   $query_filter = "WHERE question LIKE '%$filter%'"; }
     else        { $search_link = $query_filter = ""; }
     $search_form_link = WM3_cCONFIG_ADMIN_FILE;
     $base_link = "".WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     $id_link   = "";

     // Do the query and take the total items number
	 $order_by = " ORDER BY title DESC";
     $query = "SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_surveys
                        $query_filter";
     $rs = wm3Sql::sqlQuery($query.$order_by); // Do the query without "limit"
     $total_items = mysql_num_rows($rs);
     if($total_items % $max_page_items == 0 && $pg == (int)($total_items / $max_page_items)) $pg--;
	 if($currentID)
	  {
	   $position = wm3Sql::getRSPosition($rs,'surveyID',$currentID);
	   $pg = (int)($position / $max_page_items);
      }
	 if($pg) $extra_link = "&pg=$pg"; else $extra_link = "";
     if($total_items != 0) $rs = wm3Sql::sqlQuery($query.$order_by." LIMIT ".($pg*$max_page_items).",$max_page_items");

     // Create list header
     $_CONTENTS = array();
     require(WM3_cPATH_INCLUDE."admin_survey_search_form.inc");
     array_push($_CONTENTS,$w3->getWord(855));
     $str = wm3Section::makeHeaderList($w3,$_CONTENTS,$columns,$search_form);

     // Create list caption
     if($admin) $str .= wm3Section::makeCaptionList($w3,array(60,40,0),array(887,1407),$buttons);

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0) return $str.wm3Section::makeEmptyItemsList($w3,$columns,593);

     // Create list items
     $p = 0;
     while($row = mysql_fetch_object($rs))
      {
       $_CONTENTS = array(); $_WIDTHS = array();
       $link = $base_link.$id_link.$extra_link."&surveyID=$row->surveyID";
       //if() $css_class = "listCurrent";
       $total_votes = wm3Survey::getSurveyTotalVotes($row->surveyID,$admin);
       $lang_flag = "<img src=\"".WM3_cPATH_DATA.wm3Language::getFlag($row->languageID)."\" width=\"19\" height=\"13\" align=\"middle\">";
	   if($row->result_type == WM3_cSURVEY_RESULT_PUBLIC) $results = "Result are public..."; else $results = "Result are private...";
	   if($row->target_type == WM3_cSURVEY_TARGET_ALL)    $target  = "All can vote...";      else $target  = "Only registered users can vote...";
       array_push($_CONTENTS,"<a href=\"$link&action=".WM3_cACTION_SHOW_SURVEY_ITEM."\">$row->title</a><br>($total_votes votes)");
       array_push($_CONTENTS,"$lang_flag<br>$target<br>$results");
       array_push($_WIDTHS,60,40);
       // Buttons
       array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_ADD_SURVEY_ITEM,"action_add_from.png",$w3->getWord(859)));
       if($row->enabled) array_push($_CONTENTS,wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DISABLE_SURVEY,"action_disable.png",$w3->getWord(180)));
       else              array_push($_CONTENTS,wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_ENABLE_SURVEY,"action_enable.png",$w3->getWord(181)));
       array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_EDIT_SURVEY,"action_edit.png",$w3->getWord(178)));
       array_push($_CONTENTS,wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_RESET_SURVEY,"action_reset.png",$w3->getWord(179),$w3->getWord(932)));
       array_push($_CONTENTS,wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DELETE_SURVEY,"action_delete.png",$w3->getWord(179),$w3->getWord(854)));
       $str .= wm3Section::makeItemList($w3,$p,$_WIDTHS,$_CONTENTS,$row->surveyID==$currentID);
       $p++;       
      }

     // Create list bottom
     $bottom_content = "";
     if($total_items > $max_page_items)
      {
       $bottom_content = wm3Util::makePagesNavigator($total_items,$max_page_items,$pg,$base_link."&action=".WM3_cACTION_SHOW_LINK.$id_link.$search_link);
      }
     $str .= wm3Section::makeBottomList($w3,$columns,$bottom_content);

     return $str;     
    }

   public static function getSurveyItemList($w3,$currentID = 0,$admin = true)
    {
     // Get survey items list (admin and home side)

     // Prepare variables to create the list
     $max_page_items = 12; $columns = 6; $buttons = 4;
     $surveyID = $w3->getVariable('surveyID','both'); // Take surveyID from both
     $query_filter = "WHERE surveyID = '$surveyID'";
     $pg = $w3->getVariable('pg','both');
     $filter = $w3->getVariable('filter','both'); // Search field
	 $search_form_link = WM3_cCONFIG_ADMIN_FILE;
     $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     $id_link = "&surveyID=$surveyID";

     // Do the query and take the total items number
	 $order_by =" ORDER BY ts DESC";
     $query = "SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_surveys_items
                        $query_filter";
     $rs = wm3Sql::sqlQuery($query.$order_by); // Do the query without "limit"
     $total_items = mysql_num_rows($rs);
     if($total_items % $max_page_items == 0 && $pg == (int)($total_items / $max_page_items)) $pg--;
	 if($currentID)
	  {
	   $position = wm3Sql::getRSPosition($rs,'survey_itemID',$currentID);
	   $pg = (int)($position / $max_page_items);
      }
	 if($pg) $extra_link = "&pg=$pg"; else $extra_link = "";
     if($total_items != 0) $rs = wm3Sql::sqlQuery($query.$order_by." LIMIT ".($pg*$max_page_items).",$max_page_items");

     // Create list header
     $_CONTENTS = array();
     require(WM3_cPATH_INCLUDE."admin_survey_search_form.inc");
	 $_SEP  = $w3->getSkinObj()->getSeparator();
	 $_PSEP = $w3->getSkinObj()->getPathSeparator();
     array_push($_CONTENTS,"<a href=\"$base_link\">".$w3->getWord(855)."</a> $_PSEP 
                           ".wm3Survey::getSurveyTitle($surveyID)." $_SEP 
                           ".wm3Util::actionButton($base_link.$id_link."&action=".WM3_cACTION_ADD_SURVEY_ITEM,"action_add.png","","",$w3->getWord(1654),0,16,16));
     $str = wm3Section::makeHeaderList($w3,$_CONTENTS,$columns,$search_form);

     // Create list caption
     if($admin) $str .= wm3Section::makeCaptionList($w3,array(50,50,0),array(194,1407),$buttons);

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0) return $str.wm3Section::makeEmptyItemsList($w3,$columns,593);

     // Create list items
     $p = 0;
	 $total_votes = wm3Survey::getSurveyTotalVotes($surveyID,$admin);
     while($row = mysql_fetch_object($rs))
      {
       $_CONTENTS = array(); $_WIDTHS = array();
	   $link = $base_link.$id_link.$extra_link."&survey_itemID=$row->survey_itemID";
       $lang_flag = "<img src=\"".WM3_cPATH_DATA.wm3Language::getFlag($row->languageID)."\" width=\"19\" height=\"13\" align=\"middle\">";
	   if($total_votes) $percentage = $row->votes / $total_votes * 100; else $percentage = 0;
       array_push($_CONTENTS,$row->answer);
       array_push($_CONTENTS,"$lang_flag ".wm3Util::makePercentageBar($w3,$percentage,200,10)." (".round($percentage,2)."%, $row->votes votes)");
       array_push($_WIDTHS,50,50);
       // Buttons
       if($row->enabled) array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_DISABLE_SURVEY_ITEM,"action_disable.png",$w3->getWord(180)));
       else              array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_ENABLE_SURVEY_ITEM,"action_enable.png",$w3->getWord(181)));
       array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_EDIT_SURVEY_ITEM,"action_edit.png",$w3->getWord(178)));
       array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_DUPLICATE_NEWS,"action_duplicate.png",$w3->getWord(1415),$w3->getWord(1419)));
       array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_DELETE_SURVEY_ITEM,"action_delete.png",$w3->getWord(179),$w3->getWord(772)));
       $str .= wm3Section::makeItemList($w3,$p,$_WIDTHS,$_CONTENTS,$row->survey_itemID==$currentID);
       $p++;
      }

     // Create list bottom
     $bottom_content = "";
     if($total_items > $max_page_items)
      {
	   $bottom_content = wm3Util::makePagesNavigator($total_items,$max_page_items,$pg,$base_link."&action=".WM3_cACTION_SHOW_SURVEY_ITEM.$id_link);
      }
     $str .= wm3Section::makeBottomList($w3,$columns,$bottom_content);

     return $str;
    }

   public static function checkSurveyVoteError($w3,$surveyID,$survey_itemID)
    {
     // Check form invalid survey vote inputs
     wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_surveys_items WRITE,
	                               ".WM3_cCONFIG_DB_PREFIX."_surveys       WRITE");
	 $_FIELD = webmatic3::getPostValueArray(wm3Survey::getSurveyItemFieldsArray());
     $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_surveys
                             WHERE surveyID = '$surveyID'");
     if(mysql_num_rows($rs) == 0) { wm3Sql::sqlQuery("UNLOCK TABLES"); return 1; } // Survey do not exists
     $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_surveys_items
                             WHERE surveyID = '$surveyID' AND survey_itemID = '$survey_itemID'");
     if(mysql_num_rows($rs) == 0) { wm3Sql::sqlQuery("UNLOCK TABLES"); return 2; } // Survey item do not exists or not in surveyID 
     return 0;
    }

   public static function checkSurveyError($w3)
    {
     // Check form invalid inputs
     $_FIELD = webmatic3::getPostValueArray(wm3Survey::getSurveyFieldsArray());
     if(!$_FIELD['title'])    return 1;
     if(!$_FIELD['question']) return 2;
     return 0;    	
    }

   public static function checkSurveyItemError($w3)
    {
     // Check form invalid inputs
     $_FIELD = webmatic3::getPostValueArray(wm3Survey::getSurveyItemFieldsArray());
	 if(!wm3Survey::existsSurvey($_FIELD['surveyID'])) return 1;
     if(!$_FIELD['answer']) return 2;
     return 0;    	
    }

   public static function addSurvey($w3,$error = 0)
    {
     // Take variables value and set correct form style    
     $_STYLE = wm3Skin::getFormStyleArray(wm3Survey::getSurveyFieldsArray());
     $_FIELD = webmatic3::getPostValueArray(wm3Survey::getSurveyFieldsArray());
     // Fields for paging default value
     $pg = $filter = ""; 
     switch($error)
      {
       case 1: // No title
        {
         $_STYLE['title']          = "class=\"adminFormError\"";
         $_STYLE['adminFormTitle'] = "class=\"adminFormTitleError\"";
         $form_title = "Error $error";//$w3->getWord(29);
         break;
        }
       case 2: // No question
        {
         $_STYLE['question']       = "class=\"adminFormError\"";
         $_STYLE['adminFormTitle'] = "class=\"adminFormTitleError\"";
         $form_title = "Error $error";//$w3->getWord(29);
         break;
        }
       default:
        {
         // Default values for the form
         $_FIELD['enabled']    = WM3_cENABLED;
         $_STYLE['adminFormTitle'] = "class=\"adminFormTitle\"";
         $form_title = $w3->getWord(837);
       	}
      }
     $next_action       = WM3_cACTION_SAVE_SURVEY;
     $next_action_label = $w3->getWord(191);
     require(WM3_cPATH_INCLUDE."admin_survey_form.inc");
     return $admin_content;     
    }

   public static function editSurvey($w3,$error = 0)
    {
     // Take variables value from db and set correct form style
     if(!$error)
      {
       $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_surveys
                               WHERE surveyID = '".$w3->getVariable('surveyID','get')."'");
       $row = mysql_fetch_object($rs);
	   if(!$row) return wm3Section::makeNotFoundItem($w3);
       $_FIELD = webmatic3::getRowValueArray(wm3Survey::getSurveyFieldsArray(),$row);
       // Default value for fields not in $row object
      }
     else $_FIELD = webmatic3::getPostValueArray(wm3Survey::getSurveyFieldsArray());

     $_STYLE = wm3Skin::getFormStyleArray(wm3Survey::getSurveyFieldsArray());
     $pg     = $w3->getVariable('pg','both');
     $filter = $w3->getVariable('filter','both');
     switch($error)
      {
       case 1: // No title
        {
         $_STYLE['title']          = "class=\"adminFormError\"";
         $_STYLE['adminFormTitle'] = "class=\"adminFormTitleError\"";
         $form_title = "Error $error";//$w3->getWord(29);
         break;
        }
       case 2: // No question
        {
         $_STYLE['question']       = "class=\"adminFormError\"";
         $_STYLE['adminFormTitle'] = "class=\"adminFormTitleError\"";
         $form_title = "Error $error";//$w3->getWord(29);
         break;
        }
       default:
        {
         $_STYLE['adminFormTitle'] = "class=\"adminFormTitle\"";
         $form_title = "Edit link ...."; //$w3->getWord(29);
       	}
      }
     $next_action       = WM3_cACTION_UPDATE_SURVEY;
     $next_action_label = $w3->getWord(29);
     require(WM3_cPATH_INCLUDE."admin_survey_form.inc");
     return $admin_content;
    }

   public static function saveSurvey($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Survey::getSurveyFieldsArray(),WM3_cQUOTE_DB);
     $_FIELD['ts'] = time();
     wm3Sql::saveAllTableFields('_surveys',$_FIELD);
     return wm3Sql::getLastInsertID();
    }

   public static function updateSurvey($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Survey::getSurveyFieldsArray(),WM3_cQUOTE_DB);
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_surveys
                       SET title       = '".$_FIELD['title']."',
                           question    = '".$_FIELD['question']."',
						   render_mode = '".$_FIELD['render_mode']."',
                           target_type = '".$_FIELD['target_type']."',
						   result_type = '".$_FIELD['result_type']."',
						   layout_type = '".$_FIELD['layout_type']."',
                           enabled     = '".$_FIELD['enabled']."',
                           languageID  = '".$_FIELD['languageID']."'
                       WHERE surveyID  = '".$_FIELD['surveyID']."'");
     return $_FIELD['surveyID'];
    }

   public static function selectSurvey($name,$surveyID)
    {
     // Make surveys select
     $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_surveys");
     $i = 0;
     while($row = mysql_fetch_object($rs))
      {
       $_LABEL[$i] = $row->title;
       $_VALUE[$i] = $row->surveyID;
       $i++;
      }
     if($i != 0) return wm3Util::selectArray($name,$_LABEL,$_VALUE,$surveyID);
    }

   public static function disableSurvey($surveyID)
    {
	 wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_surveys SET enabled = '".WM3_cDISABLED."' WHERE surveyID = '$surveyID'");
	}

   public static function enableSurvey($surveyID)
    {
	 wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_surveys SET enabled = '".WM3_cENABLED."' WHERE surveyID = '$surveyID'");
	}
   
   public static function deleteSurvey($surveyID)
    {
     wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_surveys_items    WRITE,
	                               ".WM3_cCONFIG_DB_PREFIX."_surveys          WRITE,
								   ".WM3_cCONFIG_DB_PREFIX."_sessions_surveys WRITE");
     wm3Sql::sqlQuery("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_sessions_surveys WHERE surveyID = '$surveyID'");
     wm3Sql::sqlQuery("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_surveys_items WHERE surveyID = '$surveyID'");
	 wm3Sql::sqlQuery("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_surveys WHERE surveyID = '$surveyID'");
	 wm3Sql::sqlQuery("UNLOCK TABLES");
	}

   public static function resetSurvey($surveyID)
    {
	 wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_surveys_items SET votes = '0' WHERE surveyID = '$surveyID'");
	 wm3Sql::sqlQuery("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_sessions_surveys WHERE surveyID = '$surveyID'");
	}

   public static function addSurveyItem($w3,$error = 0)
    {
     // Take variables value and set correct form style    
     $_STYLE = wm3Skin::getFormStyleArray(wm3Survey::getSurveyItemFieldsArray());
     $_FIELD = webmatic3::getPostValueArray(wm3Survey::getSurveyItemFieldsArray());
     // Fields for paging default value
     $pg = $filter = ""; 
     switch($error)
      {
       case 1: // Invalid survey
        {
         $_STYLE['surveyID']       = "class=\"adminFormError\"";
         $_STYLE['adminFormTitle'] = "class=\"adminFormTitleError\"";
         $form_title = $w3->getWord(860)."...";
         break;
        }
       case 2: // No answer
        {
         $_STYLE['answer']         = "class=\"adminFormError\"";
         $_STYLE['adminFormTitle'] = "class=\"adminFormTitleError\"";
         $form_title = $w3->getWord(860);
         break;
        }
	   default:
        {
         // Default values for the form
         $_FIELD['surveyID']       = $w3->getVariable('surveyID','get'); // Take surveyID from get
         $_FIELD['enabled']        = WM3_cENABLED;
         $_STYLE['adminFormTitle'] = "class=\"adminFormTitle\"";
         $form_title = $w3->getWord(837);
       	}
      }
     $next_action       = WM3_cACTION_SAVE_SURVEY_ITEM;
     $next_action_label = $w3->getWord(191);
     require(WM3_cPATH_INCLUDE."admin_survey_item_form.inc");
     return $admin_content;     
    }

   public static function editSurveyItem($w3,$error = 0)
    {
     // Take variables value from db and set correct form style
     if(!$error)
      {
       $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_surveys_items
                               WHERE survey_itemID = '".$w3->getVariable('survey_itemID','get')."'");
       $row = mysql_fetch_object($rs);
	   if(!$row) return wm3Section::makeNotFoundItem($w3);
       $_FIELD = webmatic3::getRowValueArray(wm3Survey::getSurveyItemFieldsArray(),$row);
       // Default value for fields not in $row object
      }
     else $_FIELD = webmatic3::getPostValueArray(wm3Survey::getSurveyItemFieldsArray());

     $_STYLE = wm3Skin::getFormStyleArray(wm3Survey::getSurveyItemFieldsArray());
     $pg     = $w3->getVariable('pg','both');
     $filter = $w3->getVariable('filter','both');
     switch($error)
      {
       case 1: // Invalid survey
        {
         $_STYLE['surveyID']       = "class=\"adminFormError\"";
         $_STYLE['adminFormTitle'] = "class=\"adminFormTitleError\"";
         $form_title = $w3->getWord(860)."...";
         break;
        }
       case 2: // No answer
        {
         $_STYLE['answer']         = "class=\"adminFormError\"";
         $_STYLE['adminFormTitle'] = "class=\"adminFormTitleError\"";
         $form_title = $w3->getWord(860);
         break;
        }
       default:
        {
         $_STYLE['adminFormTitle'] = "class=\"adminFormTitle\"";
         $form_title = "Edit link ...."; //$w3->getWord(29);
       	}
      }
     $next_action       = WM3_cACTION_UPDATE_SURVEY_ITEM;
     $next_action_label = $w3->getWord(29);
     require(WM3_cPATH_INCLUDE."admin_survey_item_form.inc");
     return $admin_content;
    }

   public static function saveSurveyItem($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Survey::getSurveyItemFieldsArray(),WM3_cQUOTE_DB);
     $_FIELD['votes'] = 0;
     $_FIELD['ts'] = time();
     wm3Sql::saveAllTableFields('_surveys_items',$_FIELD);
     return wm3Sql::getLastInsertID();
    }

   public static function updateSurveyItem($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Survey::getSurveyItemFieldsArray(),WM3_cQUOTE_DB);
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_surveys_items
                       SET   surveyID      = '".$_FIELD['surveyID']."',
                             answer        = '".$_FIELD['answer']."',
							 render_mode   = '".$_FIELD['render_mode']."',
                             enabled       = '".$_FIELD['enabled']."',
                             languageID    = '".$_FIELD['languageID']."'
                       WHERE survey_itemID = '".$_FIELD['survey_itemID']."'");
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_sessions_surveys
                       SET   surveyID      = '".$_FIELD['surveyID']."'
                       WHERE survey_itemID = '".$_FIELD['survey_itemID']."'");
     return $_FIELD['survey_itemID'];
    }

   public static function disableSurveyItem($survey_itemID)
    {
	 wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_surveys_items SET enabled = '".WM3_cDISABLED."' WHERE survey_itemID = '$survey_itemID'");
	}

   public static function enableSurveyItem($survey_itemID)
    {
	 wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_surveys_items SET enabled = '".WM3_cENABLED."' WHERE survey_itemID = '$survey_itemID'");
	}
   
   public static function deleteSurveyItem($survey_itemID)
    {
     wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_surveys_items    WRITE,
								   ".WM3_cCONFIG_DB_PREFIX."_sessions_surveys WRITE");
	 wm3Sql::sqlQuery("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_surveys_items WHERE survey_itemID = '$survey_itemID'");
     wm3Sql::sqlQuery("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_sessions_surveys WHERE survey_itemID = '$survey_itemID'");
	 wm3Sql::sqlQuery("UNLOCK TABLES");
	}

   public function existsSurvey($surveyID)
    {
     // Return true if the survey with surveyID exists else return false
     $rs = wm3Sql::sqlQuery("SELECT surveyID FROM ".WM3_cCONFIG_DB_PREFIX."_surveys
                             WHERE  surveyID = '$surveyID'");
     if(mysql_num_rows($rs) == 1) return true;
	 else                         return false;
    }

   public static function getSurveyTitle($surveyID)
    {
     $rs = wm3Sql::sqlQuery("SELECT title FROM ".WM3_cCONFIG_DB_PREFIX."_surveys
                             WHERE surveyID = '$surveyID'");
     $row = mysql_fetch_object($rs);
     return $row->title;
    }

   public static function getSurveyTotalVotes($surveyID,$admin = false)
    {
	 if(!$admin) $query_filter = "AND enabled = '".WM3_cENABLED."'";
	 else        $query_filter = "";
     $rs = wm3Sql::sqlQuery("SELECT SUM(votes) AS total_votes FROM ".WM3_cCONFIG_DB_PREFIX."_surveys_items
                             WHERE  surveyID = '$surveyID'
							 $query_filter");
     $row = mysql_fetch_object($rs);
     if(!$row->total_votes) return 0; else return $row->total_votes;
    }

   public static function selectTargetType($name,$target_type,$w3)
    {
     // Make survey voters type
     return wm3Util::selectArray($name,
                        array($w3->getWord(843),$w3->getWord(844)),
                        array(WM3_cSURVEY_TARGET_ALL,WM3_cSURVEY_TARGET_USERS),
                        $target_type);
    }

   public static function selectResultType($name,$result_type,$w3)
    {
     // Make survey result type
     return wm3Util::selectArray($name,
                        array($w3->getWord(845),$w3->getWord(846)),
                        array(WM3_cSURVEY_RESULT_PUBLIC,WM3_cSURVEY_RESULT_PRIVATE),
                        $result_type);
    }

   public static function selectLayoutType($name,$layout_type,$w3)
    {
     // Make survey layout type
     return wm3Util::selectArray($name,
                        array($w3->getWord(847),$w3->getWord(848)),
                        array(WM3_cSURVEY_LAYOUT_COMBO,WM3_cSURVEY_LAYOUT_MENU),
                        $layout_type);
    }

   public static function voteSurvey($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Survey::getSurveyItemFieldsArray(),WM3_cQUOTE_DB);
	 if(wm3Survey::isSurveyVotable($w3,$_FIELD['surveyID'],$_FIELD['survey_itemID']))
	  {
	   if(wm3Session::surveyAllowed($w3,$_FIELD['surveyID'],WM3_cSESSION_VOTE))
	    {
	     wm3Session::surveyProtect($w3,$_FIELD['surveyID'],$_FIELD['survey_itemID'],WM3_cSESSION_VOTE);
         wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_surveys_items
                           SET   votes         = votes + 1
                           WHERE survey_itemID = '".$_FIELD['survey_itemID']."'
                             AND surveyID      = '".$_FIELD['surveyID']."'");
         return wm3Survey::renderSurveyResult($w3,$_FIELD['survey_itemID']);
	    }
       else
	    {
         $w3->getPageObj()->setSubTitle($w3->getWord(-1)."Already voted...");
		 return wm3Survey::renderSurveyResult($w3);
		}
      }
	 else
	  {
	   $error = wm3Survey::checkSurveyVoteError($w3,$_FIELD['surveyID'],$_FIELD['survey_itemID']);
	   switch($error)
	    {
	     case 1: // Survey do not exists
		  {
		   $w3->getPageObj()->setSubTitle($w3->getWord(-1)."Survey do not exists...");
		   break;
	      }
	     case 2: // Survey item do not exists or not in surveyID 
		  {
		   $w3->getPageObj()->setSubTitle($w3->getWord(-1)."Please select an answare...");
		   break;
	      }
		 default:
		  {
		   $w3->getPageObj()->setSubTitle($w3->getWord(-1)."You can not vote a survey only for registered users...");
		  }
		}
	   return wm3Survey::renderSurveyResult($w3);
	  }
    }

   public function renderSurveyResult($w3,$currentID = 0)
    {
     // Get pages list
     $surveyID = $w3->getVariable('surveyID','both'); // Take surveyID from both
     $columns = 3; $buttons = 0;
     $base_link = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();

     // Do the query and take the total items number
     $query = "SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_surveys
                        WHERE surveyID = '$surveyID' AND enabled = '".WM3_cENABLED."'";
     $rs = wm3Sql::sqlQuery($query); // Do the query without "limit"
     $total_items = mysql_num_rows($rs);

     // Create list header
	 $_CONTENTS = array();
	 $row = mysql_fetch_object($rs);
	 if(wm3Survey::isSurveyPublic($surveyID) || $w3->getAuthenticateAdminUserID())
      if($total_items) $_CONTENTS = array($row->question);
     $str = wm3Section::makeHeaderList($w3,$_CONTENTS,$columns);

     // Check if there are any items (and exit with a message if there are 0 items or survey its private and no user logged)
     if($total_items == 0)
	  return $str.wm3Section::makeEmptyItemsList($w3,$columns,593);
	 if(!wm3Survey::isSurveyPublic($surveyID) && !$w3->getAuthenticateAdminUserID())
	  return $str.wm3Section::makeEmptyItemsList($w3,$columns,876);

     // Create survey question and answers
	 $_CONTENTS = array(); $_WIDTHS = array(); array_push($_WIDTHS,60,0,40);
     $total_votes = wm3Survey::getSurveyTotalVotes($surveyID);
     $link = $base_link."&surveyID=$row->surveyID";
     $str .= wm3Survey::renderSurveyItems($w3,$surveyID,true,$currentID);
     $str .= wm3Section::makeItemList($w3,0,$_WIDTHS,array("","","<nobr>".$w3->getWord(881)." <b>$total_votes</b></nobr>"),false);

     // Create list bottom
     $str .= wm3Section::makeBottomList($w3,$columns);

     // Result by gender

     // Create list header
	 $str .= "<br>";
	 array_push($_CONTENTS,"<b>".$w3->getWord(871)."</b>");
     $str .= wm3Section::makeHeaderList($w3,$_CONTENTS,$columns);

     // Create result by gender
     $str .= wm3Survey::renderSurveyResultGender($w3,$surveyID);

     // Create list bottom
     $str .= wm3Section::makeBottomList($w3,$columns);

     return $str;
    }

   public function renderSurvey($w3,$surveyID)
    {
     // Render a survey in home page
     $columns = 2; $buttons = 0;
     $base_link = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".WM3_cSECTION_HOME;

     // Do the query and take the total items number
     $query = "SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_surveys
                        WHERE surveyID = '$surveyID' AND enabled = '".WM3_cENABLED."'";
     $rs = wm3Sql::sqlQuery($query); // Do the query without "limit"
     $total_items = mysql_num_rows($rs);

     // Create list header
     $_CONTENTS = array(); $_WIDTHS = array();
     $str = wm3Section::makeHeaderList($w3,$_CONTENTS,$columns);

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0) return $str.wm3Section::makeEmptyItemsList($w3,$columns,1633);

     // Create survey question and answers
     $row = mysql_fetch_object($rs);
     $link = $base_link."&surveyID=$row->surveyID";
     $question = "<b>$row->question<b><br><br>";
     array_push($_CONTENTS,$question); array_push($_WIDTHS,100);
     $str .= wm3Section::makeItemList($w3,0,$_WIDTHS,$_CONTENTS,false,"",array(2));
	 
	 $votable = (wm3Survey::isSurveyTargetAll($surveyID) || $w3->getAuthenticateAdminUserID());
	 $public  = (wm3Survey::isSurveyPublic($row->surveyID) || $w3->getAuthenticateAdminUserID());
     if($votable) $str .= "<form name=\"wm3_form\" method=\"post\" action=\"$link&action=".WM3_cACTION_SURVEY_VOTE."\">";
     $str .= wm3Survey::renderSurveyItems($w3,$surveyID);
     if($votable) $str .= wm3Section::makeItemList($w3,0,$_WIDTHS,array("<br><div align=\"center\"><input type=\"submit\" name=\"send\" value=\"".$w3->getWord(865)."\"></div>"),false,"",array(2));
	 else         $str .= wm3Section::makeItemList($w3,0,$_WIDTHS,array("<br><div align=\"center\"><i>(only members can vote)</i></div>"),false,"",array(2));
     if($votable) $str .= "<input type=\"hidden\" name=\"surveyID\" value=\"$surveyID\"></form>";
     if($public) $str .= wm3Section::makeItemList($w3,0,$_WIDTHS,array("<div align=\"center\"><a href=\"$link&action=".WM3_cACTION_SURVEY_RESULTS."\">".$w3->getWord(872)."</a></div>"),false,"",array(2));
	 else        $str .= wm3Section::makeItemList($w3,0,$_WIDTHS,array("<div align=\"center\"><i>(survey results are private)</i></div>"),false,"",array(2));

     // Create list bottom
     $str .= wm3Section::makeBottomList($w3,$columns);

     return $str;
    }

   public function renderSurveyItems($w3,$surveyID,$show_result = false,$currentID = 0)
    {
     // Render survey item list
     if($show_result) $columns = 3; else $columns = 2; $buttons = 0;
     $base_link = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();

     // Do the query and take the total items number
     $query = "SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_surveys_items
                        WHERE surveyID = '$surveyID' AND enabled = '".WM3_cENABLED."'";
     if($show_result) $query .= "ORDER BY votes DESC";
     $rs = wm3Sql::sqlQuery($query); // Do the query without "limit"
     $total_items = mysql_num_rows($rs);

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0) return wm3Section::makeEmptyItemsList($w3,$columns,939,true);

     // Create list items
     $p = 0; $str = "";
     while($row = mysql_fetch_object($rs))
      {
       $_CONTENTS = array(); $_WIDTHS = array();
       $link = $base_link."&surveyID=$row->surveyID";
       if($show_result)
        {
         $total_votes = wm3Survey::getSurveyTotalVotes($surveyID);
         if($total_votes) $percentage = $row->votes / $total_votes * 100; else $percentage = 0;
         $answer = $row->answer;
         $bar    = wm3Util::makePercentageBar($w3,$percentage,200,10);
         $info   = "<nobr>(".round($percentage,2)."%, $row->votes votes)</nobr>";
         array_push($_CONTENTS,$answer,$bar,$info); array_push($_WIDTHS,60,0,40);
        }
       else
        {
         $radio  = wm3Util::inputRadio('survey_itemID',$row->survey_itemID);
         $answer = $row->answer;
         array_push($_CONTENTS,$radio,$answer); array_push($_WIDTHS,0,100);
        }
       $str .= wm3Section::makeItemList($w3,$p,$_WIDTHS,$_CONTENTS,$row->survey_itemID==$currentID);
       $p++;
      }

     return $str;
    }

   public function renderSurveyResultGender($w3,$surveyID)
    {
     // Render survey gender result
     $columns = 3; $buttons = 0;

     // Do the query and take the total items number
     $query = "SELECT   ".WM3_cCONFIG_DB_PREFIX."_sessions_surveys.userID,
	                    ".WM3_cCONFIG_DB_PREFIX."_users.gender,
					    COUNT(*) as total
               FROM     ".WM3_cCONFIG_DB_PREFIX."_sessions_surveys,
			            ".WM3_cCONFIG_DB_PREFIX."_users,
						".WM3_cCONFIG_DB_PREFIX."_surveys_items
               WHERE    ".WM3_cCONFIG_DB_PREFIX."_sessions_surveys.surveyID = '$surveyID'
			     AND    ".WM3_cCONFIG_DB_PREFIX."_surveys_items.enabled = '".WM3_cENABLED."'
			     AND    ".WM3_cCONFIG_DB_PREFIX."_users.userID = ".WM3_cCONFIG_DB_PREFIX."_sessions_surveys.userID
				 AND    ".WM3_cCONFIG_DB_PREFIX."_surveys_items.survey_itemID = ".WM3_cCONFIG_DB_PREFIX."_sessions_surveys.survey_itemID
               GROUP BY ".WM3_cCONFIG_DB_PREFIX."_users.gender
               ORDER BY ".WM3_cCONFIG_DB_PREFIX."_users.gender DESC";
     $rs = wm3Sql::sqlQuery($query); // Do the query without "limit"
     $total_items = mysql_num_rows($rs);

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0) return wm3Section::makeEmptyItemsList($w3,$columns,939,true);

     // Create list items
     $p = 0; $str = "";
     while($row = mysql_fetch_object($rs))
      {
       $_CONTENTS = array(); $_WIDTHS = array();
       $total_votes = wm3Survey::getSurveyTotalVotes($surveyID);
       if($total_votes) $percentage = $row->total / $total_votes * 100; else $percentage = 0;
       if($row->gender == 'M') $label  = $w3->getWord(869);
	   else                    $label  = $w3->getWord(870);
       $bar    = wm3Util::makePercentageBar($w3,$percentage,200,10);
       $info   = "<nobr>(".round($percentage,2)."%, $row->total votes)</nobr>";
       array_push($_CONTENTS,$label,$bar,$info); array_push($_WIDTHS,60,0,40);
       $str .= wm3Section::makeItemList($w3,$p,$_WIDTHS,$_CONTENTS,false);
       $p++;
      }

     return $str;
    }

   public static function isSurveyPublic($surveyID)
    {
     $rs = wm3Sql::sqlQuery("SELECT result_type FROM ".WM3_cCONFIG_DB_PREFIX."_surveys
                             WHERE surveyID = '$surveyID'");
     if(mysql_num_rows($rs) == 0) return false;
     $row = mysql_fetch_object($rs);
	 if($row->result_type == WM3_cSURVEY_RESULT_PUBLIC) return true;
     else                                               return false;
    }

   public static function isSurveyTargetAll($surveyID)
    {
     $rs = wm3Sql::sqlQuery("SELECT target_type FROM ".WM3_cCONFIG_DB_PREFIX."_surveys
                             WHERE surveyID = '$surveyID'");
     if(mysql_num_rows($rs) == 0) return false;
     $row = mysql_fetch_object($rs);
	 if($row->target_type == WM3_cSURVEY_TARGET_ALL) return true;
     else                                            return false;
    }

   public static function isSurveyVotable($w3,$surveyID,$survey_itemID)
    {
     wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_surveys_items WRITE,
	                               ".WM3_cCONFIG_DB_PREFIX."_surveys       WRITE");
     $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_surveys
                             WHERE surveyID = '$surveyID'");
     if(mysql_num_rows($rs) == 0) { wm3Sql::sqlQuery("UNLOCK TABLES"); return false; } // Survey do not exists
     $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_surveys_items
                             WHERE surveyID = '$surveyID' AND survey_itemID = '$survey_itemID'");
     if(mysql_num_rows($rs) == 0) { wm3Sql::sqlQuery("UNLOCK TABLES"); return false; } // Survey item do not exists or not in surveyID

	 if(!wm3Survey::isSurveyTargetAll($surveyID))
	  {
       if($w3->getAuthenticateAdminUserID()) { wm3Sql::sqlQuery("UNLOCK TABLES"); return true; }
	   else                                  { wm3Sql::sqlQuery("UNLOCK TABLES"); return false; }
      }
	 else { wm3Sql::sqlQuery("UNLOCK TABLES"); return true; }
    }

  }

?>
