<?php

 // THIS FILE IS PART OF WEBMATIC3 (Webmatic cube)
 // www.valarsoft.com

 defined('WM3_cEXEC') or die('Denied');

 class wm3UserMessage
  {

   function __construct() { }

   public static function getUserMessageFieldsArray()
    {
     return array('messageID','toID','subject','message','message_high_priority','enabled','languageID','fromID','message_read','message_replied','ts');
    }

   public static function executeUserAction($w3)
    {
     switch($w3->getAction())
      {
       case WM3_cACTION_SET_NOT_READ_USER_MESSAGE:
        {
         wm3UserMessage::setNotReadUserMessage($w3->getVariable('messageID','get'));
         return wm3UserMessage::getUserMessageList($w3,$w3->getVariable('messageID','get'),false);
         break;
        }
       case WM3_cACTION_DELETE_USER_MESSAGE:
        {
         wm3UserMessage::deleteUserMessage($w3,$w3->getVariable('messageID','get'),false);
         return wm3UserMessage::getUserMessageList($w3,0,false);
         break;
        }
       case WM3_cACTION_ADD_USER_MESSAGE:
        {
         return wm3UserMessage::addUserMessage($w3,0,false);
         break;
        }
       case WM3_cACTION_REPLY_USER_MESSAGE:
        {
		 return wm3UserMessage::replyUserMessage($w3,0,false);
         break;
        }
       case WM3_cACTION_SAVE_USER_MESSAGE:
        {
         $error = wm3UserMessage::checkUserMessageError($w3);
         if(!$error)
          {
           $lastID = wm3UserMessage::saveUserMessage($w3,false);
           // $msg= message saved... //TODO
           return wm3UserMessage::getUserMessageList($w3,$lastID,false);
          }
         else return wm3UserMessage::addUserMessage($w3,$error,false);
         break;
        }
       case WM3_cACTION_SHOW_USER_MESSAGE:
        {
         return wm3UserMessage::renderUserMessage($w3,$w3->getVariable('messageID','get'),false);
         break;
        }
       default:
        {
         return wm3UserMessage::getUserMessageList($w3,0,false);
        }
      }
    }

   public static function executeAdminAction($w3)
    {
     switch($w3->getAction())
      {
       case WM3_cACTION_SET_NOT_READ_USER_MESSAGE:
        {
         wm3UserMessage::setNotReadUserMessage($w3->getVariable('messageID','get'));
         return wm3UserMessage::getUserMessageList($w3,$w3->getVariable('messageID','get'));
         break;
        }
       case WM3_cACTION_DELETE_USER_MESSAGE:
        {
         wm3UserMessage::deleteUserMessage($w3,$w3->getVariable('messageID','get'));
         return wm3UserMessage::getUserMessageList($w3);
         break;
        }
       case WM3_cACTION_ADD_USER_MESSAGE:
        {
         return wm3UserMessage::addUserMessage($w3);
         break;
        }
       case WM3_cACTION_REPLY_USER_MESSAGE:
        {
		 return wm3UserMessage::replyUserMessage($w3);
         break;
        }
       case WM3_cACTION_SAVE_USER_MESSAGE:
        {
         $error = wm3UserMessage::checkUserMessageError($w3);
         if(!$error)
          {
           $lastID = wm3UserMessage::saveUserMessage($w3);
           // $msg= message saved... //TODO
           return wm3UserMessage::getUserMessageList($w3,$lastID);
          }
         else return wm3UserMessage::addUserMessage($w3,$error);
         break;
        }
       case WM3_cACTION_SHOW_USER_MESSAGE:
        {
         return wm3UserMessage::renderUserMessage($w3,$w3->getVariable('messageID','get'));
         break;
        }
       default:
        {
         return wm3UserMessage::getUserMessageList($w3);
        }
      }
    }

   public static function getUserMessageList($w3,$currentID = 0,$admin = true)
    {
     // Get messages list (admin and user side)

     // Prepare variables to create the list
     $max_page_items = 12;
     $pg = $w3->getVariable('pg','both');
     $filter = $w3->getVariable('filter','both'); // Search field
	 $search_link = "";
	 $query_filter = "WHERE 1=1";
     if($filter)
      {
       $search_link  = "&filter=$filter";
       $query_filter = "WHERE message LIKE '%$filter%'";
      }
     if($admin)
	  {
	   $search_form_link = WM3_cCONFIG_ADMIN_FILE;
	   $query_filter .= " AND toID='".$w3->getAuthenticateAdminID()."'";
	  }
     else
      {
	   $search_form_link = WM3_cCONFIG_USER_FILE;
       $query_filter .= " AND toID='".$w3->getAuthenticateUserID()."'";
      }
	 $width_message = 70;
	 $columns = 7; $buttons = 3;
     $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     $id_link = "";

     // Do the query and take the total items number
	 $order_by = " ORDER BY ".WM3_cCONFIG_DB_PREFIX."_users_messages.ts DESC";
     $query = "SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_users_messages
                        $query_filter";
     $rs = wm3Sql::sqlQuery($query.$order_by); // Do the query without "limit"
     $total_items = mysql_num_rows($rs);
     if($total_items % $max_page_items == 0 && $pg == (int)($total_items / $max_page_items)) $pg--;
	 if($currentID)
	  {
	   $position = wm3Sql::getRSPosition($rs,'messageID',$currentID);
	   $pg = (int)($position / $max_page_items);
      }
	 if($pg) $extra_link = "&pg=$pg"; else $extra_link = "";
	 if($total_items != 0) $rs = wm3Sql::sqlQuery($query.$order_by." LIMIT ".($pg*$max_page_items).",$max_page_items");

     // Create list header
     $_CONTENTS = array(); $search_form = "";
     //if($admin)
      {
       require(WM3_cPATH_INCLUDE."admin_message_search_form.inc");
       array_push($_CONTENTS,$w3->getWord(603));
      }
     $str = wm3Section::makeHeaderList($w3,$_CONTENTS,$columns,$search_form);

     // Create list caption
     $str .= wm3Section::makeCaptionList($w3,array(0,25,55,20,0),array(-1,1285,31,807),$buttons);

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0) return $str.wm3Section::makeEmptyItemsList($w3,$columns,593);

     // Create list items
     $p = 0;
     while($row = mysql_fetch_object($rs))
      {
       $_CONTENTS = array(); $_WIDTHS = array();
       $link = $base_link.$id_link.$extra_link."&messageID=$row->messageID";
	   array_push($_WIDTHS,0,25,55,20);
       //if($admin)
        {
		 if($row->message_read) $image = "<a href=\"$link&action=".WM3_cACTION_SHOW_USER_MESSAGE."\"><img src=\"".WM3_cPATH_DATA."misc_message_open.png\" width=\"24\" height=\"24\" border=\"0\" alt=\"".$w3->getWord(610)."\" title=\"".$w3->getWord(610)."\"></a>";
		 else                   $image = "<a href=\"$link&action=".WM3_cACTION_SHOW_USER_MESSAGE."\"><img src=\"".WM3_cPATH_DATA."misc_message_close.png\" width=\"24\" height=\"24\" border=\"0\" alt=\"".$w3->getWord(610)."\" title=\"".$w3->getWord(610)."\"></a>";
		 $from    = "<a href=\"$link&action=".WM3_cACTION_SHOW_USER_MESSAGE."\">".wm3User::getUserLogin($row->fromID)."</a>";
		 $subject = "<a href=\"$link&action=".WM3_cACTION_SHOW_USER_MESSAGE."\">$row->subject</a>";
		 $date    = wm3Util::renderDate($w3,$row->ts,$w3->getHomeLanguage());
		 if(!$row->message_read) $date = "<b>$date</b>";
         //$lang_flag = "<img src=\"".WM3_cPATH_DATA.wm3Language::getFlag($row->languageID)."\" width=\"19\" height=\"13\" align=\"middle\">";
         //array_push($_CONTENTS,$lang_flag);
		 array_push($_CONTENTS,$image);
		 array_push($_CONTENTS,$from);
		 array_push($_CONTENTS,$subject);
		 array_push($_CONTENTS,$date);
         // Buttons
         array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_REPLY_USER_MESSAGE,"action_message_reply.png",$w3->getWord(607)));
         if($row->message_read) array_push($_CONTENTS,wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_SET_NOT_READ_USER_MESSAGE,"action_message_close.png",$w3->getWord(608)));
		 else                   array_push($_CONTENTS,"<img src=\"".WM3_cPATH_DATA."action_message_close_inactive.png\" width=\"24\" height=\"24\">");
         array_push($_CONTENTS,wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DELETE_USER_MESSAGE,"action_message_delete.png",$w3->getWord(609),$w3->getWord(774)));
        }
       $str .= wm3Section::makeItemList($w3,$p,$_WIDTHS,$_CONTENTS,$row->messageID==$currentID);
       $p++;
      }

     // Create list bottom
     $bottom_content = "";
     if($total_items > $max_page_items)
      {
	   //if($admin)
	   $bottom_content = wm3Util::makePagesNavigator($total_items,$max_page_items,$pg,$base_link.$id_link.$search_link);
      }
     $str .= wm3Section::makeBottomList($w3,$columns,$bottom_content);

     return $str;
    }

   public static function checkUserMessageError($w3)
    {
     // Check form invalid inputs
     $_FIELD = webmatic3::getPostValueArray(wm3UserMessage::getUserMessageFieldsArray());
     if(!$_FIELD['message']) return 1;
     return 0;
    }

   public static function addUserMessage($w3,$error = 0,$admin = true)
    {
     // Take variables value and set correct form style    
     $_STYLE = wm3Skin::getFormStyleArray(wm3UserMessage::getUserMessageFieldsArray());
     $_FIELD = webmatic3::getPostValueArray(wm3UserMessage::getUserMessageFieldsArray());
     // Fields for paging default value
     $pg = $filter = ""; 
     switch($error)
      {
       case 1: // Empty message 
        {
         $_STYLE['message']        = "class=\"adminFormError\"";
         $_STYLE['adminFormTitle'] = "class=\"adminFormTitleError\"";
         $form_title = $w3->getWord(8);
         break;
        }
       default:
        {
         // Default values for the form
         $_FIELD['toID'] = $w3->getVariable('toID','get'); // Take toID from get (used for user message link in users informations page)

         $_STYLE['adminFormTitle'] = "class=\"adminFormTitle\"";
         $form_title = $w3->getWord(351);
       	}
      }
     $next_action       = WM3_cACTION_SAVE_USER_MESSAGE;
     $next_action_label = $w3->getWord(191);
     if($admin) require(WM3_cPATH_INCLUDE."admin_user_message_form.inc");
	 else       require(WM3_cPATH_INCLUDE."user_user_message_form.inc");
     return $admin_content;
    }

   public static function replyUserMessage($w3,$error = 0,$admin = true)
    {
     // Take variables value from db and set correct form style

	 // Set message as read
	 if($admin) $toID = $w3->getAuthenticateAdminID();
	 else       $toID = $w3->getAuthenticateUserID();
	 wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_users_messages
	                   SET message_read = '".WM3_cENABLED."'
	   			       WHERE messageID = '".$w3->getVariable('messageID','get')."' AND toID = '$toID'");

     if(!$error)
      {
	   if($admin) $toID = $w3->getAuthenticateAdminID();
	   else       $toID = $w3->getAuthenticateUserID();		  
       $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_users_messages
                               WHERE messageID = '".$w3->getVariable('messageID','get')."' AND toID = '$toID'");
       $row = mysql_fetch_object($rs);
	   if(!$row) return wm3Section::makeNotFoundItem($w3);
       $_FIELD = webmatic3::getRowValueArray(wm3UserMessage::getUserMessageFieldsArray(),$row);
       // Default value for fields not in $row object
	   $_FIELD['toID']    = $_FIELD['fromID'];
	   $_FIELD['subject'] = "RE: ".$_FIELD['subject'];
	   $_FIELD['message'] = "\n\n\n---------\n\n".$_FIELD['message'];
	   $_FIELD['message_high_priority'] = WM3_cDISABLED;
      }
     else $_FIELD = webmatic3::getPostValueArray(wm3UserMessage::getUserMessageFieldsArray());

     $_STYLE = wm3Skin::getFormStyleArray(wm3UserMessage::getUserMessageFieldsArray());
     $pg     = $w3->getVariable('pg','both');
     $filter = $w3->getVariable('filter','both');
     switch($error)
      {
       case 1: // No message 
        {
         $_STYLE['message']        = "class=\"adminFormError\"";
         $_STYLE['adminFormTitle'] = "class=\"adminFormTitleError\"";
         $form_title = "Error $error";//$w3->getWord(29);
         break;
        }
       default:
        {
         $_STYLE['adminFormTitle'] = "class=\"adminFormTitle\"";
         $form_title = "Edit message ...."; //$w3->getWord(29);
       	}
      }
     $next_action       = WM3_cACTION_SAVE_USER_MESSAGE;
     $next_action_label = $w3->getWord(29);
     if($admin) require(WM3_cPATH_INCLUDE."admin_user_message_form.inc");
	 else       require(WM3_cPATH_INCLUDE."user_user_message_form.inc");
     return $admin_content;
    }

   public static function saveUserMessage($w3,$admin = true)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3UserMessage::getUserMessageFieldsArray(),WM3_cQUOTE_DB);
	 if($admin) $_FIELD['fromID'] = $w3->getAuthenticateAdminID();
	 else       $_FIELD['fromID'] = $w3->getAuthenticateUserID();
	 $_FIELD['message_read']    = WM3_cDISABLED;
	 $_FIELD['message_replied'] = WM3_cDISABLED;
	 $_FIELD['enabled']         = WM3_cENABLED;
     $_FIELD['ts'] = time();
     wm3Sql::saveAllTableFields('_users_messages',$_FIELD);
     return wm3Sql::getLastInsertID();
    }

   public static function duplicateUserMessage($w3)
    {
     // Take fields from database and duplicate data creating a new row
     $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_messages
                             WHERE messageID = '".$w3->getVariable('messageID','get')."'");
     $row = mysql_fetch_object($rs);
     if($row) // Duplicate only if ID exist
      {
       $_FIELD = webmatic3::getRowValueArray(wm3UserMessage::getUserMessageFieldsArray(),$row);
       $_FIELD['message'] = $w3->getWord(1417).$_FIELD['message'];
       $_FIELD['enabled'] = WM3_cDISABLED;
       $_FIELD['update_ts'] = $_FIELD['ts'] = time();
       wm3Sql::saveAllTableFields('_messages',$_FIELD,array('update_ts'));
       return wm3Sql::getLastInsertID();
      }
    }

   public static function setNotReadUserMessage($messageID)
    {
	 wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_users_messages
	                   SET message_read = '".WM3_cDISABLED."'
					   WHERE messageID = '$messageID'");// AND toID = '".$w3->getAuthenticateUserID()."'");
	}
   
   public static function deleteUserMessage($w3,$messageID,$admin = true)
    {
	 if($admin) $toID = $w3->getAuthenticateAdminID();
	 else       $toID = $w3->getAuthenticateUserID();
	 wm3Sql::sqlQuery("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_users_messages
	                   WHERE messageID = '$messageID' AND toID = '$toID'");
	}

   public static function renderUserMessage($w3,$messageID,$admin = true)
    {
	 // Set message as read
	 if($admin) $toID = $w3->getAuthenticateAdminID();
	 else       $toID = $w3->getAuthenticateUserID();
	 wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_users_messages
	                   SET message_read = '".WM3_cENABLED."'
	   			       WHERE messageID = '$messageID' AND toID = '$toID'");

     // Prepare variables to create the list
	 //$query_filter = "";
     $filter = $w3->getVariable('filter','both'); // Search field
     $pg     = $w3->getVariable('pg','both');
     if($filter) $search_link = "&filter=$filter"; else $search_link = "";
     if($pg) $extra_link = "&pg=$pg"; else $extra_link = "";
     //$pageID = $w3->getVariable('pageID','both');
     //$page_link        = "&pageID=$pageID";
     $search_form_link = WM3_cCONFIG_HOME_FILE."?action=".WM3_cACTION_SHOW_FAQ."$page_link";
     $base_link        = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     //$query_filter .= " AND ".WM3_cCONFIG_DB_PREFIX."_faqs.enabled*".WM3_cCONFIG_DB_PREFIX."_faqs_categories.enabled='".WM3_cENABLED."' AND ".WM3_cCONFIG_DB_PREFIX."_faqs.languageID='".$w3->getHomeLanguage()."'";
     $columns = 2; $buttons = 0;
     $id_link = "";

     // Do the query and take the total items number
     $query = "SELECT *
               FROM   ".WM3_cCONFIG_DB_PREFIX."_users_messages
               WHERE toID = '$toID'";
     $rs = wm3Sql::sqlQuery($query." ORDER BY ts DESC"); // Do the query without "limit"
	 $rs_aux = $rs;
     $total_items = mysql_num_rows($rs);
     if($total_items != 0) $rs = wm3Sql::sqlQuery($query." AND messageID = '$messageID'");

     // Create list header
     $_CONTENTS = array();
	 $_SEP = $w3->getSkinObj()->getSeparator();
     require(WM3_cPATH_INCLUDE."admin_faq_search_form.inc");
     array_push($_CONTENTS,wm3Util::actionButton($base_link.$id_link."&messageID=$messageID&action=".WM3_cACTION_REPLY_USER_MESSAGE,"action_message_reply.png","","",$w3->getWord(607),0,16,16));
	 array_push($_CONTENTS," $_SEP ".wm3Util::actionButton($base_link.$id_link."&messageID=$messageID&action=".WM3_cACTION_DELETE_USER_MESSAGE,"action_message_delete.png","","",$w3->getWord(609),0,16,16));
     $str = wm3Section::makeHeaderList($w3,$_CONTENTS,$columns,$search_form);

     // Create list caption
	 //$str .= wm3Section::makeCaptionList($w3,array(0,100),array(-1,-1),$buttons);

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0) return $str.wm3Section::makeEmptyItemsList($w3,$columns,593);

     // Create item
     $row = mysql_fetch_object($rs);
	 if(!$row) return $str.wm3Section::makeNotFoundItem($w3,$columns,false);
     $link = $base_link.$id_link.$search_link.$extra_link;
     $image = "<img src=\"".WM3_cPATH_DATA."misc_message_open.png\" width=\"24\" height=\"24\">";
	 $from    = "<b>".wm3User::getUserLogin($row->fromID)."</b>";
     $subject = "<b>$row->subject</b>";
	 $date    = wm3Util::renderDate($w3,$row->ts,$w3->getHomeLanguage());	 
     $message = "$image Date: <i>$date</i><br><br>$row->message";
	 $str .= wm3Section::makeItemList($w3,0,array(0,100),array($w3->getWord(403),$from),false);
     $str .= wm3Section::makeItemList($w3,1,array(0,100),array($w3->getWord(31),$subject),false);
	 $str .= wm3Section::makeItemList($w3,0,array(100),array($message),false,"",array(2));

     // Create list bottom
     if($total_items > 1) $bottom_content = wm3Util::makePagesNavigator(0,0,0,$base_link.$id_link.$search_link.$extra_link.$page_link."&action=".WM3_cACTION_SHOW_USER_MESSAGE,$rs_aux,"messageID",$row->messageID);
	 else $bottom_content = "";
     $str .= wm3Section::makeBottomList($w3,$columns,$bottom_content);

     return $str;
	}


   public static function selectTo($name,$userID)
    {
     // Make users select (get administrators and users with user message flag on)
     $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_users
	                         WHERE f3 = '".WM3_cENABLED."' OR admin = '".WM3_cENABLED."'
							 ORDER BY name");
     $str = "<select name=\"$name\">";
	 $str .= wm3Util::inputOption("To all user in the group (4)",0);//TODO to all user (solo per admin)
     while($row = mysql_fetch_object($rs))
      {
       if($row->userID == $userID) $str .= wm3Util::inputOption($row->login,$row->userID,"selected");
       else                        $str .= wm3Util::inputOption($row->login,$row->userID);
      }
     $str .= "</select>";
     return $str;
    }

   public static function makeNotReadUserMessage($w3,$label,$toID)
    {
     // Get the number of subcategory in a category and return a formatted string for output
     $total = wm3Sql::countTable(WM3_cCONFIG_DB_PREFIX."_users_messages","WHERE toID = '$toID' AND message_read = '".WM3_cDISABLED."'");
     if($total == 1) $label = $w3->getWord($label);
     else            $label = $w3->getWord($label+1);
	 return $w3->getWord(888)." $total ".$label;
    }

  }

?>
